#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 679
#define LARGE_STATE_COUNT 375
#define SYMBOL_COUNT 93
#define ALIAS_COUNT 0
#define TOKEN_COUNT 61
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 6
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 14

enum ts_symbol_identifiers {
  sym_semicolon = 1,
  anon_sym_LBRACK = 2,
  anon_sym_RBRACK = 3,
  sym_symbol = 4,
  sym_string = 5,
  sym_any = 6,
  sym_zero = 7,
  sym_boundary = 8,
  sym_symbol_group = 9,
  anon_sym_LPAREN = 10,
  anon_sym_RPAREN = 11,
  anon_sym_BQUOTE = 12,
  anon_sym_COMMA = 13,
  sym_colon = 14,
  sym_complement = 15,
  sym_term_complement = 16,
  sym_contains = 17,
  sym_plus = 18,
  sym_star = 19,
  sym_repeat = 20,
  sym_upper = 21,
  sym_lower = 22,
  sym_reverse = 23,
  sym_inverse = 24,
  sym_ignore = 25,
  sym_ignore_inside = 26,
  sym_union = 27,
  sym_intersect = 28,
  sym_subtract = 29,
  anon_sym__ = 30,
  anon_sym_EQ_GT = 31,
  anon_sym_DASH_GT = 32,
  anon_sym_LT_DASH = 33,
  anon_sym_LPAREN_DASH_GT_RPAREN = 34,
  anon_sym_LPAREN_LT_DASH_RPAREN = 35,
  anon_sym_AT_DASH_GT = 36,
  anon_sym_DASH_GT_AT = 37,
  anon_sym_AT_GT = 38,
  anon_sym_GT_AT = 39,
  anon_sym_LBRACK_DOT = 40,
  anon_sym_DOT_RBRACK = 41,
  anon_sym_DOT_DOT_DOT = 42,
  anon_sym_PIPE_PIPE = 43,
  anon_sym_SLASH_SLASH = 44,
  anon_sym_BSLASH_BSLASH = 45,
  anon_sym_BSLASH_SLASH = 46,
  anon_sym_COMMA_COMMA = 47,
  sym_crossproduct = 48,
  sym_compose = 49,
  sym_comment = 50,
  sym_multichar_symbols_header = 51,
  aux_sym_alphabet_symbol_token1 = 52,
  anon_sym_LEXICON = 53,
  sym_lexicon_start_wrong_case = 54,
  aux_sym_lexicon_token1 = 55,
  sym_gloss = 56,
  anon_sym_LT = 57,
  anon_sym_GT = 58,
  anon_sym_END = 59,
  aux_sym_end_comment_token1 = 60,
  sym_source_file = 61,
  sym_expression = 62,
  sym_optional = 63,
  sym_substitute = 64,
  sym_context = 65,
  sym_context_list = 66,
  sym_restrict = 67,
  sym_arrow = 68,
  sym_simple_replace = 69,
  sym_single_replace = 70,
  sym_mark = 71,
  sym_parallel_replace = 72,
  sym_condition_operators = 73,
  sym_conditional_replace = 74,
  sym_parallel_conditional_replace = 75,
  sym_alphabet_symbol = 76,
  sym_multichar_symbols = 77,
  sym_lexicon_start = 78,
  sym_lexicon = 79,
  sym_lexicon_line = 80,
  sym_lexicon_name = 81,
  sym_lexicon_string = 82,
  sym_regex = 83,
  sym_end_comment = 84,
  aux_sym_source_file_repeat1 = 85,
  aux_sym_optional_repeat1 = 86,
  aux_sym_substitute_repeat1 = 87,
  aux_sym_context_list_repeat1 = 88,
  aux_sym_parallel_replace_repeat1 = 89,
  aux_sym_parallel_conditional_replace_repeat1 = 90,
  aux_sym_multichar_symbols_repeat1 = 91,
  aux_sym_lexicon_repeat1 = 92,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_semicolon] = "semicolon",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_symbol] = "symbol",
  [sym_string] = "string",
  [sym_any] = "any",
  [sym_zero] = "zero",
  [sym_boundary] = "boundary",
  [sym_symbol_group] = "symbol_group",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_COMMA] = ",",
  [sym_colon] = "colon",
  [sym_complement] = "complement",
  [sym_term_complement] = "term_complement",
  [sym_contains] = "contains",
  [sym_plus] = "plus",
  [sym_star] = "star",
  [sym_repeat] = "repeat",
  [sym_upper] = "upper",
  [sym_lower] = "lower",
  [sym_reverse] = "reverse",
  [sym_inverse] = "inverse",
  [sym_ignore] = "ignore",
  [sym_ignore_inside] = "ignore_inside",
  [sym_union] = "union",
  [sym_intersect] = "intersect",
  [sym_subtract] = "subtract",
  [anon_sym__] = "_",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_LPAREN_DASH_GT_RPAREN] = "(->)",
  [anon_sym_LPAREN_LT_DASH_RPAREN] = "(<-)",
  [anon_sym_AT_DASH_GT] = "@->",
  [anon_sym_DASH_GT_AT] = "->@",
  [anon_sym_AT_GT] = "@>",
  [anon_sym_GT_AT] = ">@",
  [anon_sym_LBRACK_DOT] = "[.",
  [anon_sym_DOT_RBRACK] = ".]",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_BSLASH_BSLASH] = "\\\\",
  [anon_sym_BSLASH_SLASH] = "\\/",
  [anon_sym_COMMA_COMMA] = ",,",
  [sym_crossproduct] = "crossproduct",
  [sym_compose] = "compose",
  [sym_comment] = "comment",
  [sym_multichar_symbols_header] = "multichar_symbols_header",
  [aux_sym_alphabet_symbol_token1] = "alphabet_symbol_token1",
  [anon_sym_LEXICON] = "LEXICON",
  [sym_lexicon_start_wrong_case] = "lexicon_start_wrong_case",
  [aux_sym_lexicon_token1] = "lexicon_token1",
  [sym_gloss] = "gloss",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_END] = "END",
  [aux_sym_end_comment_token1] = "end_comment_token1",
  [sym_source_file] = "source_file",
  [sym_expression] = "expression",
  [sym_optional] = "optional",
  [sym_substitute] = "substitute",
  [sym_context] = "context",
  [sym_context_list] = "context_list",
  [sym_restrict] = "restrict",
  [sym_arrow] = "arrow",
  [sym_simple_replace] = "simple_replace",
  [sym_single_replace] = "single_replace",
  [sym_mark] = "mark",
  [sym_parallel_replace] = "parallel_replace",
  [sym_condition_operators] = "condition_operators",
  [sym_conditional_replace] = "conditional_replace",
  [sym_parallel_conditional_replace] = "parallel_conditional_replace",
  [sym_alphabet_symbol] = "alphabet_symbol",
  [sym_multichar_symbols] = "multichar_symbols",
  [sym_lexicon_start] = "lexicon_start",
  [sym_lexicon] = "lexicon",
  [sym_lexicon_line] = "lexicon_line",
  [sym_lexicon_name] = "lexicon_name",
  [sym_lexicon_string] = "lexicon_string",
  [sym_regex] = "regex",
  [sym_end_comment] = "end_comment",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_optional_repeat1] = "optional_repeat1",
  [aux_sym_substitute_repeat1] = "substitute_repeat1",
  [aux_sym_context_list_repeat1] = "context_list_repeat1",
  [aux_sym_parallel_replace_repeat1] = "parallel_replace_repeat1",
  [aux_sym_parallel_conditional_replace_repeat1] = "parallel_conditional_replace_repeat1",
  [aux_sym_multichar_symbols_repeat1] = "multichar_symbols_repeat1",
  [aux_sym_lexicon_repeat1] = "lexicon_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_semicolon] = sym_semicolon,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym_symbol] = sym_symbol,
  [sym_string] = sym_string,
  [sym_any] = sym_any,
  [sym_zero] = sym_zero,
  [sym_boundary] = sym_boundary,
  [sym_symbol_group] = sym_symbol_group,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_colon] = sym_colon,
  [sym_complement] = sym_complement,
  [sym_term_complement] = sym_term_complement,
  [sym_contains] = sym_contains,
  [sym_plus] = sym_plus,
  [sym_star] = sym_star,
  [sym_repeat] = sym_repeat,
  [sym_upper] = sym_upper,
  [sym_lower] = sym_lower,
  [sym_reverse] = sym_reverse,
  [sym_inverse] = sym_inverse,
  [sym_ignore] = sym_ignore,
  [sym_ignore_inside] = sym_ignore_inside,
  [sym_union] = sym_union,
  [sym_intersect] = sym_intersect,
  [sym_subtract] = sym_subtract,
  [anon_sym__] = anon_sym__,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_LPAREN_DASH_GT_RPAREN] = anon_sym_LPAREN_DASH_GT_RPAREN,
  [anon_sym_LPAREN_LT_DASH_RPAREN] = anon_sym_LPAREN_LT_DASH_RPAREN,
  [anon_sym_AT_DASH_GT] = anon_sym_AT_DASH_GT,
  [anon_sym_DASH_GT_AT] = anon_sym_DASH_GT_AT,
  [anon_sym_AT_GT] = anon_sym_AT_GT,
  [anon_sym_GT_AT] = anon_sym_GT_AT,
  [anon_sym_LBRACK_DOT] = anon_sym_LBRACK_DOT,
  [anon_sym_DOT_RBRACK] = anon_sym_DOT_RBRACK,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_BSLASH_BSLASH] = anon_sym_BSLASH_BSLASH,
  [anon_sym_BSLASH_SLASH] = anon_sym_BSLASH_SLASH,
  [anon_sym_COMMA_COMMA] = anon_sym_COMMA_COMMA,
  [sym_crossproduct] = sym_crossproduct,
  [sym_compose] = sym_compose,
  [sym_comment] = sym_comment,
  [sym_multichar_symbols_header] = sym_multichar_symbols_header,
  [aux_sym_alphabet_symbol_token1] = aux_sym_alphabet_symbol_token1,
  [anon_sym_LEXICON] = anon_sym_LEXICON,
  [sym_lexicon_start_wrong_case] = sym_lexicon_start_wrong_case,
  [aux_sym_lexicon_token1] = aux_sym_lexicon_token1,
  [sym_gloss] = sym_gloss,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_END] = anon_sym_END,
  [aux_sym_end_comment_token1] = aux_sym_end_comment_token1,
  [sym_source_file] = sym_source_file,
  [sym_expression] = sym_expression,
  [sym_optional] = sym_optional,
  [sym_substitute] = sym_substitute,
  [sym_context] = sym_context,
  [sym_context_list] = sym_context_list,
  [sym_restrict] = sym_restrict,
  [sym_arrow] = sym_arrow,
  [sym_simple_replace] = sym_simple_replace,
  [sym_single_replace] = sym_single_replace,
  [sym_mark] = sym_mark,
  [sym_parallel_replace] = sym_parallel_replace,
  [sym_condition_operators] = sym_condition_operators,
  [sym_conditional_replace] = sym_conditional_replace,
  [sym_parallel_conditional_replace] = sym_parallel_conditional_replace,
  [sym_alphabet_symbol] = sym_alphabet_symbol,
  [sym_multichar_symbols] = sym_multichar_symbols,
  [sym_lexicon_start] = sym_lexicon_start,
  [sym_lexicon] = sym_lexicon,
  [sym_lexicon_line] = sym_lexicon_line,
  [sym_lexicon_name] = sym_lexicon_name,
  [sym_lexicon_string] = sym_lexicon_string,
  [sym_regex] = sym_regex,
  [sym_end_comment] = sym_end_comment,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_optional_repeat1] = aux_sym_optional_repeat1,
  [aux_sym_substitute_repeat1] = aux_sym_substitute_repeat1,
  [aux_sym_context_list_repeat1] = aux_sym_context_list_repeat1,
  [aux_sym_parallel_replace_repeat1] = aux_sym_parallel_replace_repeat1,
  [aux_sym_parallel_conditional_replace_repeat1] = aux_sym_parallel_conditional_replace_repeat1,
  [aux_sym_multichar_symbols_repeat1] = aux_sym_multichar_symbols_repeat1,
  [aux_sym_lexicon_repeat1] = aux_sym_lexicon_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_semicolon] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_any] = {
    .visible = true,
    .named = true,
  },
  [sym_zero] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_group] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_colon] = {
    .visible = true,
    .named = true,
  },
  [sym_complement] = {
    .visible = true,
    .named = true,
  },
  [sym_term_complement] = {
    .visible = true,
    .named = true,
  },
  [sym_contains] = {
    .visible = true,
    .named = true,
  },
  [sym_plus] = {
    .visible = true,
    .named = true,
  },
  [sym_star] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat] = {
    .visible = true,
    .named = true,
  },
  [sym_upper] = {
    .visible = true,
    .named = true,
  },
  [sym_lower] = {
    .visible = true,
    .named = true,
  },
  [sym_reverse] = {
    .visible = true,
    .named = true,
  },
  [sym_inverse] = {
    .visible = true,
    .named = true,
  },
  [sym_ignore] = {
    .visible = true,
    .named = true,
  },
  [sym_ignore_inside] = {
    .visible = true,
    .named = true,
  },
  [sym_union] = {
    .visible = true,
    .named = true,
  },
  [sym_intersect] = {
    .visible = true,
    .named = true,
  },
  [sym_subtract] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_DASH_GT_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LT_DASH_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_crossproduct] = {
    .visible = true,
    .named = true,
  },
  [sym_compose] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_multichar_symbols_header] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_alphabet_symbol_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LEXICON] = {
    .visible = true,
    .named = false,
  },
  [sym_lexicon_start_wrong_case] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_lexicon_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_gloss] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_end_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_substitute] = {
    .visible = true,
    .named = true,
  },
  [sym_context] = {
    .visible = true,
    .named = true,
  },
  [sym_context_list] = {
    .visible = true,
    .named = true,
  },
  [sym_restrict] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_single_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_mark] = {
    .visible = true,
    .named = true,
  },
  [sym_parallel_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_condition_operators] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_parallel_conditional_replace] = {
    .visible = true,
    .named = true,
  },
  [sym_alphabet_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_multichar_symbols] = {
    .visible = true,
    .named = true,
  },
  [sym_lexicon_start] = {
    .visible = true,
    .named = true,
  },
  [sym_lexicon] = {
    .visible = true,
    .named = true,
  },
  [sym_lexicon_line] = {
    .visible = true,
    .named = true,
  },
  [sym_lexicon_name] = {
    .visible = true,
    .named = true,
  },
  [sym_lexicon_string] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_end_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_optional_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_substitute_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_context_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parallel_replace_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parallel_conditional_replace_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_multichar_symbols_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lexicon_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_continuation = 1,
  field_gloss = 2,
  field_left = 3,
  field_name = 4,
  field_right = 5,
  field_whole = 6,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_continuation] = "continuation",
  [field_gloss] = "gloss",
  [field_left] = "left",
  [field_name] = "name",
  [field_right] = "right",
  [field_whole] = "whole",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 2},
  [5] = {.index = 5, .length = 2},
  [6] = {.index = 7, .length = 2},
  [7] = {.index = 9, .length = 2},
  [8] = {.index = 11, .length = 2},
  [9] = {.index = 13, .length = 3},
  [10] = {.index = 16, .length = 3},
  [11] = {.index = 19, .length = 3},
  [12] = {.index = 22, .length = 3},
  [13] = {.index = 25, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 2},
  [1] =
    {field_continuation, 0},
  [2] =
    {field_continuation, 1},
  [3] =
    {field_continuation, 0},
    {field_gloss, 1},
  [5] =
    {field_continuation, 1},
    {field_whole, 0},
  [7] =
    {field_continuation, 1},
    {field_gloss, 2},
  [9] =
    {field_continuation, 2},
    {field_right, 1},
  [11] =
    {field_continuation, 2},
    {field_left, 0},
  [13] =
    {field_continuation, 1},
    {field_gloss, 2},
    {field_whole, 0},
  [16] =
    {field_continuation, 2},
    {field_gloss, 3},
    {field_right, 1},
  [19] =
    {field_continuation, 2},
    {field_gloss, 3},
    {field_left, 0},
  [22] =
    {field_continuation, 3},
    {field_left, 0},
    {field_right, 2},
  [25] =
    {field_continuation, 3},
    {field_gloss, 4},
    {field_left, 0},
    {field_right, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [2] = sym_lexicon_name,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 8,
  [14] = 8,
  [15] = 8,
  [16] = 16,
  [17] = 5,
  [18] = 8,
  [19] = 2,
  [20] = 3,
  [21] = 4,
  [22] = 22,
  [23] = 6,
  [24] = 24,
  [25] = 7,
  [26] = 26,
  [27] = 8,
  [28] = 9,
  [29] = 8,
  [30] = 8,
  [31] = 16,
  [32] = 2,
  [33] = 3,
  [34] = 4,
  [35] = 5,
  [36] = 6,
  [37] = 7,
  [38] = 9,
  [39] = 10,
  [40] = 11,
  [41] = 12,
  [42] = 10,
  [43] = 16,
  [44] = 11,
  [45] = 12,
  [46] = 3,
  [47] = 26,
  [48] = 24,
  [49] = 16,
  [50] = 22,
  [51] = 2,
  [52] = 52,
  [53] = 4,
  [54] = 5,
  [55] = 6,
  [56] = 7,
  [57] = 9,
  [58] = 10,
  [59] = 11,
  [60] = 12,
  [61] = 22,
  [62] = 24,
  [63] = 26,
  [64] = 8,
  [65] = 52,
  [66] = 2,
  [67] = 3,
  [68] = 4,
  [69] = 5,
  [70] = 6,
  [71] = 7,
  [72] = 8,
  [73] = 9,
  [74] = 10,
  [75] = 11,
  [76] = 12,
  [77] = 8,
  [78] = 8,
  [79] = 16,
  [80] = 22,
  [81] = 24,
  [82] = 26,
  [83] = 4,
  [84] = 16,
  [85] = 26,
  [86] = 10,
  [87] = 2,
  [88] = 3,
  [89] = 3,
  [90] = 5,
  [91] = 6,
  [92] = 7,
  [93] = 9,
  [94] = 10,
  [95] = 11,
  [96] = 12,
  [97] = 11,
  [98] = 12,
  [99] = 8,
  [100] = 16,
  [101] = 4,
  [102] = 6,
  [103] = 22,
  [104] = 8,
  [105] = 24,
  [106] = 8,
  [107] = 5,
  [108] = 7,
  [109] = 8,
  [110] = 9,
  [111] = 8,
  [112] = 2,
  [113] = 6,
  [114] = 10,
  [115] = 12,
  [116] = 11,
  [117] = 2,
  [118] = 3,
  [119] = 4,
  [120] = 5,
  [121] = 6,
  [122] = 7,
  [123] = 9,
  [124] = 10,
  [125] = 11,
  [126] = 12,
  [127] = 16,
  [128] = 22,
  [129] = 24,
  [130] = 26,
  [131] = 9,
  [132] = 2,
  [133] = 3,
  [134] = 4,
  [135] = 5,
  [136] = 22,
  [137] = 24,
  [138] = 26,
  [139] = 52,
  [140] = 7,
  [141] = 52,
  [142] = 7,
  [143] = 12,
  [144] = 26,
  [145] = 11,
  [146] = 22,
  [147] = 24,
  [148] = 26,
  [149] = 10,
  [150] = 52,
  [151] = 9,
  [152] = 2,
  [153] = 3,
  [154] = 4,
  [155] = 5,
  [156] = 6,
  [157] = 22,
  [158] = 24,
  [159] = 2,
  [160] = 6,
  [161] = 22,
  [162] = 7,
  [163] = 3,
  [164] = 26,
  [165] = 10,
  [166] = 4,
  [167] = 52,
  [168] = 12,
  [169] = 5,
  [170] = 24,
  [171] = 5,
  [172] = 24,
  [173] = 9,
  [174] = 11,
  [175] = 4,
  [176] = 52,
  [177] = 6,
  [178] = 7,
  [179] = 2,
  [180] = 3,
  [181] = 10,
  [182] = 12,
  [183] = 7,
  [184] = 22,
  [185] = 10,
  [186] = 11,
  [187] = 26,
  [188] = 3,
  [189] = 4,
  [190] = 52,
  [191] = 24,
  [192] = 192,
  [193] = 12,
  [194] = 5,
  [195] = 195,
  [196] = 6,
  [197] = 197,
  [198] = 9,
  [199] = 2,
  [200] = 200,
  [201] = 201,
  [202] = 26,
  [203] = 10,
  [204] = 200,
  [205] = 12,
  [206] = 201,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 197,
  [212] = 212,
  [213] = 210,
  [214] = 214,
  [215] = 215,
  [216] = 212,
  [217] = 209,
  [218] = 212,
  [219] = 2,
  [220] = 3,
  [221] = 221,
  [222] = 209,
  [223] = 4,
  [224] = 52,
  [225] = 225,
  [226] = 5,
  [227] = 200,
  [228] = 6,
  [229] = 22,
  [230] = 7,
  [231] = 24,
  [232] = 197,
  [233] = 212,
  [234] = 209,
  [235] = 209,
  [236] = 209,
  [237] = 209,
  [238] = 209,
  [239] = 209,
  [240] = 209,
  [241] = 209,
  [242] = 242,
  [243] = 243,
  [244] = 197,
  [245] = 209,
  [246] = 200,
  [247] = 200,
  [248] = 200,
  [249] = 215,
  [250] = 200,
  [251] = 215,
  [252] = 215,
  [253] = 200,
  [254] = 254,
  [255] = 255,
  [256] = 197,
  [257] = 255,
  [258] = 258,
  [259] = 255,
  [260] = 255,
  [261] = 255,
  [262] = 242,
  [263] = 243,
  [264] = 255,
  [265] = 265,
  [266] = 207,
  [267] = 24,
  [268] = 197,
  [269] = 269,
  [270] = 270,
  [271] = 197,
  [272] = 207,
  [273] = 273,
  [274] = 274,
  [275] = 214,
  [276] = 276,
  [277] = 214,
  [278] = 255,
  [279] = 208,
  [280] = 221,
  [281] = 221,
  [282] = 282,
  [283] = 243,
  [284] = 284,
  [285] = 255,
  [286] = 286,
  [287] = 52,
  [288] = 208,
  [289] = 289,
  [290] = 201,
  [291] = 210,
  [292] = 225,
  [293] = 210,
  [294] = 201,
  [295] = 242,
  [296] = 207,
  [297] = 214,
  [298] = 243,
  [299] = 243,
  [300] = 208,
  [301] = 197,
  [302] = 242,
  [303] = 195,
  [304] = 197,
  [305] = 221,
  [306] = 208,
  [307] = 197,
  [308] = 254,
  [309] = 225,
  [310] = 201,
  [311] = 242,
  [312] = 210,
  [313] = 221,
  [314] = 207,
  [315] = 197,
  [316] = 210,
  [317] = 214,
  [318] = 201,
  [319] = 243,
  [320] = 225,
  [321] = 210,
  [322] = 276,
  [323] = 282,
  [324] = 286,
  [325] = 258,
  [326] = 243,
  [327] = 273,
  [328] = 274,
  [329] = 197,
  [330] = 284,
  [331] = 289,
  [332] = 265,
  [333] = 207,
  [334] = 269,
  [335] = 270,
  [336] = 208,
  [337] = 214,
  [338] = 221,
  [339] = 201,
  [340] = 197,
  [341] = 207,
  [342] = 214,
  [343] = 221,
  [344] = 208,
  [345] = 242,
  [346] = 242,
  [347] = 201,
  [348] = 243,
  [349] = 197,
  [350] = 210,
  [351] = 254,
  [352] = 225,
  [353] = 208,
  [354] = 197,
  [355] = 242,
  [356] = 197,
  [357] = 201,
  [358] = 197,
  [359] = 197,
  [360] = 201,
  [361] = 207,
  [362] = 214,
  [363] = 210,
  [364] = 214,
  [365] = 207,
  [366] = 243,
  [367] = 197,
  [368] = 197,
  [369] = 243,
  [370] = 208,
  [371] = 214,
  [372] = 197,
  [373] = 210,
  [374] = 208,
  [375] = 270,
  [376] = 214,
  [377] = 273,
  [378] = 265,
  [379] = 210,
  [380] = 225,
  [381] = 207,
  [382] = 274,
  [383] = 282,
  [384] = 214,
  [385] = 269,
  [386] = 258,
  [387] = 276,
  [388] = 289,
  [389] = 286,
  [390] = 201,
  [391] = 208,
  [392] = 284,
  [393] = 221,
  [394] = 208,
  [395] = 221,
  [396] = 221,
  [397] = 221,
  [398] = 221,
  [399] = 208,
  [400] = 210,
  [401] = 214,
  [402] = 214,
  [403] = 254,
  [404] = 201,
  [405] = 208,
  [406] = 201,
  [407] = 210,
  [408] = 225,
  [409] = 207,
  [410] = 214,
  [411] = 208,
  [412] = 201,
  [413] = 282,
  [414] = 273,
  [415] = 208,
  [416] = 274,
  [417] = 265,
  [418] = 207,
  [419] = 286,
  [420] = 269,
  [421] = 270,
  [422] = 284,
  [423] = 289,
  [424] = 210,
  [425] = 225,
  [426] = 258,
  [427] = 276,
  [428] = 214,
  [429] = 429,
  [430] = 430,
  [431] = 430,
  [432] = 429,
  [433] = 433,
  [434] = 430,
  [435] = 430,
  [436] = 429,
  [437] = 430,
  [438] = 430,
  [439] = 429,
  [440] = 430,
  [441] = 430,
  [442] = 429,
  [443] = 430,
  [444] = 429,
  [445] = 430,
  [446] = 430,
  [447] = 430,
  [448] = 429,
  [449] = 429,
  [450] = 430,
  [451] = 430,
  [452] = 452,
  [453] = 452,
  [454] = 454,
  [455] = 454,
  [456] = 456,
  [457] = 456,
  [458] = 454,
  [459] = 454,
  [460] = 452,
  [461] = 454,
  [462] = 454,
  [463] = 454,
  [464] = 454,
  [465] = 456,
  [466] = 454,
  [467] = 454,
  [468] = 468,
  [469] = 454,
  [470] = 456,
  [471] = 454,
  [472] = 452,
  [473] = 473,
  [474] = 474,
  [475] = 473,
  [476] = 473,
  [477] = 477,
  [478] = 473,
  [479] = 477,
  [480] = 473,
  [481] = 473,
  [482] = 473,
  [483] = 473,
  [484] = 473,
  [485] = 473,
  [486] = 473,
  [487] = 473,
  [488] = 477,
  [489] = 473,
  [490] = 473,
  [491] = 473,
  [492] = 473,
  [493] = 473,
  [494] = 473,
  [495] = 473,
  [496] = 473,
  [497] = 477,
  [498] = 473,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 500,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 505,
  [508] = 505,
  [509] = 509,
  [510] = 505,
  [511] = 509,
  [512] = 505,
  [513] = 505,
  [514] = 514,
  [515] = 504,
  [516] = 502,
  [517] = 504,
  [518] = 505,
  [519] = 502,
  [520] = 509,
  [521] = 506,
  [522] = 499,
  [523] = 505,
  [524] = 509,
  [525] = 499,
  [526] = 500,
  [527] = 500,
  [528] = 501,
  [529] = 499,
  [530] = 505,
  [531] = 509,
  [532] = 500,
  [533] = 500,
  [534] = 502,
  [535] = 505,
  [536] = 504,
  [537] = 500,
  [538] = 502,
  [539] = 504,
  [540] = 509,
  [541] = 499,
  [542] = 500,
  [543] = 506,
  [544] = 505,
  [545] = 509,
  [546] = 509,
  [547] = 509,
  [548] = 548,
  [549] = 500,
  [550] = 506,
  [551] = 505,
  [552] = 499,
  [553] = 499,
  [554] = 500,
  [555] = 506,
  [556] = 500,
  [557] = 548,
  [558] = 499,
  [559] = 509,
  [560] = 502,
  [561] = 506,
  [562] = 499,
  [563] = 500,
  [564] = 509,
  [565] = 504,
  [566] = 501,
  [567] = 509,
  [568] = 502,
  [569] = 499,
  [570] = 502,
  [571] = 500,
  [572] = 548,
  [573] = 505,
  [574] = 506,
  [575] = 504,
  [576] = 504,
  [577] = 548,
  [578] = 506,
  [579] = 548,
  [580] = 499,
  [581] = 548,
  [582] = 548,
  [583] = 514,
  [584] = 509,
  [585] = 505,
  [586] = 499,
  [587] = 509,
  [588] = 499,
  [589] = 500,
  [590] = 548,
  [591] = 514,
  [592] = 514,
  [593] = 499,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 598,
  [600] = 598,
  [601] = 598,
  [602] = 598,
  [603] = 598,
  [604] = 598,
  [605] = 598,
  [606] = 606,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 618,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 627,
  [628] = 628,
  [629] = 629,
  [630] = 627,
  [631] = 631,
  [632] = 632,
  [633] = 633,
  [634] = 627,
  [635] = 632,
  [636] = 632,
  [637] = 632,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 627,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 646,
  [647] = 647,
  [648] = 648,
  [649] = 649,
  [650] = 650,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 654,
  [655] = 655,
  [656] = 656,
  [657] = 657,
  [658] = 656,
  [659] = 659,
  [660] = 656,
  [661] = 661,
  [662] = 661,
  [663] = 661,
  [664] = 664,
  [665] = 665,
  [666] = 666,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 661,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 657,
  [675] = 656,
  [676] = 657,
  [677] = 657,
  [678] = 678,
};

static TSCharacterRange sym_symbol_character_set_1[] = {
  {0, 0x08}, {0x0e, 0x1f}, {'!', '!'}, {'%', '%'}, {'\'', '\''}, {'1', '9'}, {';', ';'}, {'=', '='},
  {'@', 'Z'}, {'_', '_'}, {'a', 'z'}, {0x7f, 0x10ffff},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(76);
      ADVANCE_MAP(
        '!', 139,
        '"', 72,
        '$', 101,
        '&', 116,
        '(', 93,
        ')', 94,
        '*', 103,
        '+', 102,
        ',', 96,
        '-', 117,
        '.', 14,
        '/', 112,
        '0', 89,
        ':', 97,
        ';', 77,
        '<', 163,
        '=', 31,
        '>', 165,
        '?', 88,
        '@', 24,
        'E', 39,
        'L', 37,
        'M', 61,
        '[', 79,
        '\\', 100,
        ']', 80,
        '^', 64,
        '_', 118,
        '`', 95,
        '{', 74,
        '|', 115,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == ';') ADVANCE(77);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == 'E') ADVANCE(146);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (lookahead != 0 &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 139,
        '"', 73,
        '(', 22,
        '-', 30,
        ';', 77,
        '<', 21,
        '>', 34,
        '@', 24,
        'E', 39,
        '[', 78,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == 'E') ADVANCE(39);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(160);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '&', 116,
        '(', 93,
        ')', 94,
        '*', 103,
        '+', 102,
        ',', 96,
        '-', 117,
        '.', 14,
        '/', 112,
        '0', 89,
        ':', 97,
        '<', 21,
        '=', 82,
        '>', 165,
        '?', 88,
        '@', 81,
        'E', 84,
        '[', 79,
        '\\', 100,
        ']', 80,
        '^', 64,
        '`', 95,
        '{', 74,
        '|', 115,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      if (lookahead != 0 &&
          (lookahead < ' ' || '&' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(85);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '&', 116,
        '(', 93,
        ')', 94,
        '*', 103,
        '+', 102,
        ',', 96,
        '-', 117,
        '.', 16,
        '/', 111,
        '0', 89,
        ':', 97,
        '<', 21,
        '=', 82,
        '>', 165,
        '?', 88,
        '@', 81,
        'E', 84,
        '[', 79,
        '\\', 99,
        ']', 80,
        '^', 64,
        '`', 95,
        '{', 74,
        '|', 114,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (lookahead != 0 &&
          (lookahead < ' ' || '&' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(85);
      END_STATE();
    case 6:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '&', 116,
        '(', 93,
        '*', 103,
        '+', 102,
        ',', 96,
        '-', 117,
        '.', 15,
        '/', 112,
        '0', 89,
        ':', 97,
        '<', 21,
        '=', 82,
        '>', 34,
        '?', 88,
        '@', 81,
        'E', 84,
        '[', 79,
        '\\', 100,
        '^', 64,
        '_', 119,
        '`', 95,
        '{', 74,
        '|', 115,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (lookahead != 0 &&
          (lookahead < ' ' || '&' < lookahead) &&
          (lookahead < '(' || '0' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(85);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '&', 116,
        '(', 93,
        '*', 103,
        '+', 102,
        ',', 96,
        '-', 117,
        '.', 17,
        '/', 111,
        '0', 89,
        ':', 97,
        '<', 21,
        '=', 82,
        '>', 34,
        '?', 88,
        '@', 81,
        'E', 84,
        '[', 79,
        '\\', 99,
        '^', 64,
        '_', 119,
        '`', 95,
        '{', 74,
        '|', 114,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (lookahead != 0 &&
          (lookahead < ' ' || '&' < lookahead) &&
          (lookahead < '(' || '0' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(85);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '(', 92,
        ')', 94,
        '.', 13,
        '0', 89,
        '>', 164,
        '?', 88,
        'E', 84,
        '[', 79,
        '\\', 99,
        ']', 80,
        '`', 95,
        '{', 74,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      if (lookahead != 0 &&
          (lookahead < ' ' || '&' < lookahead) &&
          (lookahead < '(' || '0' < lookahead) &&
          lookahead != ':' &&
          lookahead != '<' &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(85);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 86,
        '"', 72,
        '$', 101,
        '%', 70,
        '(', 92,
        '.', 12,
        '0', 89,
        '?', 88,
        'E', 84,
        '[', 79,
        '\\', 99,
        '_', 119,
        '`', 95,
        '{', 74,
        '~', 98,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(87);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(161);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(25);
      END_STATE();
    case 13:
      if (lookahead == '#') ADVANCE(25);
      if (lookahead == '.') ADVANCE(26);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '#', 25,
        '.', 26,
        '/', 27,
        ']', 130,
        'i', 110,
        'l', 108,
        'o', 28,
        'r', 109,
        'u', 107,
        'x', 29,
      );
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '#', 25,
        '.', 26,
        '/', 27,
        'i', 110,
        'l', 108,
        'o', 28,
        'r', 109,
        'u', 107,
        'x', 29,
      );
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '#', 25,
        '/', 27,
        ']', 130,
        'i', 110,
        'l', 108,
        'o', 28,
        'r', 109,
        'u', 107,
        'x', 29,
      );
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '#', 25,
        '/', 27,
        'i', 110,
        'l', 108,
        'o', 28,
        'r', 109,
        'u', 107,
        'x', 29,
      );
      END_STATE();
    case 18:
      if (lookahead == ')') ADVANCE(123);
      END_STATE();
    case 19:
      if (lookahead == ')') ADVANCE(124);
      END_STATE();
    case 20:
      if (lookahead == ',') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(122);
      END_STATE();
    case 22:
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '<') ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == '-') ADVANCE(19);
      END_STATE();
    case 24:
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '>') ADVANCE(127);
      END_STATE();
    case 25:
      if (lookahead == '.') ADVANCE(90);
      END_STATE();
    case 26:
      if (lookahead == '.') ADVANCE(131);
      END_STATE();
    case 27:
      if (lookahead == '.') ADVANCE(113);
      END_STATE();
    case 28:
      if (lookahead == '.') ADVANCE(138);
      END_STATE();
    case 29:
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 30:
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 31:
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 32:
      if (lookahead == '>') ADVANCE(18);
      END_STATE();
    case 33:
      if (lookahead == '>') ADVANCE(125);
      END_STATE();
    case 34:
      if (lookahead == '@') ADVANCE(128);
      END_STATE();
    case 35:
      if (lookahead == 'C') ADVANCE(41);
      END_STATE();
    case 36:
      if (lookahead == 'D') ADVANCE(166);
      END_STATE();
    case 37:
      if (lookahead == 'E') ADVANCE(43);
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 38:
      if (lookahead == 'I') ADVANCE(35);
      END_STATE();
    case 39:
      if (lookahead == 'N') ADVANCE(36);
      END_STATE();
    case 40:
      if (lookahead == 'N') ADVANCE(156);
      END_STATE();
    case 41:
      if (lookahead == 'O') ADVANCE(40);
      END_STATE();
    case 42:
      if (lookahead == 'S') ADVANCE(63);
      END_STATE();
    case 43:
      if (lookahead == 'X') ADVANCE(38);
      END_STATE();
    case 44:
      if (lookahead == '_') ADVANCE(42);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 46:
      if (lookahead == 'b') ADVANCE(57);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(56);
      END_STATE();
    case 48:
      if (lookahead == 'c') ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'h') ADVANCE(45);
      END_STATE();
    case 50:
      if (lookahead == 'i') ADVANCE(47);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(48);
      END_STATE();
    case 52:
      if (lookahead == 'l') ADVANCE(60);
      END_STATE();
    case 53:
      if (lookahead == 'l') ADVANCE(59);
      END_STATE();
    case 54:
      if (lookahead == 'm') ADVANCE(46);
      END_STATE();
    case 55:
      if (lookahead == 'n') ADVANCE(158);
      END_STATE();
    case 56:
      if (lookahead == 'o') ADVANCE(55);
      END_STATE();
    case 57:
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 58:
      if (lookahead == 'r') ADVANCE(44);
      END_STATE();
    case 59:
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 60:
      if (lookahead == 't') ADVANCE(51);
      END_STATE();
    case 61:
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 62:
      if (lookahead == 'x') ADVANCE(50);
      END_STATE();
    case 63:
      if (lookahead == 'y') ADVANCE(54);
      END_STATE();
    case 64:
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '<' ||
          lookahead == '>') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 65:
      if (lookahead == '}') ADVANCE(91);
      if (lookahead != 0) ADVANCE(65);
      END_STATE();
    case 66:
      if (lookahead == '}') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 67:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(20);
      END_STATE();
    case 68:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 69:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(66);
      END_STATE();
    case 70:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(85);
      END_STATE();
    case 71:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(155);
      END_STATE();
    case 72:
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(10);
      END_STATE();
    case 73:
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(11);
      END_STATE();
    case 74:
      if (lookahead != 0 &&
          lookahead != '}') ADVANCE(65);
      END_STATE();
    case 75:
      if (eof) ADVANCE(76);
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == ':') ADVANCE(97);
      if (lookahead == '<') ADVANCE(162);
      if (lookahead == 'E') ADVANCE(146);
      if (lookahead == 'L') ADVANCE(144);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(75);
      if (lookahead != 0 &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_semicolon);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '.') ADVANCE(129);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '>') ADVANCE(127);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == '>') ADVANCE(120);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == 'D') ADVANCE(167);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(70);
      if (lookahead == 'N') ADVANCE(83);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(70);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '%') ADVANCE(140);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ' ||
          ('"' <= lookahead && lookahead <= '&') ||
          ('(' <= lookahead && lookahead <= '0') ||
          lookahead == ':' ||
          lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '?' ||
          ('[' <= lookahead && lookahead <= '^') ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(139);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(86);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_any);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_zero);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_boundary);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_symbol_group);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '<') ADVANCE(23);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_COMMA);
      if (lookahead == ',') ADVANCE(136);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_colon);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_complement);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_term_complement);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_term_complement);
      if (lookahead == '/') ADVANCE(135);
      if (lookahead == '\\') ADVANCE(134);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_contains);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_plus);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_star);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_repeat);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_repeat);
      if (lookahead == ',') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(105);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_repeat);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_upper);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_lower);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_reverse);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_inverse);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_ignore);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_ignore);
      if (lookahead == '/') ADVANCE(133);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_ignore_inside);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_union);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_union);
      if (lookahead == '|') ADVANCE(132);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_intersect);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_subtract);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '%') ADVANCE(70);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (lookahead == '@') ADVANCE(126);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LPAREN_DASH_GT_RPAREN);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_LPAREN_LT_DASH_RPAREN);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AT_DASH_GT);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DASH_GT_AT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_AT_GT);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_GT_AT);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_LBRACK_DOT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_DOT_RBRACK);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_BSLASH_BSLASH);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_BSLASH_SLASH);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_COMMA_COMMA);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_crossproduct);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_compose);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(139);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(86);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_multichar_symbols_header);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'C') ADVANCE(148);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'D') ADVANCE(168);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'E') ADVANCE(149);
      if (lookahead == 'e') ADVANCE(154);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'I') ADVANCE(142);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'N') ADVANCE(143);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'N') ADVANCE(157);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'O') ADVANCE(147);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'X') ADVANCE(145);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'c') ADVANCE(153);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(150);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'n') ADVANCE(159);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'o') ADVANCE(152);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead == 'x') ADVANCE(151);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_alphabet_symbol_token1);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LEXICON);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_LEXICON);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_lexicon_start_wrong_case);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_lexicon_start_wrong_case);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_lexicon_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_gloss);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '-') ADVANCE(122);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '@') ADVANCE(128);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_END);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '%') ADVANCE(70);
      if ((!eof && set_contains(sym_symbol_character_set_1, 12, lookahead))) ADVANCE(85);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '%') ADVANCE(71);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          (lookahead < ' ' || '"' < lookahead) &&
          (lookahead < ':' || '<' < lookahead) &&
          lookahead != '>') ADVANCE(155);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_end_comment_token1);
      if (lookahead == '!') ADVANCE(139);
      if (lookahead == 'E') ADVANCE(172);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(170);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(173);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_end_comment_token1);
      if (lookahead == 'D') ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_end_comment_token1);
      if (lookahead == 'N') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(aux_sym_end_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 4},
  [3] = {.lex_state = 4},
  [4] = {.lex_state = 4},
  [5] = {.lex_state = 4},
  [6] = {.lex_state = 4},
  [7] = {.lex_state = 4},
  [8] = {.lex_state = 4},
  [9] = {.lex_state = 4},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 4},
  [12] = {.lex_state = 4},
  [13] = {.lex_state = 4},
  [14] = {.lex_state = 4},
  [15] = {.lex_state = 4},
  [16] = {.lex_state = 4},
  [17] = {.lex_state = 4},
  [18] = {.lex_state = 4},
  [19] = {.lex_state = 4},
  [20] = {.lex_state = 4},
  [21] = {.lex_state = 4},
  [22] = {.lex_state = 4},
  [23] = {.lex_state = 4},
  [24] = {.lex_state = 4},
  [25] = {.lex_state = 4},
  [26] = {.lex_state = 4},
  [27] = {.lex_state = 4},
  [28] = {.lex_state = 4},
  [29] = {.lex_state = 4},
  [30] = {.lex_state = 4},
  [31] = {.lex_state = 4},
  [32] = {.lex_state = 4},
  [33] = {.lex_state = 4},
  [34] = {.lex_state = 4},
  [35] = {.lex_state = 4},
  [36] = {.lex_state = 4},
  [37] = {.lex_state = 4},
  [38] = {.lex_state = 4},
  [39] = {.lex_state = 4},
  [40] = {.lex_state = 4},
  [41] = {.lex_state = 4},
  [42] = {.lex_state = 4},
  [43] = {.lex_state = 4},
  [44] = {.lex_state = 4},
  [45] = {.lex_state = 4},
  [46] = {.lex_state = 4},
  [47] = {.lex_state = 4},
  [48] = {.lex_state = 4},
  [49] = {.lex_state = 4},
  [50] = {.lex_state = 4},
  [51] = {.lex_state = 4},
  [52] = {.lex_state = 4},
  [53] = {.lex_state = 4},
  [54] = {.lex_state = 4},
  [55] = {.lex_state = 4},
  [56] = {.lex_state = 4},
  [57] = {.lex_state = 4},
  [58] = {.lex_state = 4},
  [59] = {.lex_state = 4},
  [60] = {.lex_state = 4},
  [61] = {.lex_state = 4},
  [62] = {.lex_state = 4},
  [63] = {.lex_state = 4},
  [64] = {.lex_state = 6},
  [65] = {.lex_state = 4},
  [66] = {.lex_state = 6},
  [67] = {.lex_state = 6},
  [68] = {.lex_state = 6},
  [69] = {.lex_state = 6},
  [70] = {.lex_state = 6},
  [71] = {.lex_state = 6},
  [72] = {.lex_state = 6},
  [73] = {.lex_state = 6},
  [74] = {.lex_state = 6},
  [75] = {.lex_state = 6},
  [76] = {.lex_state = 6},
  [77] = {.lex_state = 6},
  [78] = {.lex_state = 6},
  [79] = {.lex_state = 6},
  [80] = {.lex_state = 4},
  [81] = {.lex_state = 4},
  [82] = {.lex_state = 4},
  [83] = {.lex_state = 6},
  [84] = {.lex_state = 6},
  [85] = {.lex_state = 6},
  [86] = {.lex_state = 6},
  [87] = {.lex_state = 6},
  [88] = {.lex_state = 6},
  [89] = {.lex_state = 6},
  [90] = {.lex_state = 6},
  [91] = {.lex_state = 6},
  [92] = {.lex_state = 6},
  [93] = {.lex_state = 6},
  [94] = {.lex_state = 6},
  [95] = {.lex_state = 6},
  [96] = {.lex_state = 6},
  [97] = {.lex_state = 6},
  [98] = {.lex_state = 6},
  [99] = {.lex_state = 6},
  [100] = {.lex_state = 6},
  [101] = {.lex_state = 6},
  [102] = {.lex_state = 6},
  [103] = {.lex_state = 6},
  [104] = {.lex_state = 6},
  [105] = {.lex_state = 6},
  [106] = {.lex_state = 6},
  [107] = {.lex_state = 6},
  [108] = {.lex_state = 6},
  [109] = {.lex_state = 6},
  [110] = {.lex_state = 6},
  [111] = {.lex_state = 6},
  [112] = {.lex_state = 6},
  [113] = {.lex_state = 5},
  [114] = {.lex_state = 5},
  [115] = {.lex_state = 5},
  [116] = {.lex_state = 5},
  [117] = {.lex_state = 6},
  [118] = {.lex_state = 6},
  [119] = {.lex_state = 6},
  [120] = {.lex_state = 6},
  [121] = {.lex_state = 6},
  [122] = {.lex_state = 6},
  [123] = {.lex_state = 6},
  [124] = {.lex_state = 6},
  [125] = {.lex_state = 6},
  [126] = {.lex_state = 6},
  [127] = {.lex_state = 6},
  [128] = {.lex_state = 6},
  [129] = {.lex_state = 6},
  [130] = {.lex_state = 6},
  [131] = {.lex_state = 5},
  [132] = {.lex_state = 5},
  [133] = {.lex_state = 5},
  [134] = {.lex_state = 5},
  [135] = {.lex_state = 5},
  [136] = {.lex_state = 6},
  [137] = {.lex_state = 6},
  [138] = {.lex_state = 6},
  [139] = {.lex_state = 6},
  [140] = {.lex_state = 5},
  [141] = {.lex_state = 6},
  [142] = {.lex_state = 5},
  [143] = {.lex_state = 5},
  [144] = {.lex_state = 5},
  [145] = {.lex_state = 5},
  [146] = {.lex_state = 6},
  [147] = {.lex_state = 6},
  [148] = {.lex_state = 6},
  [149] = {.lex_state = 5},
  [150] = {.lex_state = 5},
  [151] = {.lex_state = 5},
  [152] = {.lex_state = 5},
  [153] = {.lex_state = 5},
  [154] = {.lex_state = 5},
  [155] = {.lex_state = 5},
  [156] = {.lex_state = 5},
  [157] = {.lex_state = 5},
  [158] = {.lex_state = 5},
  [159] = {.lex_state = 5},
  [160] = {.lex_state = 5},
  [161] = {.lex_state = 5},
  [162] = {.lex_state = 5},
  [163] = {.lex_state = 5},
  [164] = {.lex_state = 5},
  [165] = {.lex_state = 5},
  [166] = {.lex_state = 5},
  [167] = {.lex_state = 5},
  [168] = {.lex_state = 5},
  [169] = {.lex_state = 5},
  [170] = {.lex_state = 5},
  [171] = {.lex_state = 7},
  [172] = {.lex_state = 5},
  [173] = {.lex_state = 7},
  [174] = {.lex_state = 7},
  [175] = {.lex_state = 7},
  [176] = {.lex_state = 5},
  [177] = {.lex_state = 7},
  [178] = {.lex_state = 7},
  [179] = {.lex_state = 7},
  [180] = {.lex_state = 7},
  [181] = {.lex_state = 7},
  [182] = {.lex_state = 7},
  [183] = {.lex_state = 7},
  [184] = {.lex_state = 7},
  [185] = {.lex_state = 7},
  [186] = {.lex_state = 7},
  [187] = {.lex_state = 7},
  [188] = {.lex_state = 7},
  [189] = {.lex_state = 7},
  [190] = {.lex_state = 7},
  [191] = {.lex_state = 7},
  [192] = {.lex_state = 5},
  [193] = {.lex_state = 7},
  [194] = {.lex_state = 7},
  [195] = {.lex_state = 4},
  [196] = {.lex_state = 7},
  [197] = {.lex_state = 4},
  [198] = {.lex_state = 7},
  [199] = {.lex_state = 7},
  [200] = {.lex_state = 5},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 7},
  [203] = {.lex_state = 7},
  [204] = {.lex_state = 5},
  [205] = {.lex_state = 7},
  [206] = {.lex_state = 4},
  [207] = {.lex_state = 4},
  [208] = {.lex_state = 4},
  [209] = {.lex_state = 7},
  [210] = {.lex_state = 4},
  [211] = {.lex_state = 4},
  [212] = {.lex_state = 5},
  [213] = {.lex_state = 4},
  [214] = {.lex_state = 4},
  [215] = {.lex_state = 5},
  [216] = {.lex_state = 5},
  [217] = {.lex_state = 7},
  [218] = {.lex_state = 5},
  [219] = {.lex_state = 7},
  [220] = {.lex_state = 7},
  [221] = {.lex_state = 4},
  [222] = {.lex_state = 7},
  [223] = {.lex_state = 7},
  [224] = {.lex_state = 7},
  [225] = {.lex_state = 4},
  [226] = {.lex_state = 7},
  [227] = {.lex_state = 5},
  [228] = {.lex_state = 7},
  [229] = {.lex_state = 7},
  [230] = {.lex_state = 7},
  [231] = {.lex_state = 7},
  [232] = {.lex_state = 4},
  [233] = {.lex_state = 5},
  [234] = {.lex_state = 7},
  [235] = {.lex_state = 7},
  [236] = {.lex_state = 7},
  [237] = {.lex_state = 7},
  [238] = {.lex_state = 7},
  [239] = {.lex_state = 7},
  [240] = {.lex_state = 7},
  [241] = {.lex_state = 7},
  [242] = {.lex_state = 4},
  [243] = {.lex_state = 4},
  [244] = {.lex_state = 4},
  [245] = {.lex_state = 7},
  [246] = {.lex_state = 5},
  [247] = {.lex_state = 5},
  [248] = {.lex_state = 5},
  [249] = {.lex_state = 5},
  [250] = {.lex_state = 5},
  [251] = {.lex_state = 5},
  [252] = {.lex_state = 5},
  [253] = {.lex_state = 5},
  [254] = {.lex_state = 4},
  [255] = {.lex_state = 5},
  [256] = {.lex_state = 4},
  [257] = {.lex_state = 5},
  [258] = {.lex_state = 4},
  [259] = {.lex_state = 5},
  [260] = {.lex_state = 5},
  [261] = {.lex_state = 5},
  [262] = {.lex_state = 4},
  [263] = {.lex_state = 4},
  [264] = {.lex_state = 5},
  [265] = {.lex_state = 4},
  [266] = {.lex_state = 4},
  [267] = {.lex_state = 7},
  [268] = {.lex_state = 4},
  [269] = {.lex_state = 4},
  [270] = {.lex_state = 4},
  [271] = {.lex_state = 4},
  [272] = {.lex_state = 4},
  [273] = {.lex_state = 4},
  [274] = {.lex_state = 4},
  [275] = {.lex_state = 4},
  [276] = {.lex_state = 4},
  [277] = {.lex_state = 4},
  [278] = {.lex_state = 5},
  [279] = {.lex_state = 4},
  [280] = {.lex_state = 4},
  [281] = {.lex_state = 4},
  [282] = {.lex_state = 4},
  [283] = {.lex_state = 4},
  [284] = {.lex_state = 4},
  [285] = {.lex_state = 5},
  [286] = {.lex_state = 4},
  [287] = {.lex_state = 7},
  [288] = {.lex_state = 4},
  [289] = {.lex_state = 4},
  [290] = {.lex_state = 4},
  [291] = {.lex_state = 4},
  [292] = {.lex_state = 4},
  [293] = {.lex_state = 4},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 4},
  [296] = {.lex_state = 4},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 4},
  [299] = {.lex_state = 4},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 6},
  [302] = {.lex_state = 4},
  [303] = {.lex_state = 6},
  [304] = {.lex_state = 6},
  [305] = {.lex_state = 4},
  [306] = {.lex_state = 6},
  [307] = {.lex_state = 6},
  [308] = {.lex_state = 6},
  [309] = {.lex_state = 6},
  [310] = {.lex_state = 6},
  [311] = {.lex_state = 6},
  [312] = {.lex_state = 6},
  [313] = {.lex_state = 6},
  [314] = {.lex_state = 6},
  [315] = {.lex_state = 6},
  [316] = {.lex_state = 6},
  [317] = {.lex_state = 6},
  [318] = {.lex_state = 6},
  [319] = {.lex_state = 6},
  [320] = {.lex_state = 6},
  [321] = {.lex_state = 6},
  [322] = {.lex_state = 6},
  [323] = {.lex_state = 6},
  [324] = {.lex_state = 6},
  [325] = {.lex_state = 6},
  [326] = {.lex_state = 6},
  [327] = {.lex_state = 6},
  [328] = {.lex_state = 6},
  [329] = {.lex_state = 6},
  [330] = {.lex_state = 6},
  [331] = {.lex_state = 6},
  [332] = {.lex_state = 6},
  [333] = {.lex_state = 6},
  [334] = {.lex_state = 6},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 6},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 6},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 6},
  [347] = {.lex_state = 6},
  [348] = {.lex_state = 6},
  [349] = {.lex_state = 6},
  [350] = {.lex_state = 6},
  [351] = {.lex_state = 5},
  [352] = {.lex_state = 5},
  [353] = {.lex_state = 5},
  [354] = {.lex_state = 4},
  [355] = {.lex_state = 6},
  [356] = {.lex_state = 4},
  [357] = {.lex_state = 5},
  [358] = {.lex_state = 4},
  [359] = {.lex_state = 4},
  [360] = {.lex_state = 5},
  [361] = {.lex_state = 6},
  [362] = {.lex_state = 6},
  [363] = {.lex_state = 5},
  [364] = {.lex_state = 5},
  [365] = {.lex_state = 5},
  [366] = {.lex_state = 6},
  [367] = {.lex_state = 4},
  [368] = {.lex_state = 4},
  [369] = {.lex_state = 6},
  [370] = {.lex_state = 6},
  [371] = {.lex_state = 5},
  [372] = {.lex_state = 4},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 5},
  [375] = {.lex_state = 5},
  [376] = {.lex_state = 5},
  [377] = {.lex_state = 5},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 5},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 5},
  [382] = {.lex_state = 5},
  [383] = {.lex_state = 5},
  [384] = {.lex_state = 5},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 5},
  [387] = {.lex_state = 5},
  [388] = {.lex_state = 5},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 5},
  [393] = {.lex_state = 6},
  [394] = {.lex_state = 5},
  [395] = {.lex_state = 4},
  [396] = {.lex_state = 4},
  [397] = {.lex_state = 4},
  [398] = {.lex_state = 4},
  [399] = {.lex_state = 7},
  [400] = {.lex_state = 7},
  [401] = {.lex_state = 7},
  [402] = {.lex_state = 7},
  [403] = {.lex_state = 7},
  [404] = {.lex_state = 7},
  [405] = {.lex_state = 7},
  [406] = {.lex_state = 7},
  [407] = {.lex_state = 7},
  [408] = {.lex_state = 7},
  [409] = {.lex_state = 7},
  [410] = {.lex_state = 7},
  [411] = {.lex_state = 7},
  [412] = {.lex_state = 7},
  [413] = {.lex_state = 7},
  [414] = {.lex_state = 7},
  [415] = {.lex_state = 7},
  [416] = {.lex_state = 7},
  [417] = {.lex_state = 7},
  [418] = {.lex_state = 7},
  [419] = {.lex_state = 7},
  [420] = {.lex_state = 7},
  [421] = {.lex_state = 7},
  [422] = {.lex_state = 7},
  [423] = {.lex_state = 7},
  [424] = {.lex_state = 7},
  [425] = {.lex_state = 7},
  [426] = {.lex_state = 7},
  [427] = {.lex_state = 7},
  [428] = {.lex_state = 7},
  [429] = {.lex_state = 9},
  [430] = {.lex_state = 9},
  [431] = {.lex_state = 9},
  [432] = {.lex_state = 9},
  [433] = {.lex_state = 8},
  [434] = {.lex_state = 9},
  [435] = {.lex_state = 9},
  [436] = {.lex_state = 9},
  [437] = {.lex_state = 9},
  [438] = {.lex_state = 9},
  [439] = {.lex_state = 9},
  [440] = {.lex_state = 9},
  [441] = {.lex_state = 9},
  [442] = {.lex_state = 9},
  [443] = {.lex_state = 9},
  [444] = {.lex_state = 9},
  [445] = {.lex_state = 9},
  [446] = {.lex_state = 9},
  [447] = {.lex_state = 9},
  [448] = {.lex_state = 9},
  [449] = {.lex_state = 9},
  [450] = {.lex_state = 9},
  [451] = {.lex_state = 9},
  [452] = {.lex_state = 8},
  [453] = {.lex_state = 8},
  [454] = {.lex_state = 9},
  [455] = {.lex_state = 9},
  [456] = {.lex_state = 8},
  [457] = {.lex_state = 8},
  [458] = {.lex_state = 9},
  [459] = {.lex_state = 9},
  [460] = {.lex_state = 8},
  [461] = {.lex_state = 9},
  [462] = {.lex_state = 9},
  [463] = {.lex_state = 9},
  [464] = {.lex_state = 9},
  [465] = {.lex_state = 8},
  [466] = {.lex_state = 9},
  [467] = {.lex_state = 9},
  [468] = {.lex_state = 8},
  [469] = {.lex_state = 9},
  [470] = {.lex_state = 8},
  [471] = {.lex_state = 9},
  [472] = {.lex_state = 8},
  [473] = {.lex_state = 8},
  [474] = {.lex_state = 8},
  [475] = {.lex_state = 8},
  [476] = {.lex_state = 8},
  [477] = {.lex_state = 8},
  [478] = {.lex_state = 8},
  [479] = {.lex_state = 8},
  [480] = {.lex_state = 8},
  [481] = {.lex_state = 8},
  [482] = {.lex_state = 8},
  [483] = {.lex_state = 8},
  [484] = {.lex_state = 8},
  [485] = {.lex_state = 8},
  [486] = {.lex_state = 8},
  [487] = {.lex_state = 8},
  [488] = {.lex_state = 8},
  [489] = {.lex_state = 8},
  [490] = {.lex_state = 8},
  [491] = {.lex_state = 8},
  [492] = {.lex_state = 8},
  [493] = {.lex_state = 8},
  [494] = {.lex_state = 8},
  [495] = {.lex_state = 8},
  [496] = {.lex_state = 8},
  [497] = {.lex_state = 8},
  [498] = {.lex_state = 8},
  [499] = {.lex_state = 8},
  [500] = {.lex_state = 8},
  [501] = {.lex_state = 8},
  [502] = {.lex_state = 8},
  [503] = {.lex_state = 8},
  [504] = {.lex_state = 8},
  [505] = {.lex_state = 8},
  [506] = {.lex_state = 8},
  [507] = {.lex_state = 8},
  [508] = {.lex_state = 8},
  [509] = {.lex_state = 8},
  [510] = {.lex_state = 8},
  [511] = {.lex_state = 8},
  [512] = {.lex_state = 8},
  [513] = {.lex_state = 8},
  [514] = {.lex_state = 8},
  [515] = {.lex_state = 8},
  [516] = {.lex_state = 8},
  [517] = {.lex_state = 8},
  [518] = {.lex_state = 8},
  [519] = {.lex_state = 8},
  [520] = {.lex_state = 8},
  [521] = {.lex_state = 8},
  [522] = {.lex_state = 8},
  [523] = {.lex_state = 8},
  [524] = {.lex_state = 8},
  [525] = {.lex_state = 8},
  [526] = {.lex_state = 8},
  [527] = {.lex_state = 8},
  [528] = {.lex_state = 8},
  [529] = {.lex_state = 8},
  [530] = {.lex_state = 8},
  [531] = {.lex_state = 8},
  [532] = {.lex_state = 8},
  [533] = {.lex_state = 8},
  [534] = {.lex_state = 8},
  [535] = {.lex_state = 8},
  [536] = {.lex_state = 8},
  [537] = {.lex_state = 8},
  [538] = {.lex_state = 8},
  [539] = {.lex_state = 8},
  [540] = {.lex_state = 8},
  [541] = {.lex_state = 8},
  [542] = {.lex_state = 8},
  [543] = {.lex_state = 8},
  [544] = {.lex_state = 8},
  [545] = {.lex_state = 8},
  [546] = {.lex_state = 8},
  [547] = {.lex_state = 8},
  [548] = {.lex_state = 8},
  [549] = {.lex_state = 8},
  [550] = {.lex_state = 8},
  [551] = {.lex_state = 8},
  [552] = {.lex_state = 8},
  [553] = {.lex_state = 8},
  [554] = {.lex_state = 8},
  [555] = {.lex_state = 8},
  [556] = {.lex_state = 8},
  [557] = {.lex_state = 8},
  [558] = {.lex_state = 8},
  [559] = {.lex_state = 8},
  [560] = {.lex_state = 8},
  [561] = {.lex_state = 8},
  [562] = {.lex_state = 8},
  [563] = {.lex_state = 8},
  [564] = {.lex_state = 8},
  [565] = {.lex_state = 8},
  [566] = {.lex_state = 8},
  [567] = {.lex_state = 8},
  [568] = {.lex_state = 8},
  [569] = {.lex_state = 8},
  [570] = {.lex_state = 8},
  [571] = {.lex_state = 8},
  [572] = {.lex_state = 8},
  [573] = {.lex_state = 8},
  [574] = {.lex_state = 8},
  [575] = {.lex_state = 8},
  [576] = {.lex_state = 8},
  [577] = {.lex_state = 8},
  [578] = {.lex_state = 8},
  [579] = {.lex_state = 8},
  [580] = {.lex_state = 8},
  [581] = {.lex_state = 8},
  [582] = {.lex_state = 8},
  [583] = {.lex_state = 8},
  [584] = {.lex_state = 8},
  [585] = {.lex_state = 8},
  [586] = {.lex_state = 8},
  [587] = {.lex_state = 8},
  [588] = {.lex_state = 8},
  [589] = {.lex_state = 8},
  [590] = {.lex_state = 8},
  [591] = {.lex_state = 8},
  [592] = {.lex_state = 8},
  [593] = {.lex_state = 8},
  [594] = {.lex_state = 8},
  [595] = {.lex_state = 9},
  [596] = {.lex_state = 75},
  [597] = {.lex_state = 75},
  [598] = {.lex_state = 2},
  [599] = {.lex_state = 2},
  [600] = {.lex_state = 2},
  [601] = {.lex_state = 2},
  [602] = {.lex_state = 2},
  [603] = {.lex_state = 2},
  [604] = {.lex_state = 2},
  [605] = {.lex_state = 2},
  [606] = {.lex_state = 1},
  [607] = {.lex_state = 75},
  [608] = {.lex_state = 75},
  [609] = {.lex_state = 75},
  [610] = {.lex_state = 75},
  [611] = {.lex_state = 75},
  [612] = {.lex_state = 75},
  [613] = {.lex_state = 75},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 75},
  [616] = {.lex_state = 75},
  [617] = {.lex_state = 75},
  [618] = {.lex_state = 75},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 75},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 75},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 75},
  [625] = {.lex_state = 75},
  [626] = {.lex_state = 1},
  [627] = {.lex_state = 8},
  [628] = {.lex_state = 1},
  [629] = {.lex_state = 1},
  [630] = {.lex_state = 8},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 8},
  [633] = {.lex_state = 1},
  [634] = {.lex_state = 8},
  [635] = {.lex_state = 8},
  [636] = {.lex_state = 8},
  [637] = {.lex_state = 8},
  [638] = {.lex_state = 1},
  [639] = {.lex_state = 75},
  [640] = {.lex_state = 8},
  [641] = {.lex_state = 8},
  [642] = {.lex_state = 75},
  [643] = {.lex_state = 1},
  [644] = {.lex_state = 2},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 2},
  [647] = {.lex_state = 8},
  [648] = {.lex_state = 1},
  [649] = {.lex_state = 2},
  [650] = {.lex_state = 2},
  [651] = {.lex_state = 2},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 1},
  [654] = {.lex_state = 170},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 2},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 3},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 8},
  [662] = {.lex_state = 8},
  [663] = {.lex_state = 8},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 1},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 8},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 1},
  [673] = {.lex_state = 3},
  [674] = {.lex_state = 2},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 2},
  [677] = {.lex_state = 2},
  [678] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_end_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_semicolon] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym_any] = ACTIONS(1),
    [sym_zero] = ACTIONS(1),
    [sym_boundary] = ACTIONS(1),
    [sym_symbol_group] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [sym_colon] = ACTIONS(1),
    [sym_complement] = ACTIONS(1),
    [sym_term_complement] = ACTIONS(1),
    [sym_contains] = ACTIONS(1),
    [sym_plus] = ACTIONS(1),
    [sym_star] = ACTIONS(1),
    [sym_repeat] = ACTIONS(1),
    [sym_upper] = ACTIONS(1),
    [sym_lower] = ACTIONS(1),
    [sym_reverse] = ACTIONS(1),
    [sym_inverse] = ACTIONS(1),
    [sym_ignore] = ACTIONS(1),
    [sym_ignore_inside] = ACTIONS(1),
    [sym_union] = ACTIONS(1),
    [sym_intersect] = ACTIONS(1),
    [sym_subtract] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(1),
    [anon_sym_AT_DASH_GT] = ACTIONS(1),
    [anon_sym_DASH_GT_AT] = ACTIONS(1),
    [anon_sym_AT_GT] = ACTIONS(1),
    [anon_sym_GT_AT] = ACTIONS(1),
    [anon_sym_LBRACK_DOT] = ACTIONS(1),
    [anon_sym_DOT_RBRACK] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(1),
    [anon_sym_BSLASH_SLASH] = ACTIONS(1),
    [anon_sym_COMMA_COMMA] = ACTIONS(1),
    [sym_crossproduct] = ACTIONS(1),
    [sym_compose] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_multichar_symbols_header] = ACTIONS(1),
    [anon_sym_LEXICON] = ACTIONS(1),
    [sym_lexicon_start_wrong_case] = ACTIONS(1),
    [sym_gloss] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(5),
  },
  [1] = {
    [sym_source_file] = STATE(664),
    [sym_multichar_symbols] = STATE(623),
    [sym_lexicon_start] = STATE(659),
    [sym_lexicon] = STATE(631),
    [sym_end_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(621),
    [sym_comment] = ACTIONS(3),
    [sym_multichar_symbols_header] = ACTIONS(7),
    [anon_sym_LEXICON] = ACTIONS(9),
    [sym_lexicon_start_wrong_case] = ACTIONS(11),
    [anon_sym_END] = ACTIONS(5),
  },
  [2] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(2),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [3] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(3),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [4] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(4),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [5] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(5),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [6] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(6),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [7] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(7),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(53),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [8] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(8),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [9] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(9),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [10] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(10),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [11] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(11),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [12] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(12),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [13] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(13),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(79),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [14] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(14),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(81),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [15] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(15),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(83),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [16] = {
    [sym_expression] = STATE(3),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(482),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(16),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(85),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(87),
    [sym_colon] = ACTIONS(17),
    [sym_complement] = ACTIONS(43),
    [sym_term_complement] = ACTIONS(45),
    [sym_contains] = ACTIONS(43),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(25),
    [sym_ignore_inside] = ACTIONS(27),
    [sym_union] = ACTIONS(49),
    [sym_intersect] = ACTIONS(51),
    [sym_subtract] = ACTIONS(49),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(47),
    [anon_sym_DOT_RBRACK] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [anon_sym_COMMA_COMMA] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_END] = ACTIONS(21),
  },
  [17] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(17),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [18] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(18),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [19] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(19),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [20] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(20),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [21] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(21),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [22] = {
    [sym_expression] = STATE(9),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(22),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [23] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(23),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [24] = {
    [sym_expression] = STATE(10),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(24),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [25] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(25),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(115),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [26] = {
    [sym_expression] = STATE(11),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(197),
    [sym_single_replace] = STATE(197),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(201),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(26),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [27] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(27),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [28] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(28),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [29] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(29),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(83),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [30] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(30),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(59),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(59),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(59),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(117),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(61),
    [anon_sym_END] = ACTIONS(21),
  },
  [31] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(31),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(85),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(85),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(85),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_END] = ACTIONS(21),
  },
  [32] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(32),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [33] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(33),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [34] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(34),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [35] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(35),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [36] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(36),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [37] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(37),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(135),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [38] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(38),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [39] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(39),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [40] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(40),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [41] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(41),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [42] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(42),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [43] = {
    [sym_expression] = STATE(33),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(483),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(43),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(85),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(87),
    [sym_colon] = ACTIONS(119),
    [sym_complement] = ACTIONS(125),
    [sym_term_complement] = ACTIONS(127),
    [sym_contains] = ACTIONS(125),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(121),
    [sym_ignore_inside] = ACTIONS(123),
    [sym_union] = ACTIONS(131),
    [sym_intersect] = ACTIONS(133),
    [sym_subtract] = ACTIONS(131),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [anon_sym_COMMA_COMMA] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_END] = ACTIONS(21),
  },
  [44] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(44),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [45] = {
    [sym_expression] = STATE(20),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(487),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(45),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(89),
    [sym_complement] = ACTIONS(91),
    [sym_term_complement] = ACTIONS(93),
    [sym_contains] = ACTIONS(91),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(95),
    [sym_ignore_inside] = ACTIONS(97),
    [sym_union] = ACTIONS(99),
    [sym_intersect] = ACTIONS(101),
    [sym_subtract] = ACTIONS(99),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(103),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [46] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(46),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [47] = {
    [sym_expression] = STATE(44),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(47),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [48] = {
    [sym_expression] = STATE(42),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(48),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [49] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(49),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(85),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(85),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(85),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(87),
    [anon_sym_END] = ACTIONS(21),
  },
  [50] = {
    [sym_expression] = STATE(28),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(211),
    [sym_single_replace] = STATE(211),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(221),
    [sym_conditional_replace] = STATE(206),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(50),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [51] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(51),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [52] = {
    [sym_expression] = STATE(41),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(52),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(69),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(69),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [53] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(53),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [54] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(54),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [55] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(55),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [56] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(56),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(153),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [57] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(57),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [58] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(58),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [59] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(59),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [60] = {
    [sym_expression] = STATE(46),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_arrow] = STATE(489),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(60),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(35),
    [sym_string] = ACTIONS(37),
    [sym_any] = ACTIONS(37),
    [sym_zero] = ACTIONS(37),
    [sym_boundary] = ACTIONS(37),
    [sym_symbol_group] = ACTIONS(37),
    [anon_sym_LPAREN] = ACTIONS(39),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(41),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(137),
    [sym_complement] = ACTIONS(143),
    [sym_term_complement] = ACTIONS(145),
    [sym_contains] = ACTIONS(143),
    [sym_plus] = ACTIONS(23),
    [sym_star] = ACTIONS(23),
    [sym_repeat] = ACTIONS(23),
    [sym_upper] = ACTIONS(23),
    [sym_lower] = ACTIONS(23),
    [sym_reverse] = ACTIONS(23),
    [sym_inverse] = ACTIONS(23),
    [sym_ignore] = ACTIONS(139),
    [sym_ignore_inside] = ACTIONS(141),
    [sym_union] = ACTIONS(147),
    [sym_intersect] = ACTIONS(149),
    [sym_subtract] = ACTIONS(147),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [61] = {
    [sym_expression] = STATE(38),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(61),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [62] = {
    [sym_expression] = STATE(39),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(62),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [63] = {
    [sym_expression] = STATE(40),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(244),
    [sym_single_replace] = STATE(244),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(294),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(63),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [64] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(64),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(183),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [65] = {
    [sym_expression] = STATE(60),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(65),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(69),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(69),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [66] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(66),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [67] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(67),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [68] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(68),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [69] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(69),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [70] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(70),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [71] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(71),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(185),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [72] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(72),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [73] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(73),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [74] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(74),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [75] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(75),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [76] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(76),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [77] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(77),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(187),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [78] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(78),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(61),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(83),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [anon_sym_COMMA_COMMA] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [79] = {
    [sym_expression] = STATE(67),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(495),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(79),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(87),
    [sym_colon] = ACTIONS(165),
    [sym_complement] = ACTIONS(167),
    [sym_term_complement] = ACTIONS(169),
    [sym_contains] = ACTIONS(167),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(173),
    [sym_ignore_inside] = ACTIONS(175),
    [sym_union] = ACTIONS(177),
    [sym_intersect] = ACTIONS(179),
    [sym_subtract] = ACTIONS(177),
    [anon_sym__] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(181),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [anon_sym_COMMA_COMMA] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [80] = {
    [sym_expression] = STATE(57),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(80),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [81] = {
    [sym_expression] = STATE(58),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(81),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [82] = {
    [sym_expression] = STATE(59),
    [sym_optional] = STATE(276),
    [sym_substitute] = STATE(276),
    [sym_restrict] = STATE(276),
    [sym_simple_replace] = STATE(256),
    [sym_single_replace] = STATE(256),
    [sym_mark] = STATE(276),
    [sym_parallel_replace] = STATE(281),
    [sym_conditional_replace] = STATE(290),
    [sym_parallel_conditional_replace] = STATE(276),
    [sym_end_comment] = STATE(82),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [83] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(83),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [84] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(84),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(85),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(85),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [85] = {
    [sym_expression] = STATE(75),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(85),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [86] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(86),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [87] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(87),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [88] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(88),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [89] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(89),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [90] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(90),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [91] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(91),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [92] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(92),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(221),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [93] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(93),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [94] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(94),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [95] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(95),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [96] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(96),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [97] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(97),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(71),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [98] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(98),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(75),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [99] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(99),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(83),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [100] = {
    [sym_expression] = STATE(88),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(492),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(100),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(87),
    [sym_colon] = ACTIONS(205),
    [sym_complement] = ACTIONS(211),
    [sym_term_complement] = ACTIONS(213),
    [sym_contains] = ACTIONS(211),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(207),
    [sym_ignore_inside] = ACTIONS(209),
    [sym_union] = ACTIONS(217),
    [sym_intersect] = ACTIONS(219),
    [sym_subtract] = ACTIONS(217),
    [anon_sym__] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [anon_sym_COMMA_COMMA] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [101] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(101),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [102] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(102),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [103] = {
    [sym_expression] = STATE(73),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(103),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [104] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(104),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(223),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [105] = {
    [sym_expression] = STATE(74),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(301),
    [sym_single_replace] = STATE(301),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(310),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(105),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [106] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(106),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(225),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [107] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(107),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [108] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(108),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(227),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [109] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(109),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(59),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [110] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(110),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [111] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(111),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(59),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(191),
    [sym_term_complement] = ACTIONS(193),
    [sym_contains] = ACTIONS(191),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(195),
    [sym_ignore_inside] = ACTIONS(197),
    [sym_union] = ACTIONS(199),
    [sym_intersect] = ACTIONS(201),
    [sym_subtract] = ACTIONS(199),
    [anon_sym__] = ACTIONS(61),
    [anon_sym_EQ_GT] = ACTIONS(59),
    [anon_sym_DASH_GT] = ACTIONS(61),
    [anon_sym_LT_DASH] = ACTIONS(59),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(59),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(59),
    [anon_sym_AT_DASH_GT] = ACTIONS(59),
    [anon_sym_DASH_GT_AT] = ACTIONS(59),
    [anon_sym_AT_GT] = ACTIONS(59),
    [anon_sym_GT_AT] = ACTIONS(59),
    [anon_sym_LBRACK_DOT] = ACTIONS(203),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(229),
    [anon_sym_PIPE_PIPE] = ACTIONS(59),
    [anon_sym_SLASH_SLASH] = ACTIONS(59),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(59),
    [anon_sym_BSLASH_SLASH] = ACTIONS(59),
    [sym_crossproduct] = ACTIONS(59),
    [sym_compose] = ACTIONS(59),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [112] = {
    [sym_expression] = STATE(89),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(475),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(112),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(189),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [113] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(113),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [114] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(114),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(249),
    [sym_intersect] = ACTIONS(249),
    [sym_subtract] = ACTIONS(251),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [115] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(115),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(249),
    [sym_intersect] = ACTIONS(249),
    [sym_subtract] = ACTIONS(251),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [116] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(116),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(249),
    [sym_intersect] = ACTIONS(249),
    [sym_subtract] = ACTIONS(251),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [117] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(117),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [118] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(118),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [119] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(119),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [120] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(120),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [121] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(121),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [122] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(122),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(269),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [123] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(123),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [124] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(124),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [125] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(125),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(71),
    [anon_sym_SLASH_SLASH] = ACTIONS(71),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(71),
    [anon_sym_BSLASH_SLASH] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [126] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(126),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(75),
    [anon_sym_SLASH_SLASH] = ACTIONS(75),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(75),
    [anon_sym_BSLASH_SLASH] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [127] = {
    [sym_expression] = STATE(118),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_arrow] = STATE(485),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(127),
    [anon_sym_LBRACK] = ACTIONS(155),
    [sym_symbol] = ACTIONS(157),
    [sym_string] = ACTIONS(159),
    [sym_any] = ACTIONS(159),
    [sym_zero] = ACTIONS(159),
    [sym_boundary] = ACTIONS(159),
    [sym_symbol_group] = ACTIONS(159),
    [anon_sym_LPAREN] = ACTIONS(161),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_COMMA] = ACTIONS(85),
    [sym_colon] = ACTIONS(253),
    [sym_complement] = ACTIONS(259),
    [sym_term_complement] = ACTIONS(261),
    [sym_contains] = ACTIONS(259),
    [sym_plus] = ACTIONS(171),
    [sym_star] = ACTIONS(171),
    [sym_repeat] = ACTIONS(171),
    [sym_upper] = ACTIONS(171),
    [sym_lower] = ACTIONS(171),
    [sym_reverse] = ACTIONS(171),
    [sym_inverse] = ACTIONS(171),
    [sym_ignore] = ACTIONS(255),
    [sym_ignore_inside] = ACTIONS(257),
    [sym_union] = ACTIONS(265),
    [sym_intersect] = ACTIONS(267),
    [sym_subtract] = ACTIONS(265),
    [anon_sym__] = ACTIONS(87),
    [anon_sym_EQ_GT] = ACTIONS(85),
    [anon_sym_DASH_GT] = ACTIONS(87),
    [anon_sym_LT_DASH] = ACTIONS(85),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(85),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(85),
    [anon_sym_AT_DASH_GT] = ACTIONS(85),
    [anon_sym_DASH_GT_AT] = ACTIONS(85),
    [anon_sym_AT_GT] = ACTIONS(85),
    [anon_sym_GT_AT] = ACTIONS(85),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [anon_sym_PIPE_PIPE] = ACTIONS(85),
    [anon_sym_SLASH_SLASH] = ACTIONS(85),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(85),
    [anon_sym_BSLASH_SLASH] = ACTIONS(85),
    [sym_crossproduct] = ACTIONS(85),
    [sym_compose] = ACTIONS(85),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [128] = {
    [sym_expression] = STATE(110),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(128),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [129] = {
    [sym_expression] = STATE(86),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(129),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [130] = {
    [sym_expression] = STATE(97),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(304),
    [sym_single_replace] = STATE(304),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(313),
    [sym_conditional_replace] = STATE(318),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(130),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [131] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(131),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(249),
    [sym_intersect] = ACTIONS(249),
    [sym_subtract] = ACTIONS(251),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [132] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(132),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [133] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(133),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [134] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(134),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [135] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(135),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [136] = {
    [sym_expression] = STATE(93),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(136),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [137] = {
    [sym_expression] = STATE(94),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(137),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [138] = {
    [sym_expression] = STATE(95),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(138),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [139] = {
    [sym_expression] = STATE(96),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(315),
    [sym_single_replace] = STATE(315),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(339),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(139),
    [anon_sym_LBRACK] = ACTIONS(69),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(69),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(69),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [140] = {
    [sym_expression] = STATE(133),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(478),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(140),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(241),
    [sym_complement] = ACTIONS(243),
    [sym_term_complement] = ACTIONS(243),
    [sym_contains] = ACTIONS(243),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(247),
    [sym_ignore_inside] = ACTIONS(247),
    [sym_union] = ACTIONS(249),
    [sym_intersect] = ACTIONS(249),
    [sym_subtract] = ACTIONS(251),
    [anon_sym_EQ_GT] = ACTIONS(271),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(129),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [141] = {
    [sym_expression] = STATE(126),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(141),
    [anon_sym_LBRACK] = ACTIONS(69),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(69),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(69),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(69),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_PIPE_PIPE] = ACTIONS(67),
    [anon_sym_SLASH_SLASH] = ACTIONS(67),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(67),
    [anon_sym_BSLASH_SLASH] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [142] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(142),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(283),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [143] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(143),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [144] = {
    [sym_expression] = STATE(116),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(144),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(63),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(63),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(63),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [145] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(145),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(71),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(71),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(73),
    [anon_sym_END] = ACTIONS(21),
  },
  [146] = {
    [sym_expression] = STATE(123),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(146),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(107),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(107),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(107),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_PIPE_PIPE] = ACTIONS(109),
    [anon_sym_SLASH_SLASH] = ACTIONS(109),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(109),
    [anon_sym_BSLASH_SLASH] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [147] = {
    [sym_expression] = STATE(124),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(147),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(111),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(111),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(111),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_PIPE_PIPE] = ACTIONS(113),
    [anon_sym_SLASH_SLASH] = ACTIONS(113),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(113),
    [anon_sym_BSLASH_SLASH] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [148] = {
    [sym_expression] = STATE(125),
    [sym_optional] = STATE(322),
    [sym_substitute] = STATE(322),
    [sym_restrict] = STATE(322),
    [sym_simple_replace] = STATE(340),
    [sym_single_replace] = STATE(340),
    [sym_mark] = STATE(322),
    [sym_parallel_replace] = STATE(343),
    [sym_conditional_replace] = STATE(347),
    [sym_parallel_conditional_replace] = STATE(322),
    [sym_end_comment] = STATE(148),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(65),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(65),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(65),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_PIPE_PIPE] = ACTIONS(63),
    [anon_sym_SLASH_SLASH] = ACTIONS(63),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(63),
    [anon_sym_BSLASH_SLASH] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [149] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(149),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [150] = {
    [sym_expression] = STATE(115),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(150),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [151] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(151),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [152] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(152),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [153] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(153),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [154] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(154),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [155] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(155),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [156] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(156),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [157] = {
    [sym_expression] = STATE(131),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(157),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(109),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(109),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(109),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [158] = {
    [sym_expression] = STATE(114),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(232),
    [sym_single_replace] = STATE(232),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(357),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(158),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [159] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(159),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [160] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(160),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [161] = {
    [sym_expression] = STATE(151),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(161),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_RBRACK] = ACTIONS(109),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_RPAREN] = ACTIONS(109),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(109),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(109),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(109),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_DOT_RBRACK] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(107),
    [anon_sym_END] = ACTIONS(21),
  },
  [162] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(162),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [163] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(163),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [164] = {
    [sym_expression] = STATE(145),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(164),
    [anon_sym_LBRACK] = ACTIONS(65),
    [anon_sym_RBRACK] = ACTIONS(63),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_RPAREN] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(63),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(63),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(63),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_DOT_RBRACK] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(65),
    [anon_sym_END] = ACTIONS(21),
  },
  [165] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(165),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [166] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(166),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [167] = {
    [sym_expression] = STATE(143),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(167),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [168] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(168),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(75),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(75),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(77),
    [anon_sym_END] = ACTIONS(21),
  },
  [169] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(169),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [170] = {
    [sym_expression] = STATE(149),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(170),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [171] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(171),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [172] = {
    [sym_expression] = STATE(165),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(172),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(113),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_DOT_RBRACK] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(111),
    [anon_sym_END] = ACTIONS(21),
  },
  [173] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(173),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(315),
    [sym_intersect] = ACTIONS(315),
    [sym_subtract] = ACTIONS(317),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [174] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(174),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(73),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(315),
    [sym_intersect] = ACTIONS(315),
    [sym_subtract] = ACTIONS(317),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(71),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [175] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(175),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [176] = {
    [sym_expression] = STATE(168),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(176),
    [anon_sym_LBRACK] = ACTIONS(69),
    [anon_sym_RBRACK] = ACTIONS(67),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_RPAREN] = ACTIONS(67),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_DOT_RBRACK] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(69),
    [anon_sym_END] = ACTIONS(21),
  },
  [177] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(177),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [178] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(178),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(315),
    [sym_intersect] = ACTIONS(315),
    [sym_subtract] = ACTIONS(317),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(319),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [179] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(179),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [180] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(180),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [181] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(181),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(315),
    [sym_intersect] = ACTIONS(315),
    [sym_subtract] = ACTIONS(317),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [182] = {
    [sym_expression] = STATE(180),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(496),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(182),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(77),
    [sym_colon] = ACTIONS(297),
    [sym_complement] = ACTIONS(311),
    [sym_term_complement] = ACTIONS(311),
    [sym_contains] = ACTIONS(311),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(313),
    [sym_ignore_inside] = ACTIONS(313),
    [sym_union] = ACTIONS(315),
    [sym_intersect] = ACTIONS(315),
    [sym_subtract] = ACTIONS(317),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(215),
    [anon_sym_COMMA_COMMA] = ACTIONS(75),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [183] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(183),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(327),
    [sym_intersect] = ACTIONS(327),
    [sym_subtract] = ACTIONS(329),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(331),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [184] = {
    [sym_expression] = STATE(173),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(184),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(107),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(109),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(109),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(109),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [anon_sym_COMMA_COMMA] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [185] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(185),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(327),
    [sym_intersect] = ACTIONS(327),
    [sym_subtract] = ACTIONS(329),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [186] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(186),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(71),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(327),
    [sym_intersect] = ACTIONS(327),
    [sym_subtract] = ACTIONS(329),
    [anon_sym__] = ACTIONS(73),
    [anon_sym_EQ_GT] = ACTIONS(71),
    [anon_sym_DASH_GT] = ACTIONS(73),
    [anon_sym_LT_DASH] = ACTIONS(71),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(71),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(71),
    [anon_sym_AT_DASH_GT] = ACTIONS(71),
    [anon_sym_DASH_GT_AT] = ACTIONS(71),
    [anon_sym_AT_GT] = ACTIONS(71),
    [anon_sym_GT_AT] = ACTIONS(71),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(71),
    [sym_compose] = ACTIONS(71),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [187] = {
    [sym_expression] = STATE(174),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(187),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(65),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(63),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(63),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(63),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [anon_sym_COMMA_COMMA] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [188] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(188),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [189] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(189),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [190] = {
    [sym_expression] = STATE(182),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(190),
    [anon_sym_LBRACK] = ACTIONS(69),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(69),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [anon_sym_COMMA_COMMA] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [191] = {
    [sym_expression] = STATE(181),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(307),
    [sym_single_replace] = STATE(307),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(404),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(191),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(111),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [anon_sym_COMMA_COMMA] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [192] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(192),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(337),
    [anon_sym_END] = ACTIONS(21),
  },
  [193] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(193),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(75),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(327),
    [sym_intersect] = ACTIONS(327),
    [sym_subtract] = ACTIONS(329),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [194] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(194),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [195] = {
    [sym_condition_operators] = STATE(432),
    [sym_end_comment] = STATE(195),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(341),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(339),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_RBRACK] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_END] = ACTIONS(21),
  },
  [196] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(196),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(31),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [197] = {
    [sym_condition_operators] = STATE(436),
    [sym_end_comment] = STATE(197),
    [aux_sym_parallel_replace_repeat1] = STATE(243),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(347),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [198] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(198),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(323),
    [sym_term_complement] = ACTIONS(323),
    [sym_contains] = ACTIONS(323),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(325),
    [sym_ignore_inside] = ACTIONS(325),
    [sym_union] = ACTIONS(327),
    [sym_intersect] = ACTIONS(327),
    [sym_subtract] = ACTIONS(329),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [199] = {
    [sym_expression] = STATE(188),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(498),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(199),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(15),
    [sym_colon] = ACTIONS(321),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [200] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(200),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(351),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [201] = {
    [sym_end_comment] = STATE(201),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(210),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(353),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [202] = {
    [sym_expression] = STATE(186),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(202),
    [anon_sym_LBRACK] = ACTIONS(65),
    [sym_symbol] = ACTIONS(65),
    [sym_string] = ACTIONS(63),
    [sym_any] = ACTIONS(63),
    [sym_zero] = ACTIONS(63),
    [sym_boundary] = ACTIONS(63),
    [sym_symbol_group] = ACTIONS(63),
    [anon_sym_LPAREN] = ACTIONS(65),
    [anon_sym_BQUOTE] = ACTIONS(63),
    [anon_sym_COMMA] = ACTIONS(63),
    [sym_colon] = ACTIONS(63),
    [sym_complement] = ACTIONS(63),
    [sym_term_complement] = ACTIONS(63),
    [sym_contains] = ACTIONS(63),
    [sym_plus] = ACTIONS(63),
    [sym_star] = ACTIONS(63),
    [sym_repeat] = ACTIONS(63),
    [sym_upper] = ACTIONS(63),
    [sym_lower] = ACTIONS(63),
    [sym_reverse] = ACTIONS(63),
    [sym_inverse] = ACTIONS(63),
    [sym_ignore] = ACTIONS(63),
    [sym_ignore_inside] = ACTIONS(63),
    [sym_union] = ACTIONS(63),
    [sym_intersect] = ACTIONS(63),
    [sym_subtract] = ACTIONS(65),
    [anon_sym__] = ACTIONS(65),
    [anon_sym_EQ_GT] = ACTIONS(63),
    [anon_sym_DASH_GT] = ACTIONS(65),
    [anon_sym_LT_DASH] = ACTIONS(63),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(63),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(63),
    [anon_sym_AT_DASH_GT] = ACTIONS(63),
    [anon_sym_DASH_GT_AT] = ACTIONS(63),
    [anon_sym_AT_GT] = ACTIONS(63),
    [anon_sym_GT_AT] = ACTIONS(63),
    [anon_sym_LBRACK_DOT] = ACTIONS(63),
    [sym_crossproduct] = ACTIONS(63),
    [sym_compose] = ACTIONS(63),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [203] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(203),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [204] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(204),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(365),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [205] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(205),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(77),
    [anon_sym_EQ_GT] = ACTIONS(75),
    [anon_sym_DASH_GT] = ACTIONS(77),
    [anon_sym_LT_DASH] = ACTIONS(75),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(75),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(75),
    [anon_sym_AT_DASH_GT] = ACTIONS(75),
    [anon_sym_DASH_GT_AT] = ACTIONS(75),
    [anon_sym_AT_GT] = ACTIONS(75),
    [anon_sym_GT_AT] = ACTIONS(75),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(75),
    [sym_compose] = ACTIONS(75),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [206] = {
    [sym_end_comment] = STATE(206),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(213),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(353),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [207] = {
    [sym_end_comment] = STATE(207),
    [aux_sym_context_list_repeat1] = STATE(207),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(371),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [208] = {
    [sym_end_comment] = STATE(208),
    [aux_sym_context_list_repeat1] = STATE(214),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
  [209] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(209),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(378),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [210] = {
    [sym_end_comment] = STATE(210),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(225),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(386),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [211] = {
    [sym_condition_operators] = STATE(436),
    [sym_end_comment] = STATE(211),
    [aux_sym_parallel_replace_repeat1] = STATE(283),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(388),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [212] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(212),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(390),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [213] = {
    [sym_end_comment] = STATE(213),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(225),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(353),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [214] = {
    [sym_end_comment] = STATE(214),
    [aux_sym_context_list_repeat1] = STATE(207),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(392),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [215] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(215),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(396),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(283),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(398),
    [sym_compose] = ACTIONS(398),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [216] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(216),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(400),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [217] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(217),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(402),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [218] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(218),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(404),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [219] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(219),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(15),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [220] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(220),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(15),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(15),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [221] = {
    [sym_condition_operators] = STATE(436),
    [sym_end_comment] = STATE(221),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [222] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(222),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(406),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [223] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(223),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [224] = {
    [sym_expression] = STATE(193),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(224),
    [anon_sym_LBRACK] = ACTIONS(69),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [anon_sym_COMMA] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [225] = {
    [sym_end_comment] = STATE(225),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(225),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_RBRACK] = ACTIONS(410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(412),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(408),
    [anon_sym_END] = ACTIONS(21),
  },
  [226] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(226),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(31),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(31),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [227] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(227),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(415),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [228] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(228),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(31),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [229] = {
    [sym_expression] = STATE(198),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(229),
    [anon_sym_LBRACK] = ACTIONS(107),
    [sym_symbol] = ACTIONS(107),
    [sym_string] = ACTIONS(109),
    [sym_any] = ACTIONS(109),
    [sym_zero] = ACTIONS(109),
    [sym_boundary] = ACTIONS(109),
    [sym_symbol_group] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(107),
    [anon_sym_BQUOTE] = ACTIONS(109),
    [anon_sym_COMMA] = ACTIONS(109),
    [sym_colon] = ACTIONS(109),
    [sym_complement] = ACTIONS(109),
    [sym_term_complement] = ACTIONS(109),
    [sym_contains] = ACTIONS(109),
    [sym_plus] = ACTIONS(109),
    [sym_star] = ACTIONS(109),
    [sym_repeat] = ACTIONS(109),
    [sym_upper] = ACTIONS(109),
    [sym_lower] = ACTIONS(109),
    [sym_reverse] = ACTIONS(109),
    [sym_inverse] = ACTIONS(109),
    [sym_ignore] = ACTIONS(109),
    [sym_ignore_inside] = ACTIONS(109),
    [sym_union] = ACTIONS(109),
    [sym_intersect] = ACTIONS(109),
    [sym_subtract] = ACTIONS(107),
    [anon_sym__] = ACTIONS(107),
    [anon_sym_EQ_GT] = ACTIONS(109),
    [anon_sym_DASH_GT] = ACTIONS(107),
    [anon_sym_LT_DASH] = ACTIONS(109),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(109),
    [anon_sym_AT_DASH_GT] = ACTIONS(109),
    [anon_sym_DASH_GT_AT] = ACTIONS(109),
    [anon_sym_AT_GT] = ACTIONS(109),
    [anon_sym_GT_AT] = ACTIONS(109),
    [anon_sym_LBRACK_DOT] = ACTIONS(109),
    [sym_crossproduct] = ACTIONS(109),
    [sym_compose] = ACTIONS(109),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [230] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(230),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [231] = {
    [sym_expression] = STATE(185),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(329),
    [sym_single_replace] = STATE(329),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(338),
    [sym_conditional_replace] = STATE(406),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(231),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [anon_sym_COMMA] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [232] = {
    [sym_condition_operators] = STATE(439),
    [sym_end_comment] = STATE(232),
    [aux_sym_parallel_replace_repeat1] = STATE(263),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(417),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [233] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(233),
    [anon_sym_LBRACK] = ACTIONS(231),
    [anon_sym_RBRACK] = ACTIONS(419),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [234] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(234),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [235] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(235),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(423),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [236] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(236),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [237] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(237),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(427),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [238] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(238),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(429),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [239] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(239),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(431),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [240] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(240),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(433),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [241] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(241),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(435),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [242] = {
    [sym_end_comment] = STATE(242),
    [aux_sym_parallel_replace_repeat1] = STATE(242),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(341),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(437),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_RBRACK] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_END] = ACTIONS(21),
  },
  [243] = {
    [sym_end_comment] = STATE(243),
    [aux_sym_parallel_replace_repeat1] = STATE(242),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(440),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_RBRACK] = ACTIONS(442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [anon_sym_COMMA_COMMA] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_END] = ACTIONS(21),
  },
  [244] = {
    [sym_condition_operators] = STATE(442),
    [sym_end_comment] = STATE(244),
    [aux_sym_parallel_replace_repeat1] = STATE(263),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(417),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [245] = {
    [sym_expression] = STATE(220),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_arrow] = STATE(490),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(245),
    [anon_sym_LBRACK] = ACTIONS(301),
    [sym_symbol] = ACTIONS(303),
    [sym_string] = ACTIONS(305),
    [sym_any] = ACTIONS(305),
    [sym_zero] = ACTIONS(305),
    [sym_boundary] = ACTIONS(305),
    [sym_symbol_group] = ACTIONS(305),
    [anon_sym_LPAREN] = ACTIONS(307),
    [anon_sym_BQUOTE] = ACTIONS(309),
    [sym_colon] = ACTIONS(355),
    [sym_complement] = ACTIONS(357),
    [sym_term_complement] = ACTIONS(357),
    [sym_contains] = ACTIONS(357),
    [sym_plus] = ACTIONS(299),
    [sym_star] = ACTIONS(299),
    [sym_repeat] = ACTIONS(299),
    [sym_upper] = ACTIONS(299),
    [sym_lower] = ACTIONS(299),
    [sym_reverse] = ACTIONS(299),
    [sym_inverse] = ACTIONS(299),
    [sym_ignore] = ACTIONS(359),
    [sym_ignore_inside] = ACTIONS(359),
    [sym_union] = ACTIONS(361),
    [sym_intersect] = ACTIONS(361),
    [sym_subtract] = ACTIONS(363),
    [anon_sym__] = ACTIONS(444),
    [anon_sym_EQ_GT] = ACTIONS(380),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(263),
    [sym_crossproduct] = ACTIONS(382),
    [sym_compose] = ACTIONS(382),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [246] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(246),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(446),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [247] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(247),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(448),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [248] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(248),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(450),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [249] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(249),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(452),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(283),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(398),
    [sym_compose] = ACTIONS(398),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [250] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(250),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(454),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [251] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(251),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(456),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(283),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(398),
    [sym_compose] = ACTIONS(398),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [252] = {
    [sym_expression] = STATE(153),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(480),
    [sym_simple_replace] = STATE(268),
    [sym_single_replace] = STATE(268),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(280),
    [sym_conditional_replace] = STATE(360),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(252),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [anon_sym_COMMA] = ACTIONS(458),
    [sym_colon] = ACTIONS(273),
    [sym_complement] = ACTIONS(275),
    [sym_term_complement] = ACTIONS(275),
    [sym_contains] = ACTIONS(275),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(277),
    [sym_ignore_inside] = ACTIONS(277),
    [sym_union] = ACTIONS(279),
    [sym_intersect] = ACTIONS(279),
    [sym_subtract] = ACTIONS(281),
    [anon_sym_EQ_GT] = ACTIONS(283),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(398),
    [sym_compose] = ACTIONS(398),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [253] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(253),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [anon_sym_DOT_RBRACK] = ACTIONS(460),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [254] = {
    [sym_end_comment] = STATE(254),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(379),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_RBRACK] = ACTIONS(410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(410),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(408),
    [anon_sym_END] = ACTIONS(21),
  },
  [255] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(473),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(255),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [256] = {
    [sym_condition_operators] = STATE(442),
    [sym_end_comment] = STATE(256),
    [aux_sym_parallel_replace_repeat1] = STATE(299),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [257] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(486),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(257),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [258] = {
    [sym_end_comment] = STATE(258),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(15),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [259] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(481),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(259),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [260] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(484),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(260),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [261] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(476),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(261),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [262] = {
    [sym_end_comment] = STATE(262),
    [aux_sym_parallel_replace_repeat1] = STATE(262),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(341),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(464),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_RBRACK] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_END] = ACTIONS(21),
  },
  [263] = {
    [sym_end_comment] = STATE(263),
    [aux_sym_parallel_replace_repeat1] = STATE(262),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(440),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_RBRACK] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [anon_sym_COMMA_COMMA] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_END] = ACTIONS(21),
  },
  [264] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(493),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(264),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [265] = {
    [sym_end_comment] = STATE(265),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [266] = {
    [sym_end_comment] = STATE(266),
    [aux_sym_context_list_repeat1] = STATE(266),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(467),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [267] = {
    [sym_expression] = STATE(203),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(267),
    [anon_sym_LBRACK] = ACTIONS(111),
    [sym_symbol] = ACTIONS(111),
    [sym_string] = ACTIONS(113),
    [sym_any] = ACTIONS(113),
    [sym_zero] = ACTIONS(113),
    [sym_boundary] = ACTIONS(113),
    [sym_symbol_group] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym_colon] = ACTIONS(113),
    [sym_complement] = ACTIONS(113),
    [sym_term_complement] = ACTIONS(113),
    [sym_contains] = ACTIONS(113),
    [sym_plus] = ACTIONS(113),
    [sym_star] = ACTIONS(113),
    [sym_repeat] = ACTIONS(113),
    [sym_upper] = ACTIONS(113),
    [sym_lower] = ACTIONS(113),
    [sym_reverse] = ACTIONS(113),
    [sym_inverse] = ACTIONS(113),
    [sym_ignore] = ACTIONS(113),
    [sym_ignore_inside] = ACTIONS(113),
    [sym_union] = ACTIONS(113),
    [sym_intersect] = ACTIONS(113),
    [sym_subtract] = ACTIONS(111),
    [anon_sym__] = ACTIONS(111),
    [anon_sym_EQ_GT] = ACTIONS(113),
    [anon_sym_DASH_GT] = ACTIONS(111),
    [anon_sym_LT_DASH] = ACTIONS(113),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(113),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(113),
    [anon_sym_AT_DASH_GT] = ACTIONS(113),
    [anon_sym_DASH_GT_AT] = ACTIONS(113),
    [anon_sym_AT_GT] = ACTIONS(113),
    [anon_sym_GT_AT] = ACTIONS(113),
    [anon_sym_LBRACK_DOT] = ACTIONS(113),
    [sym_crossproduct] = ACTIONS(113),
    [sym_compose] = ACTIONS(113),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [268] = {
    [sym_condition_operators] = STATE(439),
    [sym_end_comment] = STATE(268),
    [aux_sym_parallel_replace_repeat1] = STATE(299),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [269] = {
    [sym_end_comment] = STATE(269),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_RBRACK] = ACTIONS(472),
    [sym_symbol] = ACTIONS(470),
    [sym_string] = ACTIONS(472),
    [sym_any] = ACTIONS(472),
    [sym_zero] = ACTIONS(472),
    [sym_boundary] = ACTIONS(472),
    [sym_symbol_group] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(470),
    [sym_colon] = ACTIONS(472),
    [sym_complement] = ACTIONS(472),
    [sym_term_complement] = ACTIONS(470),
    [sym_contains] = ACTIONS(472),
    [sym_plus] = ACTIONS(472),
    [sym_star] = ACTIONS(472),
    [sym_repeat] = ACTIONS(472),
    [sym_upper] = ACTIONS(472),
    [sym_lower] = ACTIONS(472),
    [sym_reverse] = ACTIONS(472),
    [sym_inverse] = ACTIONS(472),
    [sym_ignore] = ACTIONS(470),
    [sym_ignore_inside] = ACTIONS(472),
    [sym_union] = ACTIONS(470),
    [sym_intersect] = ACTIONS(472),
    [sym_subtract] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(470),
    [anon_sym_LT_DASH] = ACTIONS(472),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(472),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(472),
    [anon_sym_AT_DASH_GT] = ACTIONS(472),
    [anon_sym_DASH_GT_AT] = ACTIONS(472),
    [anon_sym_AT_GT] = ACTIONS(472),
    [anon_sym_GT_AT] = ACTIONS(472),
    [anon_sym_LBRACK_DOT] = ACTIONS(472),
    [anon_sym_DOT_RBRACK] = ACTIONS(472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_SLASH_SLASH] = ACTIONS(472),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(472),
    [anon_sym_BSLASH_SLASH] = ACTIONS(472),
    [anon_sym_COMMA_COMMA] = ACTIONS(472),
    [sym_crossproduct] = ACTIONS(472),
    [sym_compose] = ACTIONS(472),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(470),
    [anon_sym_END] = ACTIONS(21),
  },
  [270] = {
    [sym_end_comment] = STATE(270),
    [anon_sym_LBRACK] = ACTIONS(474),
    [anon_sym_RBRACK] = ACTIONS(476),
    [sym_symbol] = ACTIONS(474),
    [sym_string] = ACTIONS(476),
    [sym_any] = ACTIONS(476),
    [sym_zero] = ACTIONS(476),
    [sym_boundary] = ACTIONS(476),
    [sym_symbol_group] = ACTIONS(476),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(476),
    [anon_sym_BQUOTE] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(474),
    [sym_colon] = ACTIONS(476),
    [sym_complement] = ACTIONS(476),
    [sym_term_complement] = ACTIONS(474),
    [sym_contains] = ACTIONS(476),
    [sym_plus] = ACTIONS(476),
    [sym_star] = ACTIONS(476),
    [sym_repeat] = ACTIONS(476),
    [sym_upper] = ACTIONS(476),
    [sym_lower] = ACTIONS(476),
    [sym_reverse] = ACTIONS(476),
    [sym_inverse] = ACTIONS(476),
    [sym_ignore] = ACTIONS(474),
    [sym_ignore_inside] = ACTIONS(476),
    [sym_union] = ACTIONS(474),
    [sym_intersect] = ACTIONS(476),
    [sym_subtract] = ACTIONS(474),
    [anon_sym_EQ_GT] = ACTIONS(476),
    [anon_sym_DASH_GT] = ACTIONS(474),
    [anon_sym_LT_DASH] = ACTIONS(476),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(476),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(476),
    [anon_sym_AT_DASH_GT] = ACTIONS(476),
    [anon_sym_DASH_GT_AT] = ACTIONS(476),
    [anon_sym_AT_GT] = ACTIONS(476),
    [anon_sym_GT_AT] = ACTIONS(476),
    [anon_sym_LBRACK_DOT] = ACTIONS(476),
    [anon_sym_DOT_RBRACK] = ACTIONS(476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(476),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_SLASH_SLASH] = ACTIONS(476),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(476),
    [anon_sym_BSLASH_SLASH] = ACTIONS(476),
    [anon_sym_COMMA_COMMA] = ACTIONS(476),
    [sym_crossproduct] = ACTIONS(476),
    [sym_compose] = ACTIONS(476),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_END] = ACTIONS(21),
  },
  [271] = {
    [sym_condition_operators] = STATE(432),
    [sym_end_comment] = STATE(271),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [272] = {
    [sym_end_comment] = STATE(272),
    [aux_sym_context_list_repeat1] = STATE(272),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(478),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [273] = {
    [sym_end_comment] = STATE(273),
    [anon_sym_LBRACK] = ACTIONS(29),
    [anon_sym_RBRACK] = ACTIONS(31),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_RPAREN] = ACTIONS(31),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_RBRACK] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(21),
  },
  [274] = {
    [sym_end_comment] = STATE(274),
    [anon_sym_LBRACK] = ACTIONS(481),
    [anon_sym_RBRACK] = ACTIONS(483),
    [sym_symbol] = ACTIONS(481),
    [sym_string] = ACTIONS(483),
    [sym_any] = ACTIONS(483),
    [sym_zero] = ACTIONS(483),
    [sym_boundary] = ACTIONS(483),
    [sym_symbol_group] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_RPAREN] = ACTIONS(483),
    [anon_sym_BQUOTE] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(481),
    [sym_colon] = ACTIONS(483),
    [sym_complement] = ACTIONS(483),
    [sym_term_complement] = ACTIONS(481),
    [sym_contains] = ACTIONS(483),
    [sym_plus] = ACTIONS(483),
    [sym_star] = ACTIONS(483),
    [sym_repeat] = ACTIONS(483),
    [sym_upper] = ACTIONS(483),
    [sym_lower] = ACTIONS(483),
    [sym_reverse] = ACTIONS(483),
    [sym_inverse] = ACTIONS(483),
    [sym_ignore] = ACTIONS(481),
    [sym_ignore_inside] = ACTIONS(483),
    [sym_union] = ACTIONS(481),
    [sym_intersect] = ACTIONS(483),
    [sym_subtract] = ACTIONS(481),
    [anon_sym_EQ_GT] = ACTIONS(483),
    [anon_sym_DASH_GT] = ACTIONS(481),
    [anon_sym_LT_DASH] = ACTIONS(483),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(483),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(483),
    [anon_sym_AT_DASH_GT] = ACTIONS(483),
    [anon_sym_DASH_GT_AT] = ACTIONS(483),
    [anon_sym_AT_GT] = ACTIONS(483),
    [anon_sym_GT_AT] = ACTIONS(483),
    [anon_sym_LBRACK_DOT] = ACTIONS(483),
    [anon_sym_DOT_RBRACK] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_SLASH_SLASH] = ACTIONS(483),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(483),
    [anon_sym_BSLASH_SLASH] = ACTIONS(483),
    [anon_sym_COMMA_COMMA] = ACTIONS(483),
    [sym_crossproduct] = ACTIONS(483),
    [sym_compose] = ACTIONS(483),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_END] = ACTIONS(21),
  },
  [275] = {
    [sym_end_comment] = STATE(275),
    [aux_sym_context_list_repeat1] = STATE(272),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(392),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [276] = {
    [sym_end_comment] = STATE(276),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [277] = {
    [sym_end_comment] = STATE(277),
    [aux_sym_context_list_repeat1] = STATE(266),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [278] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(494),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(278),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [279] = {
    [sym_end_comment] = STATE(279),
    [aux_sym_context_list_repeat1] = STATE(275),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
  [280] = {
    [sym_condition_operators] = STATE(439),
    [sym_end_comment] = STATE(280),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [281] = {
    [sym_condition_operators] = STATE(442),
    [sym_end_comment] = STATE(281),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [282] = {
    [sym_end_comment] = STATE(282),
    [anon_sym_LBRACK] = ACTIONS(13),
    [anon_sym_RBRACK] = ACTIONS(15),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(15),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(15),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_RBRACK] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_END] = ACTIONS(21),
  },
  [283] = {
    [sym_end_comment] = STATE(283),
    [aux_sym_parallel_replace_repeat1] = STATE(295),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(442),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_RBRACK] = ACTIONS(442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_END] = ACTIONS(21),
  },
  [284] = {
    [sym_end_comment] = STATE(284),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_RBRACK] = ACTIONS(487),
    [sym_symbol] = ACTIONS(485),
    [sym_string] = ACTIONS(487),
    [sym_any] = ACTIONS(487),
    [sym_zero] = ACTIONS(487),
    [sym_boundary] = ACTIONS(487),
    [sym_symbol_group] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RPAREN] = ACTIONS(487),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_COMMA] = ACTIONS(485),
    [sym_colon] = ACTIONS(487),
    [sym_complement] = ACTIONS(487),
    [sym_term_complement] = ACTIONS(485),
    [sym_contains] = ACTIONS(487),
    [sym_plus] = ACTIONS(487),
    [sym_star] = ACTIONS(487),
    [sym_repeat] = ACTIONS(487),
    [sym_upper] = ACTIONS(487),
    [sym_lower] = ACTIONS(487),
    [sym_reverse] = ACTIONS(487),
    [sym_inverse] = ACTIONS(487),
    [sym_ignore] = ACTIONS(485),
    [sym_ignore_inside] = ACTIONS(487),
    [sym_union] = ACTIONS(485),
    [sym_intersect] = ACTIONS(487),
    [sym_subtract] = ACTIONS(485),
    [anon_sym_EQ_GT] = ACTIONS(487),
    [anon_sym_DASH_GT] = ACTIONS(485),
    [anon_sym_LT_DASH] = ACTIONS(487),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(487),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(487),
    [anon_sym_AT_DASH_GT] = ACTIONS(487),
    [anon_sym_DASH_GT_AT] = ACTIONS(487),
    [anon_sym_AT_GT] = ACTIONS(487),
    [anon_sym_GT_AT] = ACTIONS(487),
    [anon_sym_LBRACK_DOT] = ACTIONS(487),
    [anon_sym_DOT_RBRACK] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(487),
    [anon_sym_PIPE_PIPE] = ACTIONS(487),
    [anon_sym_SLASH_SLASH] = ACTIONS(487),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(487),
    [anon_sym_BSLASH_SLASH] = ACTIONS(487),
    [anon_sym_COMMA_COMMA] = ACTIONS(487),
    [sym_crossproduct] = ACTIONS(487),
    [sym_compose] = ACTIONS(487),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(485),
    [anon_sym_END] = ACTIONS(21),
  },
  [285] = {
    [sym_expression] = STATE(163),
    [sym_optional] = STATE(387),
    [sym_substitute] = STATE(387),
    [sym_restrict] = STATE(387),
    [sym_arrow] = STATE(491),
    [sym_simple_replace] = STATE(271),
    [sym_single_replace] = STATE(271),
    [sym_mark] = STATE(387),
    [sym_parallel_replace] = STATE(305),
    [sym_conditional_replace] = STATE(390),
    [sym_parallel_conditional_replace] = STATE(387),
    [sym_end_comment] = STATE(285),
    [anon_sym_LBRACK] = ACTIONS(231),
    [sym_symbol] = ACTIONS(233),
    [sym_string] = ACTIONS(235),
    [sym_any] = ACTIONS(235),
    [sym_zero] = ACTIONS(235),
    [sym_boundary] = ACTIONS(235),
    [sym_symbol_group] = ACTIONS(235),
    [anon_sym_LPAREN] = ACTIONS(237),
    [anon_sym_BQUOTE] = ACTIONS(239),
    [sym_colon] = ACTIONS(285),
    [sym_complement] = ACTIONS(287),
    [sym_term_complement] = ACTIONS(287),
    [sym_contains] = ACTIONS(287),
    [sym_plus] = ACTIONS(245),
    [sym_star] = ACTIONS(245),
    [sym_repeat] = ACTIONS(245),
    [sym_upper] = ACTIONS(245),
    [sym_lower] = ACTIONS(245),
    [sym_reverse] = ACTIONS(245),
    [sym_inverse] = ACTIONS(245),
    [sym_ignore] = ACTIONS(289),
    [sym_ignore_inside] = ACTIONS(289),
    [sym_union] = ACTIONS(291),
    [sym_intersect] = ACTIONS(291),
    [sym_subtract] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(295),
    [anon_sym_DASH_GT] = ACTIONS(55),
    [anon_sym_LT_DASH] = ACTIONS(57),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(57),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(57),
    [anon_sym_AT_DASH_GT] = ACTIONS(57),
    [anon_sym_DASH_GT_AT] = ACTIONS(57),
    [anon_sym_AT_GT] = ACTIONS(57),
    [anon_sym_GT_AT] = ACTIONS(57),
    [anon_sym_LBRACK_DOT] = ACTIONS(151),
    [sym_crossproduct] = ACTIONS(335),
    [sym_compose] = ACTIONS(335),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [286] = {
    [sym_end_comment] = STATE(286),
    [anon_sym_LBRACK] = ACTIONS(489),
    [anon_sym_RBRACK] = ACTIONS(491),
    [sym_symbol] = ACTIONS(489),
    [sym_string] = ACTIONS(491),
    [sym_any] = ACTIONS(491),
    [sym_zero] = ACTIONS(491),
    [sym_boundary] = ACTIONS(491),
    [sym_symbol_group] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(489),
    [anon_sym_RPAREN] = ACTIONS(491),
    [anon_sym_BQUOTE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(489),
    [sym_colon] = ACTIONS(491),
    [sym_complement] = ACTIONS(491),
    [sym_term_complement] = ACTIONS(489),
    [sym_contains] = ACTIONS(491),
    [sym_plus] = ACTIONS(491),
    [sym_star] = ACTIONS(491),
    [sym_repeat] = ACTIONS(491),
    [sym_upper] = ACTIONS(491),
    [sym_lower] = ACTIONS(491),
    [sym_reverse] = ACTIONS(491),
    [sym_inverse] = ACTIONS(491),
    [sym_ignore] = ACTIONS(489),
    [sym_ignore_inside] = ACTIONS(491),
    [sym_union] = ACTIONS(489),
    [sym_intersect] = ACTIONS(491),
    [sym_subtract] = ACTIONS(489),
    [anon_sym_EQ_GT] = ACTIONS(491),
    [anon_sym_DASH_GT] = ACTIONS(489),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(491),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(491),
    [anon_sym_AT_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_AT] = ACTIONS(491),
    [anon_sym_AT_GT] = ACTIONS(491),
    [anon_sym_GT_AT] = ACTIONS(491),
    [anon_sym_LBRACK_DOT] = ACTIONS(491),
    [anon_sym_DOT_RBRACK] = ACTIONS(491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_SLASH_SLASH] = ACTIONS(491),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(491),
    [anon_sym_COMMA_COMMA] = ACTIONS(491),
    [sym_crossproduct] = ACTIONS(491),
    [sym_compose] = ACTIONS(491),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_END] = ACTIONS(21),
  },
  [287] = {
    [sym_expression] = STATE(205),
    [sym_optional] = STATE(427),
    [sym_substitute] = STATE(427),
    [sym_restrict] = STATE(427),
    [sym_simple_replace] = STATE(349),
    [sym_single_replace] = STATE(349),
    [sym_mark] = STATE(427),
    [sym_parallel_replace] = STATE(393),
    [sym_conditional_replace] = STATE(412),
    [sym_parallel_conditional_replace] = STATE(427),
    [sym_end_comment] = STATE(287),
    [anon_sym_LBRACK] = ACTIONS(69),
    [sym_symbol] = ACTIONS(69),
    [sym_string] = ACTIONS(67),
    [sym_any] = ACTIONS(67),
    [sym_zero] = ACTIONS(67),
    [sym_boundary] = ACTIONS(67),
    [sym_symbol_group] = ACTIONS(67),
    [anon_sym_LPAREN] = ACTIONS(69),
    [anon_sym_BQUOTE] = ACTIONS(67),
    [sym_colon] = ACTIONS(67),
    [sym_complement] = ACTIONS(67),
    [sym_term_complement] = ACTIONS(67),
    [sym_contains] = ACTIONS(67),
    [sym_plus] = ACTIONS(67),
    [sym_star] = ACTIONS(67),
    [sym_repeat] = ACTIONS(67),
    [sym_upper] = ACTIONS(67),
    [sym_lower] = ACTIONS(67),
    [sym_reverse] = ACTIONS(67),
    [sym_inverse] = ACTIONS(67),
    [sym_ignore] = ACTIONS(67),
    [sym_ignore_inside] = ACTIONS(67),
    [sym_union] = ACTIONS(67),
    [sym_intersect] = ACTIONS(67),
    [sym_subtract] = ACTIONS(69),
    [anon_sym__] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(67),
    [anon_sym_DASH_GT] = ACTIONS(69),
    [anon_sym_LT_DASH] = ACTIONS(67),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(67),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(67),
    [anon_sym_AT_DASH_GT] = ACTIONS(67),
    [anon_sym_DASH_GT_AT] = ACTIONS(67),
    [anon_sym_AT_GT] = ACTIONS(67),
    [anon_sym_GT_AT] = ACTIONS(67),
    [anon_sym_LBRACK_DOT] = ACTIONS(67),
    [sym_crossproduct] = ACTIONS(67),
    [sym_compose] = ACTIONS(67),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [288] = {
    [sym_end_comment] = STATE(288),
    [aux_sym_context_list_repeat1] = STATE(277),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(376),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
  [289] = {
    [sym_end_comment] = STATE(289),
    [anon_sym_LBRACK] = ACTIONS(493),
    [anon_sym_RBRACK] = ACTIONS(495),
    [sym_symbol] = ACTIONS(493),
    [sym_string] = ACTIONS(495),
    [sym_any] = ACTIONS(495),
    [sym_zero] = ACTIONS(495),
    [sym_boundary] = ACTIONS(495),
    [sym_symbol_group] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_RPAREN] = ACTIONS(495),
    [anon_sym_BQUOTE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(493),
    [sym_colon] = ACTIONS(495),
    [sym_complement] = ACTIONS(495),
    [sym_term_complement] = ACTIONS(493),
    [sym_contains] = ACTIONS(495),
    [sym_plus] = ACTIONS(495),
    [sym_star] = ACTIONS(495),
    [sym_repeat] = ACTIONS(495),
    [sym_upper] = ACTIONS(495),
    [sym_lower] = ACTIONS(495),
    [sym_reverse] = ACTIONS(495),
    [sym_inverse] = ACTIONS(495),
    [sym_ignore] = ACTIONS(493),
    [sym_ignore_inside] = ACTIONS(495),
    [sym_union] = ACTIONS(493),
    [sym_intersect] = ACTIONS(495),
    [sym_subtract] = ACTIONS(493),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_DASH_GT] = ACTIONS(493),
    [anon_sym_LT_DASH] = ACTIONS(495),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(495),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(495),
    [anon_sym_AT_DASH_GT] = ACTIONS(495),
    [anon_sym_DASH_GT_AT] = ACTIONS(495),
    [anon_sym_AT_GT] = ACTIONS(495),
    [anon_sym_GT_AT] = ACTIONS(495),
    [anon_sym_LBRACK_DOT] = ACTIONS(495),
    [anon_sym_DOT_RBRACK] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [anon_sym_SLASH_SLASH] = ACTIONS(495),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(495),
    [anon_sym_COMMA_COMMA] = ACTIONS(495),
    [sym_crossproduct] = ACTIONS(495),
    [sym_compose] = ACTIONS(495),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(493),
    [anon_sym_END] = ACTIONS(21),
  },
  [290] = {
    [sym_end_comment] = STATE(290),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(291),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(497),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [291] = {
    [sym_end_comment] = STATE(291),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(292),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(497),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [292] = {
    [sym_end_comment] = STATE(292),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(292),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_RBRACK] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(499),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(408),
    [anon_sym_END] = ACTIONS(21),
  },
  [293] = {
    [sym_end_comment] = STATE(293),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(292),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(386),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [294] = {
    [sym_end_comment] = STATE(294),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(293),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(497),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [295] = {
    [sym_end_comment] = STATE(295),
    [aux_sym_parallel_replace_repeat1] = STATE(295),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(341),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(502),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_RBRACK] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_END] = ACTIONS(21),
  },
  [296] = {
    [sym_end_comment] = STATE(296),
    [aux_sym_context_list_repeat1] = STATE(296),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(505),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [297] = {
    [sym_end_comment] = STATE(297),
    [aux_sym_context_list_repeat1] = STATE(296),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [298] = {
    [sym_end_comment] = STATE(298),
    [aux_sym_parallel_replace_repeat1] = STATE(302),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_RBRACK] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_END] = ACTIONS(21),
  },
  [299] = {
    [sym_end_comment] = STATE(299),
    [aux_sym_parallel_replace_repeat1] = STATE(302),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_RBRACK] = ACTIONS(442),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_RPAREN] = ACTIONS(442),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(442),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_RBRACK] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(440),
    [anon_sym_END] = ACTIONS(21),
  },
  [300] = {
    [sym_end_comment] = STATE(300),
    [aux_sym_context_list_repeat1] = STATE(297),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(376),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
  [301] = {
    [sym_condition_operators] = STATE(449),
    [sym_end_comment] = STATE(301),
    [aux_sym_parallel_replace_repeat1] = STATE(319),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(508),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [302] = {
    [sym_end_comment] = STATE(302),
    [aux_sym_parallel_replace_repeat1] = STATE(302),
    [anon_sym_LBRACK] = ACTIONS(339),
    [anon_sym_RBRACK] = ACTIONS(341),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(510),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_RBRACK] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(339),
    [anon_sym_END] = ACTIONS(21),
  },
  [303] = {
    [sym_condition_operators] = STATE(432),
    [sym_end_comment] = STATE(303),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(339),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(339),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [304] = {
    [sym_condition_operators] = STATE(449),
    [sym_end_comment] = STATE(304),
    [aux_sym_parallel_replace_repeat1] = STATE(326),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(513),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [305] = {
    [sym_condition_operators] = STATE(432),
    [sym_end_comment] = STATE(305),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [306] = {
    [sym_end_comment] = STATE(306),
    [aux_sym_context_list_repeat1] = STATE(317),
    [anon_sym_LBRACK] = ACTIONS(374),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym__] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [307] = {
    [sym_condition_operators] = STATE(429),
    [sym_end_comment] = STATE(307),
    [aux_sym_parallel_replace_repeat1] = STATE(348),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(515),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [308] = {
    [sym_end_comment] = STATE(308),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(379),
    [anon_sym_LBRACK] = ACTIONS(408),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym__] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(410),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [309] = {
    [sym_end_comment] = STATE(309),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(309),
    [anon_sym_LBRACK] = ACTIONS(408),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym__] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(517),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [310] = {
    [sym_end_comment] = STATE(310),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(312),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(520),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [311] = {
    [sym_end_comment] = STATE(311),
    [aux_sym_parallel_replace_repeat1] = STATE(311),
    [anon_sym_LBRACK] = ACTIONS(339),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(522),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [312] = {
    [sym_end_comment] = STATE(312),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(309),
    [anon_sym_LBRACK] = ACTIONS(384),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(386),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [313] = {
    [sym_condition_operators] = STATE(449),
    [sym_end_comment] = STATE(313),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [314] = {
    [sym_end_comment] = STATE(314),
    [aux_sym_context_list_repeat1] = STATE(314),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(525),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym__] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [315] = {
    [sym_condition_operators] = STATE(444),
    [sym_end_comment] = STATE(315),
    [aux_sym_parallel_replace_repeat1] = STATE(348),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(515),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [316] = {
    [sym_end_comment] = STATE(316),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(309),
    [anon_sym_LBRACK] = ACTIONS(384),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(520),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [317] = {
    [sym_end_comment] = STATE(317),
    [aux_sym_context_list_repeat1] = STATE(314),
    [anon_sym_LBRACK] = ACTIONS(392),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(392),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym__] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [318] = {
    [sym_end_comment] = STATE(318),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(316),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(520),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [319] = {
    [sym_end_comment] = STATE(319),
    [aux_sym_parallel_replace_repeat1] = STATE(311),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(440),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym__] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [anon_sym_COMMA_COMMA] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [320] = {
    [sym_end_comment] = STATE(320),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(320),
    [anon_sym_LBRACK] = ACTIONS(408),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(408),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(408),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(408),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym__] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_PIPE_PIPE] = ACTIONS(410),
    [anon_sym_SLASH_SLASH] = ACTIONS(410),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(410),
    [anon_sym_BSLASH_SLASH] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(528),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [321] = {
    [sym_end_comment] = STATE(321),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(320),
    [anon_sym_LBRACK] = ACTIONS(384),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(386),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [322] = {
    [sym_end_comment] = STATE(322),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [323] = {
    [sym_end_comment] = STATE(323),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(15),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [324] = {
    [sym_end_comment] = STATE(324),
    [anon_sym_LBRACK] = ACTIONS(489),
    [sym_symbol] = ACTIONS(489),
    [sym_string] = ACTIONS(491),
    [sym_any] = ACTIONS(491),
    [sym_zero] = ACTIONS(491),
    [sym_boundary] = ACTIONS(491),
    [sym_symbol_group] = ACTIONS(491),
    [anon_sym_LPAREN] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(489),
    [sym_colon] = ACTIONS(491),
    [sym_complement] = ACTIONS(491),
    [sym_term_complement] = ACTIONS(489),
    [sym_contains] = ACTIONS(491),
    [sym_plus] = ACTIONS(491),
    [sym_star] = ACTIONS(491),
    [sym_repeat] = ACTIONS(491),
    [sym_upper] = ACTIONS(491),
    [sym_lower] = ACTIONS(491),
    [sym_reverse] = ACTIONS(491),
    [sym_inverse] = ACTIONS(491),
    [sym_ignore] = ACTIONS(489),
    [sym_ignore_inside] = ACTIONS(491),
    [sym_union] = ACTIONS(489),
    [sym_intersect] = ACTIONS(491),
    [sym_subtract] = ACTIONS(489),
    [anon_sym__] = ACTIONS(489),
    [anon_sym_EQ_GT] = ACTIONS(491),
    [anon_sym_DASH_GT] = ACTIONS(489),
    [anon_sym_LT_DASH] = ACTIONS(491),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(491),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(491),
    [anon_sym_AT_DASH_GT] = ACTIONS(491),
    [anon_sym_DASH_GT_AT] = ACTIONS(491),
    [anon_sym_AT_GT] = ACTIONS(491),
    [anon_sym_GT_AT] = ACTIONS(491),
    [anon_sym_LBRACK_DOT] = ACTIONS(491),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(491),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_SLASH_SLASH] = ACTIONS(491),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(491),
    [anon_sym_BSLASH_SLASH] = ACTIONS(491),
    [anon_sym_COMMA_COMMA] = ACTIONS(491),
    [sym_crossproduct] = ACTIONS(491),
    [sym_compose] = ACTIONS(491),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [325] = {
    [sym_end_comment] = STATE(325),
    [anon_sym_LBRACK] = ACTIONS(13),
    [sym_symbol] = ACTIONS(13),
    [sym_string] = ACTIONS(15),
    [sym_any] = ACTIONS(15),
    [sym_zero] = ACTIONS(15),
    [sym_boundary] = ACTIONS(15),
    [sym_symbol_group] = ACTIONS(15),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(15),
    [anon_sym_COMMA] = ACTIONS(13),
    [sym_colon] = ACTIONS(15),
    [sym_complement] = ACTIONS(15),
    [sym_term_complement] = ACTIONS(13),
    [sym_contains] = ACTIONS(15),
    [sym_plus] = ACTIONS(15),
    [sym_star] = ACTIONS(15),
    [sym_repeat] = ACTIONS(15),
    [sym_upper] = ACTIONS(15),
    [sym_lower] = ACTIONS(15),
    [sym_reverse] = ACTIONS(15),
    [sym_inverse] = ACTIONS(15),
    [sym_ignore] = ACTIONS(13),
    [sym_ignore_inside] = ACTIONS(15),
    [sym_union] = ACTIONS(13),
    [sym_intersect] = ACTIONS(15),
    [sym_subtract] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_EQ_GT] = ACTIONS(15),
    [anon_sym_DASH_GT] = ACTIONS(13),
    [anon_sym_LT_DASH] = ACTIONS(15),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(15),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(15),
    [anon_sym_AT_DASH_GT] = ACTIONS(15),
    [anon_sym_DASH_GT_AT] = ACTIONS(15),
    [anon_sym_AT_GT] = ACTIONS(15),
    [anon_sym_GT_AT] = ACTIONS(15),
    [anon_sym_LBRACK_DOT] = ACTIONS(15),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15),
    [anon_sym_PIPE_PIPE] = ACTIONS(15),
    [anon_sym_SLASH_SLASH] = ACTIONS(15),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(15),
    [anon_sym_BSLASH_SLASH] = ACTIONS(15),
    [anon_sym_COMMA_COMMA] = ACTIONS(15),
    [sym_crossproduct] = ACTIONS(15),
    [sym_compose] = ACTIONS(15),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [326] = {
    [sym_end_comment] = STATE(326),
    [aux_sym_parallel_replace_repeat1] = STATE(345),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(442),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym__] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [327] = {
    [sym_end_comment] = STATE(327),
    [anon_sym_LBRACK] = ACTIONS(29),
    [sym_symbol] = ACTIONS(29),
    [sym_string] = ACTIONS(31),
    [sym_any] = ACTIONS(31),
    [sym_zero] = ACTIONS(31),
    [sym_boundary] = ACTIONS(31),
    [sym_symbol_group] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(29),
    [anon_sym_BQUOTE] = ACTIONS(31),
    [anon_sym_COMMA] = ACTIONS(29),
    [sym_colon] = ACTIONS(31),
    [sym_complement] = ACTIONS(31),
    [sym_term_complement] = ACTIONS(29),
    [sym_contains] = ACTIONS(31),
    [sym_plus] = ACTIONS(31),
    [sym_star] = ACTIONS(31),
    [sym_repeat] = ACTIONS(31),
    [sym_upper] = ACTIONS(31),
    [sym_lower] = ACTIONS(31),
    [sym_reverse] = ACTIONS(31),
    [sym_inverse] = ACTIONS(31),
    [sym_ignore] = ACTIONS(29),
    [sym_ignore_inside] = ACTIONS(31),
    [sym_union] = ACTIONS(29),
    [sym_intersect] = ACTIONS(31),
    [sym_subtract] = ACTIONS(29),
    [anon_sym__] = ACTIONS(29),
    [anon_sym_EQ_GT] = ACTIONS(31),
    [anon_sym_DASH_GT] = ACTIONS(29),
    [anon_sym_LT_DASH] = ACTIONS(31),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(31),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(31),
    [anon_sym_AT_DASH_GT] = ACTIONS(31),
    [anon_sym_DASH_GT_AT] = ACTIONS(31),
    [anon_sym_AT_GT] = ACTIONS(31),
    [anon_sym_GT_AT] = ACTIONS(31),
    [anon_sym_LBRACK_DOT] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(31),
    [anon_sym_PIPE_PIPE] = ACTIONS(31),
    [anon_sym_SLASH_SLASH] = ACTIONS(31),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(31),
    [anon_sym_BSLASH_SLASH] = ACTIONS(31),
    [anon_sym_COMMA_COMMA] = ACTIONS(31),
    [sym_crossproduct] = ACTIONS(31),
    [sym_compose] = ACTIONS(31),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [328] = {
    [sym_end_comment] = STATE(328),
    [anon_sym_LBRACK] = ACTIONS(481),
    [sym_symbol] = ACTIONS(481),
    [sym_string] = ACTIONS(483),
    [sym_any] = ACTIONS(483),
    [sym_zero] = ACTIONS(483),
    [sym_boundary] = ACTIONS(483),
    [sym_symbol_group] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(481),
    [anon_sym_BQUOTE] = ACTIONS(483),
    [anon_sym_COMMA] = ACTIONS(481),
    [sym_colon] = ACTIONS(483),
    [sym_complement] = ACTIONS(483),
    [sym_term_complement] = ACTIONS(481),
    [sym_contains] = ACTIONS(483),
    [sym_plus] = ACTIONS(483),
    [sym_star] = ACTIONS(483),
    [sym_repeat] = ACTIONS(483),
    [sym_upper] = ACTIONS(483),
    [sym_lower] = ACTIONS(483),
    [sym_reverse] = ACTIONS(483),
    [sym_inverse] = ACTIONS(483),
    [sym_ignore] = ACTIONS(481),
    [sym_ignore_inside] = ACTIONS(483),
    [sym_union] = ACTIONS(481),
    [sym_intersect] = ACTIONS(483),
    [sym_subtract] = ACTIONS(481),
    [anon_sym__] = ACTIONS(481),
    [anon_sym_EQ_GT] = ACTIONS(483),
    [anon_sym_DASH_GT] = ACTIONS(481),
    [anon_sym_LT_DASH] = ACTIONS(483),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(483),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(483),
    [anon_sym_AT_DASH_GT] = ACTIONS(483),
    [anon_sym_DASH_GT_AT] = ACTIONS(483),
    [anon_sym_AT_GT] = ACTIONS(483),
    [anon_sym_GT_AT] = ACTIONS(483),
    [anon_sym_LBRACK_DOT] = ACTIONS(483),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_SLASH_SLASH] = ACTIONS(483),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(483),
    [anon_sym_BSLASH_SLASH] = ACTIONS(483),
    [anon_sym_COMMA_COMMA] = ACTIONS(483),
    [sym_crossproduct] = ACTIONS(483),
    [sym_compose] = ACTIONS(483),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [329] = {
    [sym_condition_operators] = STATE(429),
    [sym_end_comment] = STATE(329),
    [aux_sym_parallel_replace_repeat1] = STATE(369),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(531),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [330] = {
    [sym_end_comment] = STATE(330),
    [anon_sym_LBRACK] = ACTIONS(485),
    [sym_symbol] = ACTIONS(485),
    [sym_string] = ACTIONS(487),
    [sym_any] = ACTIONS(487),
    [sym_zero] = ACTIONS(487),
    [sym_boundary] = ACTIONS(487),
    [sym_symbol_group] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [anon_sym_COMMA] = ACTIONS(485),
    [sym_colon] = ACTIONS(487),
    [sym_complement] = ACTIONS(487),
    [sym_term_complement] = ACTIONS(485),
    [sym_contains] = ACTIONS(487),
    [sym_plus] = ACTIONS(487),
    [sym_star] = ACTIONS(487),
    [sym_repeat] = ACTIONS(487),
    [sym_upper] = ACTIONS(487),
    [sym_lower] = ACTIONS(487),
    [sym_reverse] = ACTIONS(487),
    [sym_inverse] = ACTIONS(487),
    [sym_ignore] = ACTIONS(485),
    [sym_ignore_inside] = ACTIONS(487),
    [sym_union] = ACTIONS(485),
    [sym_intersect] = ACTIONS(487),
    [sym_subtract] = ACTIONS(485),
    [anon_sym__] = ACTIONS(485),
    [anon_sym_EQ_GT] = ACTIONS(487),
    [anon_sym_DASH_GT] = ACTIONS(485),
    [anon_sym_LT_DASH] = ACTIONS(487),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(487),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(487),
    [anon_sym_AT_DASH_GT] = ACTIONS(487),
    [anon_sym_DASH_GT_AT] = ACTIONS(487),
    [anon_sym_AT_GT] = ACTIONS(487),
    [anon_sym_GT_AT] = ACTIONS(487),
    [anon_sym_LBRACK_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(487),
    [anon_sym_PIPE_PIPE] = ACTIONS(487),
    [anon_sym_SLASH_SLASH] = ACTIONS(487),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(487),
    [anon_sym_BSLASH_SLASH] = ACTIONS(487),
    [anon_sym_COMMA_COMMA] = ACTIONS(487),
    [sym_crossproduct] = ACTIONS(487),
    [sym_compose] = ACTIONS(487),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [331] = {
    [sym_end_comment] = STATE(331),
    [anon_sym_LBRACK] = ACTIONS(493),
    [sym_symbol] = ACTIONS(493),
    [sym_string] = ACTIONS(495),
    [sym_any] = ACTIONS(495),
    [sym_zero] = ACTIONS(495),
    [sym_boundary] = ACTIONS(495),
    [sym_symbol_group] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_BQUOTE] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(493),
    [sym_colon] = ACTIONS(495),
    [sym_complement] = ACTIONS(495),
    [sym_term_complement] = ACTIONS(493),
    [sym_contains] = ACTIONS(495),
    [sym_plus] = ACTIONS(495),
    [sym_star] = ACTIONS(495),
    [sym_repeat] = ACTIONS(495),
    [sym_upper] = ACTIONS(495),
    [sym_lower] = ACTIONS(495),
    [sym_reverse] = ACTIONS(495),
    [sym_inverse] = ACTIONS(495),
    [sym_ignore] = ACTIONS(493),
    [sym_ignore_inside] = ACTIONS(495),
    [sym_union] = ACTIONS(493),
    [sym_intersect] = ACTIONS(495),
    [sym_subtract] = ACTIONS(493),
    [anon_sym__] = ACTIONS(493),
    [anon_sym_EQ_GT] = ACTIONS(495),
    [anon_sym_DASH_GT] = ACTIONS(493),
    [anon_sym_LT_DASH] = ACTIONS(495),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(495),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(495),
    [anon_sym_AT_DASH_GT] = ACTIONS(495),
    [anon_sym_DASH_GT_AT] = ACTIONS(495),
    [anon_sym_AT_GT] = ACTIONS(495),
    [anon_sym_GT_AT] = ACTIONS(495),
    [anon_sym_LBRACK_DOT] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(495),
    [anon_sym_PIPE_PIPE] = ACTIONS(495),
    [anon_sym_SLASH_SLASH] = ACTIONS(495),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(495),
    [anon_sym_BSLASH_SLASH] = ACTIONS(495),
    [anon_sym_COMMA_COMMA] = ACTIONS(495),
    [sym_crossproduct] = ACTIONS(495),
    [sym_compose] = ACTIONS(495),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [332] = {
    [sym_end_comment] = STATE(332),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(367),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym__] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [333] = {
    [sym_end_comment] = STATE(333),
    [aux_sym_context_list_repeat1] = STATE(333),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(533),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym__] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [334] = {
    [sym_end_comment] = STATE(334),
    [anon_sym_LBRACK] = ACTIONS(470),
    [sym_symbol] = ACTIONS(470),
    [sym_string] = ACTIONS(472),
    [sym_any] = ACTIONS(472),
    [sym_zero] = ACTIONS(472),
    [sym_boundary] = ACTIONS(472),
    [sym_symbol_group] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_COMMA] = ACTIONS(470),
    [sym_colon] = ACTIONS(472),
    [sym_complement] = ACTIONS(472),
    [sym_term_complement] = ACTIONS(470),
    [sym_contains] = ACTIONS(472),
    [sym_plus] = ACTIONS(472),
    [sym_star] = ACTIONS(472),
    [sym_repeat] = ACTIONS(472),
    [sym_upper] = ACTIONS(472),
    [sym_lower] = ACTIONS(472),
    [sym_reverse] = ACTIONS(472),
    [sym_inverse] = ACTIONS(472),
    [sym_ignore] = ACTIONS(470),
    [sym_ignore_inside] = ACTIONS(472),
    [sym_union] = ACTIONS(470),
    [sym_intersect] = ACTIONS(472),
    [sym_subtract] = ACTIONS(470),
    [anon_sym__] = ACTIONS(470),
    [anon_sym_EQ_GT] = ACTIONS(472),
    [anon_sym_DASH_GT] = ACTIONS(470),
    [anon_sym_LT_DASH] = ACTIONS(472),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(472),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(472),
    [anon_sym_AT_DASH_GT] = ACTIONS(472),
    [anon_sym_DASH_GT_AT] = ACTIONS(472),
    [anon_sym_AT_GT] = ACTIONS(472),
    [anon_sym_GT_AT] = ACTIONS(472),
    [anon_sym_LBRACK_DOT] = ACTIONS(472),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [anon_sym_SLASH_SLASH] = ACTIONS(472),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(472),
    [anon_sym_BSLASH_SLASH] = ACTIONS(472),
    [anon_sym_COMMA_COMMA] = ACTIONS(472),
    [sym_crossproduct] = ACTIONS(472),
    [sym_compose] = ACTIONS(472),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [335] = {
    [sym_end_comment] = STATE(335),
    [anon_sym_LBRACK] = ACTIONS(474),
    [sym_symbol] = ACTIONS(474),
    [sym_string] = ACTIONS(476),
    [sym_any] = ACTIONS(476),
    [sym_zero] = ACTIONS(476),
    [sym_boundary] = ACTIONS(476),
    [sym_symbol_group] = ACTIONS(476),
    [anon_sym_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(476),
    [anon_sym_COMMA] = ACTIONS(474),
    [sym_colon] = ACTIONS(476),
    [sym_complement] = ACTIONS(476),
    [sym_term_complement] = ACTIONS(474),
    [sym_contains] = ACTIONS(476),
    [sym_plus] = ACTIONS(476),
    [sym_star] = ACTIONS(476),
    [sym_repeat] = ACTIONS(476),
    [sym_upper] = ACTIONS(476),
    [sym_lower] = ACTIONS(476),
    [sym_reverse] = ACTIONS(476),
    [sym_inverse] = ACTIONS(476),
    [sym_ignore] = ACTIONS(474),
    [sym_ignore_inside] = ACTIONS(476),
    [sym_union] = ACTIONS(474),
    [sym_intersect] = ACTIONS(476),
    [sym_subtract] = ACTIONS(474),
    [anon_sym__] = ACTIONS(474),
    [anon_sym_EQ_GT] = ACTIONS(476),
    [anon_sym_DASH_GT] = ACTIONS(474),
    [anon_sym_LT_DASH] = ACTIONS(476),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(476),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(476),
    [anon_sym_AT_DASH_GT] = ACTIONS(476),
    [anon_sym_DASH_GT_AT] = ACTIONS(476),
    [anon_sym_AT_GT] = ACTIONS(476),
    [anon_sym_GT_AT] = ACTIONS(476),
    [anon_sym_LBRACK_DOT] = ACTIONS(476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(476),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_SLASH_SLASH] = ACTIONS(476),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(476),
    [anon_sym_BSLASH_SLASH] = ACTIONS(476),
    [anon_sym_COMMA_COMMA] = ACTIONS(476),
    [sym_crossproduct] = ACTIONS(476),
    [sym_compose] = ACTIONS(476),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [336] = {
    [sym_end_comment] = STATE(336),
    [aux_sym_context_list_repeat1] = STATE(337),
    [anon_sym_LBRACK] = ACTIONS(374),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(376),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym__] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [337] = {
    [sym_end_comment] = STATE(337),
    [aux_sym_context_list_repeat1] = STATE(333),
    [anon_sym_LBRACK] = ACTIONS(392),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym__] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [338] = {
    [sym_condition_operators] = STATE(429),
    [sym_end_comment] = STATE(338),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [339] = {
    [sym_end_comment] = STATE(339),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(321),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(536),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [340] = {
    [sym_condition_operators] = STATE(444),
    [sym_end_comment] = STATE(340),
    [aux_sym_parallel_replace_repeat1] = STATE(369),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(531),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [341] = {
    [sym_end_comment] = STATE(341),
    [aux_sym_context_list_repeat1] = STATE(341),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(538),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym__] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [342] = {
    [sym_end_comment] = STATE(342),
    [aux_sym_context_list_repeat1] = STATE(341),
    [anon_sym_LBRACK] = ACTIONS(392),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(392),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym__] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [343] = {
    [sym_condition_operators] = STATE(444),
    [sym_end_comment] = STATE(343),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [anon_sym_COMMA_COMMA] = ACTIONS(345),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [344] = {
    [sym_end_comment] = STATE(344),
    [aux_sym_context_list_repeat1] = STATE(342),
    [anon_sym_LBRACK] = ACTIONS(374),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym__] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [345] = {
    [sym_end_comment] = STATE(345),
    [aux_sym_parallel_replace_repeat1] = STATE(345),
    [anon_sym_LBRACK] = ACTIONS(339),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(541),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [346] = {
    [sym_end_comment] = STATE(346),
    [aux_sym_parallel_replace_repeat1] = STATE(346),
    [anon_sym_LBRACK] = ACTIONS(339),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(544),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [anon_sym_COMMA_COMMA] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [347] = {
    [sym_end_comment] = STATE(347),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(350),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(345),
    [anon_sym_BSLASH_SLASH] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(536),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [348] = {
    [sym_end_comment] = STATE(348),
    [aux_sym_parallel_replace_repeat1] = STATE(346),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(440),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym__] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [anon_sym_COMMA_COMMA] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [349] = {
    [sym_condition_operators] = STATE(448),
    [sym_end_comment] = STATE(349),
    [aux_sym_parallel_replace_repeat1] = STATE(366),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(531),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym__] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [350] = {
    [sym_end_comment] = STATE(350),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(320),
    [anon_sym_LBRACK] = ACTIONS(384),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(384),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(384),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(384),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym__] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_PIPE_PIPE] = ACTIONS(386),
    [anon_sym_SLASH_SLASH] = ACTIONS(386),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(386),
    [anon_sym_BSLASH_SLASH] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(536),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [351] = {
    [sym_end_comment] = STATE(351),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(379),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(410),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(410),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(410),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_RBRACK] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(410),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(408),
    [anon_sym_END] = ACTIONS(21),
  },
  [352] = {
    [sym_end_comment] = STATE(352),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(352),
    [anon_sym_LBRACK] = ACTIONS(408),
    [anon_sym_RBRACK] = ACTIONS(410),
    [sym_symbol] = ACTIONS(408),
    [sym_string] = ACTIONS(410),
    [sym_any] = ACTIONS(410),
    [sym_zero] = ACTIONS(410),
    [sym_boundary] = ACTIONS(410),
    [sym_symbol_group] = ACTIONS(410),
    [anon_sym_LPAREN] = ACTIONS(408),
    [anon_sym_RPAREN] = ACTIONS(410),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_COMMA] = ACTIONS(408),
    [sym_colon] = ACTIONS(410),
    [sym_complement] = ACTIONS(410),
    [sym_term_complement] = ACTIONS(410),
    [sym_contains] = ACTIONS(410),
    [sym_plus] = ACTIONS(410),
    [sym_star] = ACTIONS(410),
    [sym_repeat] = ACTIONS(410),
    [sym_upper] = ACTIONS(410),
    [sym_lower] = ACTIONS(410),
    [sym_reverse] = ACTIONS(410),
    [sym_inverse] = ACTIONS(410),
    [sym_ignore] = ACTIONS(410),
    [sym_ignore_inside] = ACTIONS(410),
    [sym_union] = ACTIONS(410),
    [sym_intersect] = ACTIONS(410),
    [sym_subtract] = ACTIONS(408),
    [anon_sym_EQ_GT] = ACTIONS(410),
    [anon_sym_DASH_GT] = ACTIONS(408),
    [anon_sym_LT_DASH] = ACTIONS(410),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(410),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(410),
    [anon_sym_AT_DASH_GT] = ACTIONS(410),
    [anon_sym_DASH_GT_AT] = ACTIONS(410),
    [anon_sym_AT_GT] = ACTIONS(410),
    [anon_sym_GT_AT] = ACTIONS(410),
    [anon_sym_LBRACK_DOT] = ACTIONS(410),
    [anon_sym_DOT_RBRACK] = ACTIONS(410),
    [anon_sym_COMMA_COMMA] = ACTIONS(547),
    [sym_crossproduct] = ACTIONS(410),
    [sym_compose] = ACTIONS(410),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(408),
    [anon_sym_END] = ACTIONS(21),
  },
  [353] = {
    [sym_end_comment] = STATE(353),
    [aux_sym_context_list_repeat1] = STATE(371),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(376),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(376),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(376),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
  [354] = {
    [sym_condition_operators] = STATE(448),
    [sym_end_comment] = STATE(354),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [355] = {
    [sym_end_comment] = STATE(355),
    [aux_sym_parallel_replace_repeat1] = STATE(355),
    [anon_sym_LBRACK] = ACTIONS(339),
    [sym_symbol] = ACTIONS(339),
    [sym_string] = ACTIONS(341),
    [sym_any] = ACTIONS(341),
    [sym_zero] = ACTIONS(341),
    [sym_boundary] = ACTIONS(341),
    [sym_symbol_group] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(339),
    [anon_sym_BQUOTE] = ACTIONS(341),
    [anon_sym_COMMA] = ACTIONS(550),
    [sym_colon] = ACTIONS(341),
    [sym_complement] = ACTIONS(341),
    [sym_term_complement] = ACTIONS(339),
    [sym_contains] = ACTIONS(341),
    [sym_plus] = ACTIONS(341),
    [sym_star] = ACTIONS(341),
    [sym_repeat] = ACTIONS(341),
    [sym_upper] = ACTIONS(341),
    [sym_lower] = ACTIONS(341),
    [sym_reverse] = ACTIONS(341),
    [sym_inverse] = ACTIONS(341),
    [sym_ignore] = ACTIONS(339),
    [sym_ignore_inside] = ACTIONS(341),
    [sym_union] = ACTIONS(339),
    [sym_intersect] = ACTIONS(341),
    [sym_subtract] = ACTIONS(339),
    [anon_sym__] = ACTIONS(339),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_DASH_GT] = ACTIONS(339),
    [anon_sym_LT_DASH] = ACTIONS(341),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(341),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(341),
    [anon_sym_AT_DASH_GT] = ACTIONS(341),
    [anon_sym_DASH_GT_AT] = ACTIONS(341),
    [anon_sym_AT_GT] = ACTIONS(341),
    [anon_sym_GT_AT] = ACTIONS(341),
    [anon_sym_LBRACK_DOT] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_SLASH_SLASH] = ACTIONS(341),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(341),
    [anon_sym_BSLASH_SLASH] = ACTIONS(341),
    [sym_crossproduct] = ACTIONS(341),
    [sym_compose] = ACTIONS(341),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [356] = {
    [sym_condition_operators] = STATE(436),
    [sym_end_comment] = STATE(356),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [357] = {
    [sym_end_comment] = STATE(357),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(363),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(345),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(345),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(345),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(553),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [358] = {
    [sym_condition_operators] = STATE(449),
    [sym_end_comment] = STATE(358),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [359] = {
    [sym_condition_operators] = STATE(429),
    [sym_end_comment] = STATE(359),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [360] = {
    [sym_end_comment] = STATE(360),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(373),
    [anon_sym_LBRACK] = ACTIONS(343),
    [anon_sym_RBRACK] = ACTIONS(345),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(343),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(345),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(345),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(345),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_DOT_RBRACK] = ACTIONS(345),
    [anon_sym_COMMA_COMMA] = ACTIONS(553),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_END] = ACTIONS(21),
  },
  [361] = {
    [sym_end_comment] = STATE(361),
    [aux_sym_context_list_repeat1] = STATE(361),
    [anon_sym_LBRACK] = ACTIONS(367),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(555),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(367),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(367),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(367),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym__] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_PIPE_PIPE] = ACTIONS(369),
    [anon_sym_SLASH_SLASH] = ACTIONS(369),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(369),
    [anon_sym_BSLASH_SLASH] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [362] = {
    [sym_end_comment] = STATE(362),
    [aux_sym_context_list_repeat1] = STATE(361),
    [anon_sym_LBRACK] = ACTIONS(392),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(394),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(392),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(392),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(392),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym__] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_PIPE_PIPE] = ACTIONS(394),
    [anon_sym_SLASH_SLASH] = ACTIONS(394),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(394),
    [anon_sym_BSLASH_SLASH] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [363] = {
    [sym_end_comment] = STATE(363),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(352),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(386),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(386),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(386),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(386),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [364] = {
    [sym_end_comment] = STATE(364),
    [aux_sym_context_list_repeat1] = STATE(365),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(558),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(394),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(394),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(394),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [365] = {
    [sym_end_comment] = STATE(365),
    [aux_sym_context_list_repeat1] = STATE(365),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(369),
    [sym_symbol] = ACTIONS(367),
    [sym_string] = ACTIONS(369),
    [sym_any] = ACTIONS(369),
    [sym_zero] = ACTIONS(369),
    [sym_boundary] = ACTIONS(369),
    [sym_symbol_group] = ACTIONS(369),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(369),
    [anon_sym_COMMA] = ACTIONS(560),
    [sym_colon] = ACTIONS(369),
    [sym_complement] = ACTIONS(369),
    [sym_term_complement] = ACTIONS(369),
    [sym_contains] = ACTIONS(369),
    [sym_plus] = ACTIONS(369),
    [sym_star] = ACTIONS(369),
    [sym_repeat] = ACTIONS(369),
    [sym_upper] = ACTIONS(369),
    [sym_lower] = ACTIONS(369),
    [sym_reverse] = ACTIONS(369),
    [sym_inverse] = ACTIONS(369),
    [sym_ignore] = ACTIONS(369),
    [sym_ignore_inside] = ACTIONS(369),
    [sym_union] = ACTIONS(369),
    [sym_intersect] = ACTIONS(369),
    [sym_subtract] = ACTIONS(367),
    [anon_sym_EQ_GT] = ACTIONS(369),
    [anon_sym_DASH_GT] = ACTIONS(367),
    [anon_sym_LT_DASH] = ACTIONS(369),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(369),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(369),
    [anon_sym_AT_DASH_GT] = ACTIONS(369),
    [anon_sym_DASH_GT_AT] = ACTIONS(369),
    [anon_sym_AT_GT] = ACTIONS(369),
    [anon_sym_GT_AT] = ACTIONS(369),
    [anon_sym_LBRACK_DOT] = ACTIONS(369),
    [anon_sym_DOT_RBRACK] = ACTIONS(369),
    [anon_sym_COMMA_COMMA] = ACTIONS(369),
    [sym_crossproduct] = ACTIONS(369),
    [sym_compose] = ACTIONS(369),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(367),
    [anon_sym_END] = ACTIONS(21),
  },
  [366] = {
    [sym_end_comment] = STATE(366),
    [aux_sym_parallel_replace_repeat1] = STATE(355),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(531),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym__] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [367] = {
    [sym_condition_operators] = STATE(442),
    [sym_end_comment] = STATE(367),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [368] = {
    [sym_condition_operators] = STATE(444),
    [sym_end_comment] = STATE(368),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [369] = {
    [sym_end_comment] = STATE(369),
    [aux_sym_parallel_replace_repeat1] = STATE(355),
    [anon_sym_LBRACK] = ACTIONS(440),
    [sym_symbol] = ACTIONS(440),
    [sym_string] = ACTIONS(442),
    [sym_any] = ACTIONS(442),
    [sym_zero] = ACTIONS(442),
    [sym_boundary] = ACTIONS(442),
    [sym_symbol_group] = ACTIONS(442),
    [anon_sym_LPAREN] = ACTIONS(440),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(442),
    [sym_colon] = ACTIONS(442),
    [sym_complement] = ACTIONS(442),
    [sym_term_complement] = ACTIONS(440),
    [sym_contains] = ACTIONS(442),
    [sym_plus] = ACTIONS(442),
    [sym_star] = ACTIONS(442),
    [sym_repeat] = ACTIONS(442),
    [sym_upper] = ACTIONS(442),
    [sym_lower] = ACTIONS(442),
    [sym_reverse] = ACTIONS(442),
    [sym_inverse] = ACTIONS(442),
    [sym_ignore] = ACTIONS(440),
    [sym_ignore_inside] = ACTIONS(442),
    [sym_union] = ACTIONS(440),
    [sym_intersect] = ACTIONS(442),
    [sym_subtract] = ACTIONS(440),
    [anon_sym__] = ACTIONS(440),
    [anon_sym_EQ_GT] = ACTIONS(442),
    [anon_sym_DASH_GT] = ACTIONS(440),
    [anon_sym_LT_DASH] = ACTIONS(442),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(442),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(442),
    [anon_sym_AT_DASH_GT] = ACTIONS(442),
    [anon_sym_DASH_GT_AT] = ACTIONS(442),
    [anon_sym_AT_GT] = ACTIONS(442),
    [anon_sym_GT_AT] = ACTIONS(442),
    [anon_sym_LBRACK_DOT] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_SLASH_SLASH] = ACTIONS(442),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(442),
    [anon_sym_BSLASH_SLASH] = ACTIONS(442),
    [sym_crossproduct] = ACTIONS(442),
    [sym_compose] = ACTIONS(442),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [370] = {
    [sym_end_comment] = STATE(370),
    [aux_sym_context_list_repeat1] = STATE(362),
    [anon_sym_LBRACK] = ACTIONS(374),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(376),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(374),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(374),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(374),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym__] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_PIPE_PIPE] = ACTIONS(376),
    [anon_sym_SLASH_SLASH] = ACTIONS(376),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(376),
    [anon_sym_BSLASH_SLASH] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [371] = {
    [sym_end_comment] = STATE(371),
    [aux_sym_context_list_repeat1] = STATE(365),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(394),
    [sym_symbol] = ACTIONS(392),
    [sym_string] = ACTIONS(394),
    [sym_any] = ACTIONS(394),
    [sym_zero] = ACTIONS(394),
    [sym_boundary] = ACTIONS(394),
    [sym_symbol_group] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_RPAREN] = ACTIONS(394),
    [anon_sym_BQUOTE] = ACTIONS(394),
    [anon_sym_COMMA] = ACTIONS(392),
    [sym_colon] = ACTIONS(394),
    [sym_complement] = ACTIONS(394),
    [sym_term_complement] = ACTIONS(394),
    [sym_contains] = ACTIONS(394),
    [sym_plus] = ACTIONS(394),
    [sym_star] = ACTIONS(394),
    [sym_repeat] = ACTIONS(394),
    [sym_upper] = ACTIONS(394),
    [sym_lower] = ACTIONS(394),
    [sym_reverse] = ACTIONS(394),
    [sym_inverse] = ACTIONS(394),
    [sym_ignore] = ACTIONS(394),
    [sym_ignore_inside] = ACTIONS(394),
    [sym_union] = ACTIONS(394),
    [sym_intersect] = ACTIONS(394),
    [sym_subtract] = ACTIONS(392),
    [anon_sym_EQ_GT] = ACTIONS(394),
    [anon_sym_DASH_GT] = ACTIONS(392),
    [anon_sym_LT_DASH] = ACTIONS(394),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(394),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(394),
    [anon_sym_AT_DASH_GT] = ACTIONS(394),
    [anon_sym_DASH_GT_AT] = ACTIONS(394),
    [anon_sym_AT_GT] = ACTIONS(394),
    [anon_sym_GT_AT] = ACTIONS(394),
    [anon_sym_LBRACK_DOT] = ACTIONS(394),
    [anon_sym_DOT_RBRACK] = ACTIONS(394),
    [anon_sym_COMMA_COMMA] = ACTIONS(394),
    [sym_crossproduct] = ACTIONS(394),
    [sym_compose] = ACTIONS(394),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(392),
    [anon_sym_END] = ACTIONS(21),
  },
  [372] = {
    [sym_condition_operators] = STATE(439),
    [sym_end_comment] = STATE(372),
    [aux_sym_parallel_replace_repeat1] = STATE(298),
    [anon_sym_LBRACK] = ACTIONS(343),
    [sym_symbol] = ACTIONS(343),
    [sym_string] = ACTIONS(345),
    [sym_any] = ACTIONS(345),
    [sym_zero] = ACTIONS(345),
    [sym_boundary] = ACTIONS(345),
    [sym_symbol_group] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(343),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(462),
    [sym_colon] = ACTIONS(345),
    [sym_complement] = ACTIONS(345),
    [sym_term_complement] = ACTIONS(343),
    [sym_contains] = ACTIONS(345),
    [sym_plus] = ACTIONS(345),
    [sym_star] = ACTIONS(345),
    [sym_repeat] = ACTIONS(345),
    [sym_upper] = ACTIONS(345),
    [sym_lower] = ACTIONS(345),
    [sym_reverse] = ACTIONS(345),
    [sym_inverse] = ACTIONS(345),
    [sym_ignore] = ACTIONS(343),
    [sym_ignore_inside] = ACTIONS(345),
    [sym_union] = ACTIONS(343),
    [sym_intersect] = ACTIONS(345),
    [sym_subtract] = ACTIONS(343),
    [anon_sym_EQ_GT] = ACTIONS(345),
    [anon_sym_DASH_GT] = ACTIONS(343),
    [anon_sym_LT_DASH] = ACTIONS(345),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(345),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(345),
    [anon_sym_AT_DASH_GT] = ACTIONS(345),
    [anon_sym_DASH_GT_AT] = ACTIONS(345),
    [anon_sym_AT_GT] = ACTIONS(345),
    [anon_sym_GT_AT] = ACTIONS(345),
    [anon_sym_LBRACK_DOT] = ACTIONS(345),
    [anon_sym_PIPE_PIPE] = ACTIONS(349),
    [anon_sym_SLASH_SLASH] = ACTIONS(349),
    [anon_sym_BSLASH_BSLASH] = ACTIONS(349),
    [anon_sym_BSLASH_SLASH] = ACTIONS(349),
    [sym_crossproduct] = ACTIONS(345),
    [sym_compose] = ACTIONS(345),
    [sym_comment] = ACTIONS(19),
    [anon_sym_END] = ACTIONS(21),
  },
  [373] = {
    [sym_end_comment] = STATE(373),
    [aux_sym_parallel_conditional_replace_repeat1] = STATE(352),
    [anon_sym_LBRACK] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(386),
    [sym_symbol] = ACTIONS(384),
    [sym_string] = ACTIONS(386),
    [sym_any] = ACTIONS(386),
    [sym_zero] = ACTIONS(386),
    [sym_boundary] = ACTIONS(386),
    [sym_symbol_group] = ACTIONS(386),
    [anon_sym_LPAREN] = ACTIONS(384),
    [anon_sym_RPAREN] = ACTIONS(386),
    [anon_sym_BQUOTE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(384),
    [sym_colon] = ACTIONS(386),
    [sym_complement] = ACTIONS(386),
    [sym_term_complement] = ACTIONS(386),
    [sym_contains] = ACTIONS(386),
    [sym_plus] = ACTIONS(386),
    [sym_star] = ACTIONS(386),
    [sym_repeat] = ACTIONS(386),
    [sym_upper] = ACTIONS(386),
    [sym_lower] = ACTIONS(386),
    [sym_reverse] = ACTIONS(386),
    [sym_inverse] = ACTIONS(386),
    [sym_ignore] = ACTIONS(386),
    [sym_ignore_inside] = ACTIONS(386),
    [sym_union] = ACTIONS(386),
    [sym_intersect] = ACTIONS(386),
    [sym_subtract] = ACTIONS(384),
    [anon_sym_EQ_GT] = ACTIONS(386),
    [anon_sym_DASH_GT] = ACTIONS(384),
    [anon_sym_LT_DASH] = ACTIONS(386),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(386),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(386),
    [anon_sym_AT_DASH_GT] = ACTIONS(386),
    [anon_sym_DASH_GT_AT] = ACTIONS(386),
    [anon_sym_AT_GT] = ACTIONS(386),
    [anon_sym_GT_AT] = ACTIONS(386),
    [anon_sym_LBRACK_DOT] = ACTIONS(386),
    [anon_sym_DOT_RBRACK] = ACTIONS(386),
    [anon_sym_COMMA_COMMA] = ACTIONS(553),
    [sym_crossproduct] = ACTIONS(386),
    [sym_compose] = ACTIONS(386),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(384),
    [anon_sym_END] = ACTIONS(21),
  },
  [374] = {
    [sym_end_comment] = STATE(374),
    [aux_sym_context_list_repeat1] = STATE(364),
    [anon_sym_LBRACK] = ACTIONS(374),
    [anon_sym_RBRACK] = ACTIONS(376),
    [sym_symbol] = ACTIONS(374),
    [sym_string] = ACTIONS(376),
    [sym_any] = ACTIONS(376),
    [sym_zero] = ACTIONS(376),
    [sym_boundary] = ACTIONS(376),
    [sym_symbol_group] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(374),
    [anon_sym_RPAREN] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(558),
    [sym_colon] = ACTIONS(376),
    [sym_complement] = ACTIONS(376),
    [sym_term_complement] = ACTIONS(376),
    [sym_contains] = ACTIONS(376),
    [sym_plus] = ACTIONS(376),
    [sym_star] = ACTIONS(376),
    [sym_repeat] = ACTIONS(376),
    [sym_upper] = ACTIONS(376),
    [sym_lower] = ACTIONS(376),
    [sym_reverse] = ACTIONS(376),
    [sym_inverse] = ACTIONS(376),
    [sym_ignore] = ACTIONS(376),
    [sym_ignore_inside] = ACTIONS(376),
    [sym_union] = ACTIONS(376),
    [sym_intersect] = ACTIONS(376),
    [sym_subtract] = ACTIONS(374),
    [anon_sym_EQ_GT] = ACTIONS(376),
    [anon_sym_DASH_GT] = ACTIONS(374),
    [anon_sym_LT_DASH] = ACTIONS(376),
    [anon_sym_LPAREN_DASH_GT_RPAREN] = ACTIONS(376),
    [anon_sym_LPAREN_LT_DASH_RPAREN] = ACTIONS(376),
    [anon_sym_AT_DASH_GT] = ACTIONS(376),
    [anon_sym_DASH_GT_AT] = ACTIONS(376),
    [anon_sym_AT_GT] = ACTIONS(376),
    [anon_sym_GT_AT] = ACTIONS(376),
    [anon_sym_LBRACK_DOT] = ACTIONS(376),
    [anon_sym_DOT_RBRACK] = ACTIONS(376),
    [anon_sym_COMMA_COMMA] = ACTIONS(376),
    [sym_crossproduct] = ACTIONS(376),
    [sym_compose] = ACTIONS(376),
    [sym_comment] = ACTIONS(19),
    [anon_sym_GT] = ACTIONS(374),
    [anon_sym_END] = ACTIONS(21),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(375), 1,
      sym_end_comment,
    ACTIONS(474), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(476), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [57] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(376), 1,
      sym_end_comment,
    STATE(381), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(392), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(394), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [116] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(377), 1,
      sym_end_comment,
    ACTIONS(29), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(31), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [173] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(378), 1,
      sym_end_comment,
    ACTIONS(367), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(369), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [230] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(563), 1,
      anon_sym_COMMA_COMMA,
    STATE(379), 1,
      sym_end_comment,
    STATE(380), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(384), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(386), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [291] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(565), 1,
      anon_sym_COMMA_COMMA,
    STATE(380), 2,
      sym_end_comment,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(408), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(410), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [350] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(568), 1,
      anon_sym_COMMA,
    STATE(381), 2,
      sym_end_comment,
      aux_sym_context_list_repeat1,
    ACTIONS(367), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(369), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [409] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(382), 1,
      sym_end_comment,
    ACTIONS(481), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(483), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [466] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(383), 1,
      sym_end_comment,
    ACTIONS(13), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(15), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [523] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(571), 1,
      anon_sym_COMMA,
    STATE(381), 1,
      aux_sym_context_list_repeat1,
    STATE(384), 1,
      sym_end_comment,
    ACTIONS(392), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(394), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [584] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(385), 1,
      sym_end_comment,
    ACTIONS(470), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(472), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [641] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(386), 1,
      sym_end_comment,
    ACTIONS(13), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(15), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [698] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(387), 1,
      sym_end_comment,
    ACTIONS(343), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(345), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [755] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(388), 1,
      sym_end_comment,
    ACTIONS(493), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(495), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [812] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(389), 1,
      sym_end_comment,
    ACTIONS(489), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(491), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [869] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(563), 1,
      anon_sym_COMMA_COMMA,
    STATE(379), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    STATE(390), 1,
      sym_end_comment,
    ACTIONS(343), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(345), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [930] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(571), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      aux_sym_context_list_repeat1,
    STATE(391), 1,
      sym_end_comment,
    ACTIONS(374), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(376), 35,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [991] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(392), 1,
      sym_end_comment,
    ACTIONS(485), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(487), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1048] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(393), 1,
      sym_end_comment,
    STATE(448), 1,
      sym_condition_operators,
    ACTIONS(349), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASH_SLASH,
    ACTIONS(343), 9,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_term_complement,
      sym_ignore,
      sym_union,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(345), 29,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore_inside,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1109] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(376), 1,
      aux_sym_context_list_repeat1,
    STATE(394), 1,
      sym_end_comment,
    ACTIONS(374), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym_DASH_GT,
      anon_sym_GT,
    ACTIONS(376), 36,
      anon_sym_RBRACK,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_RBRACK,
      sym_crossproduct,
      sym_compose,
  [1168] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(395), 1,
      sym_end_comment,
    STATE(448), 1,
      sym_condition_operators,
    ACTIONS(349), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASH_SLASH,
    ACTIONS(343), 8,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_term_complement,
      sym_ignore,
      sym_union,
      sym_subtract,
      anon_sym_DASH_GT,
    ACTIONS(345), 29,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore_inside,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1228] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(396), 1,
      sym_end_comment,
    STATE(449), 1,
      sym_condition_operators,
    ACTIONS(349), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASH_SLASH,
    ACTIONS(343), 8,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_term_complement,
      sym_ignore,
      sym_union,
      sym_subtract,
      anon_sym_DASH_GT,
    ACTIONS(345), 29,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore_inside,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1288] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(397), 1,
      sym_end_comment,
    STATE(429), 1,
      sym_condition_operators,
    ACTIONS(349), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASH_SLASH,
    ACTIONS(343), 8,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_term_complement,
      sym_ignore,
      sym_union,
      sym_subtract,
      anon_sym_DASH_GT,
    ACTIONS(345), 29,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore_inside,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1348] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(398), 1,
      sym_end_comment,
    STATE(444), 1,
      sym_condition_operators,
    ACTIONS(349), 4,
      anon_sym_PIPE_PIPE,
      anon_sym_SLASH_SLASH,
      anon_sym_BSLASH_BSLASH,
      anon_sym_BSLASH_SLASH,
    ACTIONS(343), 8,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_term_complement,
      sym_ignore,
      sym_union,
      sym_subtract,
      anon_sym_DASH_GT,
    ACTIONS(345), 29,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore_inside,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1408] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(573), 1,
      anon_sym_COMMA,
    STATE(399), 1,
      sym_end_comment,
    STATE(402), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(374), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(376), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1467] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(400), 1,
      sym_end_comment,
    STATE(408), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(384), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(386), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1524] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(401), 1,
      sym_end_comment,
    STATE(409), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(392), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(394), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1581] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(573), 1,
      anon_sym_COMMA,
    STATE(402), 1,
      sym_end_comment,
    STATE(409), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(392), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(394), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1640] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(379), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    STATE(403), 1,
      sym_end_comment,
    ACTIONS(408), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(410), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1697] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(575), 1,
      anon_sym_COMMA_COMMA,
    STATE(400), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    STATE(404), 1,
      sym_end_comment,
    ACTIONS(343), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(345), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1756] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(401), 1,
      aux_sym_context_list_repeat1,
    STATE(405), 1,
      sym_end_comment,
    ACTIONS(374), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(376), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [1813] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(575), 1,
      anon_sym_COMMA_COMMA,
    STATE(406), 1,
      sym_end_comment,
    STATE(407), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(343), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(345), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1872] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(575), 1,
      anon_sym_COMMA_COMMA,
    STATE(407), 1,
      sym_end_comment,
    STATE(408), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(384), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(386), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1931] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(577), 1,
      anon_sym_COMMA_COMMA,
    STATE(408), 2,
      sym_end_comment,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(408), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(410), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [1988] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(580), 1,
      anon_sym_COMMA,
    STATE(409), 2,
      sym_end_comment,
      aux_sym_context_list_repeat1,
    ACTIONS(367), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(369), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2045] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(410), 1,
      sym_end_comment,
    STATE(418), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(392), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(394), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2101] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(410), 1,
      aux_sym_context_list_repeat1,
    STATE(411), 1,
      sym_end_comment,
    ACTIONS(374), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(376), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      anon_sym_COMMA,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2157] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(583), 1,
      anon_sym_COMMA_COMMA,
    STATE(412), 1,
      sym_end_comment,
    STATE(424), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(343), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(345), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2215] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(413), 1,
      sym_end_comment,
    ACTIONS(13), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(15), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2269] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(414), 1,
      sym_end_comment,
    ACTIONS(29), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(31), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2323] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(585), 1,
      anon_sym_COMMA,
    STATE(415), 1,
      sym_end_comment,
    STATE(428), 1,
      aux_sym_context_list_repeat1,
    ACTIONS(374), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(376), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2381] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(416), 1,
      sym_end_comment,
    ACTIONS(481), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(483), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2435] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(417), 1,
      sym_end_comment,
    ACTIONS(367), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(369), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2489] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(587), 1,
      anon_sym_COMMA,
    STATE(418), 2,
      sym_end_comment,
      aux_sym_context_list_repeat1,
    ACTIONS(367), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(369), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2545] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(419), 1,
      sym_end_comment,
    ACTIONS(489), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(491), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2599] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(420), 1,
      sym_end_comment,
    ACTIONS(470), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(472), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2653] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(421), 1,
      sym_end_comment,
    ACTIONS(474), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(476), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2707] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(422), 1,
      sym_end_comment,
    ACTIONS(485), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(487), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2761] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(423), 1,
      sym_end_comment,
    ACTIONS(493), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(495), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2815] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(583), 1,
      anon_sym_COMMA_COMMA,
    STATE(424), 1,
      sym_end_comment,
    STATE(425), 1,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(384), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(386), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2873] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(590), 1,
      anon_sym_COMMA_COMMA,
    STATE(425), 2,
      sym_end_comment,
      aux_sym_parallel_conditional_replace_repeat1,
    ACTIONS(408), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(410), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [2929] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(426), 1,
      sym_end_comment,
    ACTIONS(13), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(15), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [2983] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(427), 1,
      sym_end_comment,
    ACTIONS(343), 7,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(345), 33,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      anon_sym_COMMA_COMMA,
      sym_crossproduct,
      sym_compose,
  [3037] = 7,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(585), 1,
      anon_sym_COMMA,
    STATE(418), 1,
      aux_sym_context_list_repeat1,
    STATE(428), 1,
      sym_end_comment,
    ACTIONS(392), 6,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym_LPAREN,
      sym_subtract,
      anon_sym__,
      anon_sym_DASH_GT,
    ACTIONS(394), 32,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_BQUOTE,
      sym_colon,
      sym_complement,
      sym_term_complement,
      sym_contains,
      sym_plus,
      sym_star,
      sym_repeat,
      sym_upper,
      sym_lower,
      sym_reverse,
      sym_inverse,
      sym_ignore,
      sym_ignore_inside,
      sym_union,
      sym_intersect,
      anon_sym_EQ_GT,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
      anon_sym_LBRACK_DOT,
      sym_crossproduct,
      sym_compose,
  [3095] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(595), 1,
      anon_sym__,
    STATE(222), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(405), 1,
      sym_context,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(423), 1,
      sym_context_list,
    STATE(429), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3161] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(595), 1,
      anon_sym__,
    STATE(222), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(405), 1,
      sym_context,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(422), 1,
      sym_context_list,
    STATE(430), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3227] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym__,
    STATE(237), 1,
      sym_expression,
    STATE(306), 1,
      sym_context,
    STATE(330), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(431), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3293] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(599), 1,
      anon_sym__,
    STATE(245), 1,
      sym_expression,
    STATE(374), 1,
      sym_context,
    STATE(388), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(432), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3359] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(601), 1,
      anon_sym_LBRACK,
    ACTIONS(604), 1,
      sym_symbol,
    ACTIONS(610), 1,
      anon_sym_LPAREN,
    ACTIONS(615), 1,
      anon_sym_BQUOTE,
    ACTIONS(621), 1,
      anon_sym_LBRACK_DOT,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    ACTIONS(613), 2,
      anon_sym_RPAREN,
      anon_sym_GT,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    STATE(433), 2,
      sym_end_comment,
      aux_sym_optional_repeat1,
    ACTIONS(618), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(607), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3421] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(624), 1,
      anon_sym__,
    STATE(209), 1,
      sym_expression,
    STATE(391), 1,
      sym_context,
    STATE(392), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(434), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3487] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(626), 1,
      anon_sym__,
    STATE(234), 1,
      sym_expression,
    STATE(284), 1,
      sym_context_list,
    STATE(288), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(435), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3553] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym__,
    STATE(208), 1,
      sym_context,
    STATE(235), 1,
      sym_expression,
    STATE(289), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(436), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3619] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym__,
    STATE(208), 1,
      sym_context,
    STATE(235), 1,
      sym_expression,
    STATE(284), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(437), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3685] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(624), 1,
      anon_sym__,
    STATE(209), 1,
      sym_expression,
    STATE(392), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(394), 1,
      sym_context,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(438), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3751] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(599), 1,
      anon_sym__,
    STATE(245), 1,
      sym_expression,
    STATE(353), 1,
      sym_context,
    STATE(388), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(439), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3817] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(599), 1,
      anon_sym__,
    STATE(245), 1,
      sym_expression,
    STATE(353), 1,
      sym_context,
    STATE(392), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(440), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3883] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(630), 1,
      anon_sym__,
    STATE(238), 1,
      sym_expression,
    STATE(284), 1,
      sym_context_list,
    STATE(300), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(441), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [3949] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym__,
    STATE(239), 1,
      sym_expression,
    STATE(279), 1,
      sym_context,
    STATE(289), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(442), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4015] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym__,
    STATE(217), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(415), 1,
      sym_context,
    STATE(422), 1,
      sym_context_list,
    STATE(443), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4081] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(636), 1,
      anon_sym__,
    STATE(241), 1,
      sym_expression,
    STATE(331), 1,
      sym_context_list,
    STATE(344), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(444), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4147] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(638), 1,
      anon_sym__,
    STATE(240), 1,
      sym_expression,
    STATE(330), 1,
      sym_context_list,
    STATE(370), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(445), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4213] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym__,
    STATE(239), 1,
      sym_expression,
    STATE(279), 1,
      sym_context,
    STATE(284), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(446), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4279] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(636), 1,
      anon_sym__,
    STATE(241), 1,
      sym_expression,
    STATE(330), 1,
      sym_context_list,
    STATE(344), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(447), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4345] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(595), 1,
      anon_sym__,
    STATE(222), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(399), 1,
      sym_context,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(423), 1,
      sym_context_list,
    STATE(448), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4411] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym__,
    STATE(237), 1,
      sym_expression,
    STATE(306), 1,
      sym_context,
    STATE(331), 1,
      sym_context_list,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(449), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4477] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(640), 1,
      anon_sym__,
    STATE(236), 1,
      sym_expression,
    STATE(330), 1,
      sym_context_list,
    STATE(336), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(450), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4543] = 18,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym__,
    STATE(217), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(411), 1,
      sym_context,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(422), 1,
      sym_context_list,
    STATE(451), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4609] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(644), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(433), 1,
      aux_sym_optional_repeat1,
    STATE(452), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4672] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(646), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(433), 1,
      aux_sym_optional_repeat1,
    STATE(453), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4735] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(597), 1,
      anon_sym__,
    STATE(237), 1,
      sym_expression,
    STATE(332), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(454), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4798] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      anon_sym__,
    STATE(217), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(417), 1,
      sym_context,
    STATE(455), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4861] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(648), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(452), 1,
      aux_sym_optional_repeat1,
    STATE(456), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4924] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(650), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(457), 1,
      sym_end_comment,
    STATE(460), 1,
      aux_sym_optional_repeat1,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [4987] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(630), 1,
      anon_sym__,
    STATE(238), 1,
      sym_expression,
    STATE(265), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(458), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5050] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(638), 1,
      anon_sym__,
    STATE(240), 1,
      sym_expression,
    STATE(332), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(459), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5113] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(652), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(433), 1,
      aux_sym_optional_repeat1,
    STATE(460), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5176] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(632), 1,
      anon_sym__,
    STATE(239), 1,
      sym_expression,
    STATE(265), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(461), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5239] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(624), 1,
      anon_sym__,
    STATE(209), 1,
      sym_expression,
    STATE(378), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(462), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5302] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(636), 1,
      anon_sym__,
    STATE(241), 1,
      sym_expression,
    STATE(332), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(463), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5365] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(599), 1,
      anon_sym__,
    STATE(245), 1,
      sym_expression,
    STATE(378), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(464), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5428] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(654), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(465), 1,
      sym_end_comment,
    STATE(472), 1,
      aux_sym_optional_repeat1,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5491] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(626), 1,
      anon_sym__,
    STATE(234), 1,
      sym_expression,
    STATE(265), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(466), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5554] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(628), 1,
      anon_sym__,
    STATE(235), 1,
      sym_expression,
    STATE(265), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(467), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5617] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(656), 1,
      anon_sym_GT,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(433), 1,
      aux_sym_optional_repeat1,
    STATE(468), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5680] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(640), 1,
      anon_sym__,
    STATE(236), 1,
      sym_expression,
    STATE(332), 1,
      sym_context,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(469), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5743] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(658), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(453), 1,
      aux_sym_optional_repeat1,
    STATE(470), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5806] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    ACTIONS(595), 1,
      anon_sym__,
    STATE(222), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(417), 1,
      sym_context,
    STATE(471), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5869] = 17,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(660), 1,
      anon_sym_RPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(433), 1,
      aux_sym_optional_repeat1,
    STATE(472), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5932] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(72), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(473), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [5992] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(192), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(468), 1,
      aux_sym_optional_repeat1,
    STATE(474), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6052] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(109), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(475), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6112] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(15), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(476), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6172] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(670), 1,
      anon_sym_RBRACK,
    STATE(212), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(477), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6232] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(14), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(478), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6292] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(674), 1,
      anon_sym_RBRACK,
    STATE(218), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(479), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6352] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(676), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(30), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(480), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6412] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(78), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(481), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6472] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(678), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(8), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(482), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6532] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(680), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(13), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(483), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6592] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(8), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(484), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6652] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(682), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(104), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(485), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6712] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(109), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(486), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6772] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(684), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(27), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(487), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6832] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(686), 1,
      anon_sym_RBRACK,
    STATE(233), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(488), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6892] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    ACTIONS(688), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(18), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(489), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [6952] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(690), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(106), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(490), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7012] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(99), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(491), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7072] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(692), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(64), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(492), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7132] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(27), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(493), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7192] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(664), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(29), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(494), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7252] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(694), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(72), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(495), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7312] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(696), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(77), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(496), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7372] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    ACTIONS(698), 1,
      anon_sym_RBRACK,
    STATE(216), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(497), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7432] = 16,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    ACTIONS(700), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(111), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(498), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7492] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(120), 1,
      sym_expression,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(347), 1,
      sym_conditional_replace,
    STATE(499), 1,
      sym_end_comment,
    STATE(340), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(259), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7549] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(6), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(500), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7606] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(230), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(501), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7663] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(502), 1,
      sym_end_comment,
    STATE(195), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7720] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(228), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(503), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7777] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(351), 1,
      sym_conditional_replace,
    STATE(504), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7834] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(132), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(357), 1,
      sym_conditional_replace,
    STATE(505), 1,
      sym_end_comment,
    STATE(232), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(243), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7891] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(43), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(294), 1,
      sym_conditional_replace,
    STATE(506), 1,
      sym_end_comment,
    STATE(244), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(125), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [7948] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(152), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(507), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8005] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(179), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(404), 1,
      sym_conditional_replace,
    STATE(508), 1,
      sym_end_comment,
    STATE(307), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(311), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8062] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(223), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(509), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8119] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(199), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(406), 1,
      sym_conditional_replace,
    STATE(510), 1,
      sym_end_comment,
    STATE(329), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(323), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8176] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(166), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(511), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8233] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(32), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(294), 1,
      sym_conditional_replace,
    STATE(512), 1,
      sym_end_comment,
    STATE(244), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(125), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8290] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(87), 1,
      sym_expression,
    STATE(339), 1,
      sym_conditional_replace,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(513), 1,
      sym_end_comment,
    STATE(315), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(211), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8347] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(215), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(514), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8404] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(308), 1,
      sym_conditional_replace,
    STATE(396), 1,
      sym_parallel_replace,
    STATE(515), 1,
      sym_end_comment,
    STATE(358), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8461] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(264), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(516), 1,
      sym_end_comment,
    STATE(195), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8518] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(351), 1,
      sym_conditional_replace,
    STATE(517), 1,
      sym_end_comment,
    STATE(372), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8575] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(2), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(518), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8632] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(261), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(519), 1,
      sym_end_comment,
    STATE(195), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8689] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(154), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(520), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8746] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(521), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8803] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(155), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(522), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8860] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(51), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(290), 1,
      sym_conditional_replace,
    STATE(523), 1,
      sym_end_comment,
    STATE(256), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(143), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8917] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(53), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(290), 1,
      sym_conditional_replace,
    STATE(524), 1,
      sym_end_comment,
    STATE(256), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(143), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [8974] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(54), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(290), 1,
      sym_conditional_replace,
    STATE(525), 1,
      sym_end_comment,
    STATE(256), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(143), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9031] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(55), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(290), 1,
      sym_conditional_replace,
    STATE(526), 1,
      sym_end_comment,
    STATE(256), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(143), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9088] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(156), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(527), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9145] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(142), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(528), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9202] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(169), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(529), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9259] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(117), 1,
      sym_expression,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(347), 1,
      sym_conditional_replace,
    STATE(530), 1,
      sym_end_comment,
    STATE(340), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(259), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9316] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(119), 1,
      sym_expression,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(347), 1,
      sym_conditional_replace,
    STATE(531), 1,
      sym_end_comment,
    STATE(340), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(259), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9373] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(23), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(532), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9430] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(121), 1,
      sym_expression,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(347), 1,
      sym_conditional_replace,
    STATE(533), 1,
      sym_end_comment,
    STATE(340), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(259), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9487] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(285), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(534), 1,
      sym_end_comment,
    STATE(303), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9544] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(112), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(535), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9601] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(395), 1,
      sym_parallel_replace,
    STATE(403), 1,
      sym_conditional_replace,
    STATE(536), 1,
      sym_end_comment,
    STATE(354), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9658] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(160), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(537), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9715] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(257), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(538), 1,
      sym_end_comment,
    STATE(303), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9772] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(397), 1,
      sym_parallel_replace,
    STATE(403), 1,
      sym_conditional_replace,
    STATE(539), 1,
      sym_end_comment,
    STATE(359), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9829] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(34), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(294), 1,
      sym_conditional_replace,
    STATE(540), 1,
      sym_end_comment,
    STATE(244), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(125), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9886] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(294), 1,
      sym_conditional_replace,
    STATE(541), 1,
      sym_end_comment,
    STATE(244), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(125), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [9943] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(294), 1,
      sym_conditional_replace,
    STATE(542), 1,
      sym_end_comment,
    STATE(244), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(125), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10000] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(49), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(290), 1,
      sym_conditional_replace,
    STATE(543), 1,
      sym_end_comment,
    STATE(256), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(143), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10057] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(66), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(544), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10114] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(101), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(545), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10171] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(134), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(357), 1,
      sym_conditional_replace,
    STATE(546), 1,
      sym_end_comment,
    STATE(232), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(243), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10228] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(83), 1,
      sym_expression,
    STATE(339), 1,
      sym_conditional_replace,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(547), 1,
      sym_end_comment,
    STATE(315), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(211), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10285] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(253), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(548), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10342] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(91), 1,
      sym_expression,
    STATE(339), 1,
      sym_conditional_replace,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(549), 1,
      sym_end_comment,
    STATE(315), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(211), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10399] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(127), 1,
      sym_expression,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(347), 1,
      sym_conditional_replace,
    STATE(550), 1,
      sym_end_comment,
    STATE(340), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(259), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10456] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(159), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(551), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10513] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(107), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(552), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10570] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(135), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(357), 1,
      sym_conditional_replace,
    STATE(553), 1,
      sym_end_comment,
    STATE(232), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(243), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10627] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(129), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(113), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(357), 1,
      sym_conditional_replace,
    STATE(554), 1,
      sym_end_comment,
    STATE(232), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(243), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10684] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(79), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(555), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10741] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(102), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(556), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10798] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(204), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(557), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10855] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(5), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(558), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10912] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(68), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(559), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [10969] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(260), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(560), 1,
      sym_end_comment,
    STATE(195), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11026] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(16), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(561), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11083] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(69), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(562), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11140] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(70), 1,
      sym_expression,
    STATE(310), 1,
      sym_conditional_replace,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(563), 1,
      sym_end_comment,
    STATE(301), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(167), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11197] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(47), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(4), 1,
      sym_expression,
    STATE(201), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(564), 1,
      sym_end_comment,
    STATE(197), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(43), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11254] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(254), 1,
      sym_conditional_replace,
    STATE(278), 1,
      sym_expression,
    STATE(565), 1,
      sym_end_comment,
    STATE(356), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11311] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(162), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(566), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11368] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(189), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(406), 1,
      sym_conditional_replace,
    STATE(567), 1,
      sym_end_comment,
    STATE(329), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(323), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11425] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(259), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(568), 1,
      sym_end_comment,
    STATE(303), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11482] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(194), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(406), 1,
      sym_conditional_replace,
    STATE(569), 1,
      sym_end_comment,
    STATE(329), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(323), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11539] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(181), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(255), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(570), 1,
      sym_end_comment,
    STATE(303), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11596] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(196), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(406), 1,
      sym_conditional_replace,
    STATE(571), 1,
      sym_end_comment,
    STATE(329), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(323), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11653] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(227), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(572), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11710] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(19), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(573), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11767] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(203), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(84), 1,
      sym_expression,
    STATE(313), 1,
      sym_parallel_replace,
    STATE(318), 1,
      sym_conditional_replace,
    STATE(574), 1,
      sym_end_comment,
    STATE(304), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(191), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11824] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(254), 1,
      sym_conditional_replace,
    STATE(278), 1,
      sym_expression,
    STATE(281), 1,
      sym_parallel_replace,
    STATE(575), 1,
      sym_end_comment,
    STATE(367), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11881] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(278), 1,
      sym_expression,
    STATE(308), 1,
      sym_conditional_replace,
    STATE(398), 1,
      sym_parallel_replace,
    STATE(576), 1,
      sym_end_comment,
    STATE(368), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11938] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(200), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(577), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [11995] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(100), 1,
      sym_expression,
    STATE(339), 1,
      sym_conditional_replace,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(578), 1,
      sym_end_comment,
    STATE(315), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(211), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12052] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(246), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(579), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12109] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(226), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(580), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12166] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(247), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(581), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12223] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(248), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(582), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12280] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(249), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(583), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12337] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(21), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(584), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12394] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(263), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(219), 1,
      sym_expression,
    STATE(393), 1,
      sym_parallel_replace,
    STATE(412), 1,
      sym_conditional_replace,
    STATE(585), 1,
      sym_end_comment,
    STATE(349), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(357), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12451] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(33), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      sym_symbol,
    ACTIONS(41), 1,
      anon_sym_BQUOTE,
    ACTIONS(103), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(668), 1,
      anon_sym_LPAREN,
    STATE(17), 1,
      sym_expression,
    STATE(206), 1,
      sym_conditional_replace,
    STATE(221), 1,
      sym_parallel_replace,
    STATE(586), 1,
      sym_end_comment,
    STATE(211), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(91), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(37), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(276), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12508] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(175), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(404), 1,
      sym_conditional_replace,
    STATE(587), 1,
      sym_end_comment,
    STATE(307), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(311), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12565] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(171), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(404), 1,
      sym_conditional_replace,
    STATE(588), 1,
      sym_end_comment,
    STATE(307), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(311), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12622] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(301), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      sym_symbol,
    ACTIONS(309), 1,
      anon_sym_BQUOTE,
    ACTIONS(593), 1,
      anon_sym_LPAREN,
    STATE(177), 1,
      sym_expression,
    STATE(338), 1,
      sym_parallel_replace,
    STATE(404), 1,
      sym_conditional_replace,
    STATE(589), 1,
      sym_end_comment,
    STATE(307), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(311), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(305), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(427), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12679] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(250), 1,
      sym_expression,
    STATE(305), 1,
      sym_parallel_replace,
    STATE(390), 1,
      sym_conditional_replace,
    STATE(590), 1,
      sym_end_comment,
    STATE(271), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(287), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12736] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(251), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(591), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12793] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(151), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(231), 1,
      anon_sym_LBRACK,
    ACTIONS(233), 1,
      sym_symbol,
    ACTIONS(239), 1,
      anon_sym_BQUOTE,
    ACTIONS(642), 1,
      anon_sym_LPAREN,
    STATE(252), 1,
      sym_expression,
    STATE(280), 1,
      sym_parallel_replace,
    STATE(360), 1,
      sym_conditional_replace,
    STATE(592), 1,
      sym_end_comment,
    STATE(268), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(275), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(235), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(387), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12850] = 15,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(155), 1,
      anon_sym_LBRACK,
    ACTIONS(157), 1,
      sym_symbol,
    ACTIONS(163), 1,
      anon_sym_BQUOTE,
    ACTIONS(215), 1,
      anon_sym_LBRACK_DOT,
    ACTIONS(662), 1,
      anon_sym_LPAREN,
    STATE(90), 1,
      sym_expression,
    STATE(339), 1,
      sym_conditional_replace,
    STATE(343), 1,
      sym_parallel_replace,
    STATE(593), 1,
      sym_end_comment,
    STATE(315), 2,
      sym_simple_replace,
      sym_single_replace,
    ACTIONS(211), 3,
      sym_complement,
      sym_term_complement,
      sym_contains,
    ACTIONS(159), 5,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
    STATE(322), 5,
      sym_optional,
      sym_substitute,
      sym_restrict,
      sym_mark,
      sym_parallel_conditional_replace,
  [12907] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(594), 1,
      sym_end_comment,
    ACTIONS(702), 2,
      anon_sym_LBRACK,
      sym_symbol,
    ACTIONS(704), 12,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      sym_complement,
      sym_term_complement,
      sym_contains,
      anon_sym_LBRACK_DOT,
      anon_sym_DOT_DOT_DOT,
  [12935] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(595), 1,
      sym_end_comment,
    ACTIONS(706), 3,
      anon_sym_LBRACK,
      sym_symbol,
      anon_sym__,
    ACTIONS(708), 11,
      sym_string,
      sym_any,
      sym_zero,
      sym_boundary,
      sym_symbol_group,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      sym_complement,
      sym_term_complement,
      sym_contains,
      anon_sym_LBRACK_DOT,
  [12963] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(710), 1,
      ts_builtin_sym_end,
    ACTIONS(712), 1,
      sym_colon,
    ACTIONS(714), 1,
      aux_sym_alphabet_symbol_token1,
    ACTIONS(718), 1,
      anon_sym_LT,
    STATE(596), 1,
      sym_end_comment,
    STATE(597), 1,
      aux_sym_lexicon_repeat1,
    STATE(615), 1,
      sym_lexicon_line,
    STATE(633), 1,
      sym_lexicon_string,
    STATE(644), 1,
      sym_lexicon_name,
    STATE(648), 1,
      sym_regex,
    ACTIONS(716), 2,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13004] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(720), 1,
      ts_builtin_sym_end,
    ACTIONS(722), 1,
      sym_colon,
    ACTIONS(725), 1,
      aux_sym_alphabet_symbol_token1,
    ACTIONS(730), 1,
      anon_sym_LT,
    STATE(615), 1,
      sym_lexicon_line,
    STATE(633), 1,
      sym_lexicon_string,
    STATE(644), 1,
      sym_lexicon_name,
    STATE(648), 1,
      sym_regex,
    ACTIONS(728), 2,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
    STATE(597), 2,
      sym_end_comment,
      aux_sym_lexicon_repeat1,
  [13043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(521), 1,
      sym_arrow,
    STATE(598), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13068] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(578), 1,
      sym_arrow,
    STATE(599), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(574), 1,
      sym_arrow,
    STATE(600), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13118] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(550), 1,
      sym_arrow,
    STATE(601), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(555), 1,
      sym_arrow,
    STATE(602), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(543), 1,
      sym_arrow,
    STATE(603), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13193] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(506), 1,
      sym_arrow,
    STATE(604), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(55), 1,
      anon_sym_DASH_GT,
    STATE(561), 1,
      sym_arrow,
    STATE(605), 1,
      sym_end_comment,
    ACTIONS(57), 7,
      anon_sym_LT_DASH,
      anon_sym_LPAREN_DASH_GT_RPAREN,
      anon_sym_LPAREN_LT_DASH_RPAREN,
      anon_sym_AT_DASH_GT,
      anon_sym_DASH_GT_AT,
      anon_sym_AT_GT,
      anon_sym_GT_AT,
  [13243] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(712), 1,
      sym_colon,
    ACTIONS(714), 1,
      aux_sym_alphabet_symbol_token1,
    ACTIONS(718), 1,
      anon_sym_LT,
    STATE(596), 1,
      aux_sym_lexicon_repeat1,
    STATE(606), 1,
      sym_end_comment,
    STATE(615), 1,
      sym_lexicon_line,
    STATE(633), 1,
      sym_lexicon_string,
    STATE(644), 1,
      sym_lexicon_name,
    STATE(648), 1,
      sym_regex,
  [13277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(607), 1,
      sym_end_comment,
    ACTIONS(733), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(735), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(608), 1,
      sym_end_comment,
    ACTIONS(737), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(739), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(609), 1,
      sym_end_comment,
    ACTIONS(741), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(743), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(610), 1,
      sym_end_comment,
    ACTIONS(745), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(747), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(611), 1,
      sym_end_comment,
    ACTIONS(749), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(751), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(612), 1,
      sym_end_comment,
    ACTIONS(753), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(755), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(613), 1,
      sym_end_comment,
    ACTIONS(757), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(759), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(761), 1,
      ts_builtin_sym_end,
    ACTIONS(763), 1,
      anon_sym_LEXICON,
    ACTIONS(766), 1,
      sym_lexicon_start_wrong_case,
    STATE(631), 1,
      sym_lexicon,
    STATE(659), 1,
      sym_lexicon_start,
    STATE(614), 2,
      sym_end_comment,
      aux_sym_source_file_repeat1,
  [13443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(615), 1,
      sym_end_comment,
    ACTIONS(769), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(771), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(616), 1,
      sym_end_comment,
    ACTIONS(773), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(775), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(617), 1,
      sym_end_comment,
    ACTIONS(777), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(779), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(618), 1,
      sym_end_comment,
    ACTIONS(781), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(783), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(9), 1,
      anon_sym_LEXICON,
    ACTIONS(11), 1,
      sym_lexicon_start_wrong_case,
    ACTIONS(785), 1,
      ts_builtin_sym_end,
    STATE(614), 1,
      aux_sym_source_file_repeat1,
    STATE(619), 1,
      sym_end_comment,
    STATE(631), 1,
      sym_lexicon,
    STATE(659), 1,
      sym_lexicon_start,
  [13551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(620), 1,
      sym_end_comment,
    ACTIONS(787), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(789), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13571] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(9), 1,
      anon_sym_LEXICON,
    ACTIONS(11), 1,
      sym_lexicon_start_wrong_case,
    ACTIONS(791), 1,
      ts_builtin_sym_end,
    STATE(614), 1,
      aux_sym_source_file_repeat1,
    STATE(621), 1,
      sym_end_comment,
    STATE(631), 1,
      sym_lexicon,
    STATE(659), 1,
      sym_lexicon_start,
  [13599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(622), 1,
      sym_end_comment,
    ACTIONS(793), 3,
      ts_builtin_sym_end,
      sym_colon,
      anon_sym_LT,
    ACTIONS(795), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13619] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(9), 1,
      anon_sym_LEXICON,
    ACTIONS(11), 1,
      sym_lexicon_start_wrong_case,
    STATE(619), 1,
      aux_sym_source_file_repeat1,
    STATE(623), 1,
      sym_end_comment,
    STATE(631), 1,
      sym_lexicon,
    STATE(659), 1,
      sym_lexicon_start,
  [13644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(797), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(624), 1,
      sym_end_comment,
    STATE(625), 1,
      aux_sym_multichar_symbols_repeat1,
    STATE(642), 1,
      sym_alphabet_symbol,
    ACTIONS(799), 2,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13667] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(801), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(642), 1,
      sym_alphabet_symbol,
    ACTIONS(804), 2,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
    STATE(625), 2,
      sym_end_comment,
      aux_sym_multichar_symbols_repeat1,
  [13688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(808), 1,
      sym_colon,
    ACTIONS(810), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(626), 1,
      sym_end_comment,
    ACTIONS(806), 2,
      sym_semicolon,
      sym_gloss,
  [13708] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(812), 1,
      anon_sym_RBRACK,
    ACTIONS(814), 1,
      sym_symbol,
    STATE(627), 1,
      sym_end_comment,
    STATE(635), 1,
      aux_sym_substitute_repeat1,
  [13727] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(714), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(628), 1,
      sym_end_comment,
    STATE(643), 1,
      sym_lexicon_string,
    STATE(649), 1,
      sym_lexicon_name,
  [13746] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(714), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(629), 1,
      sym_end_comment,
    STATE(652), 1,
      sym_lexicon_name,
    STATE(653), 1,
      sym_lexicon_string,
  [13765] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(816), 1,
      anon_sym_RBRACK,
    STATE(630), 1,
      sym_end_comment,
    STATE(632), 1,
      aux_sym_substitute_repeat1,
  [13784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    STATE(631), 1,
      sym_end_comment,
    ACTIONS(818), 3,
      ts_builtin_sym_end,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13799] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(820), 1,
      anon_sym_RBRACK,
    STATE(632), 1,
      sym_end_comment,
    STATE(640), 1,
      aux_sym_substitute_repeat1,
  [13818] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(822), 1,
      sym_colon,
    ACTIONS(824), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(633), 1,
      sym_end_comment,
    STATE(650), 1,
      sym_lexicon_name,
  [13837] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(826), 1,
      anon_sym_RBRACK,
    STATE(634), 1,
      sym_end_comment,
    STATE(637), 1,
      aux_sym_substitute_repeat1,
  [13856] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(828), 1,
      anon_sym_RBRACK,
    STATE(635), 1,
      sym_end_comment,
    STATE(640), 1,
      aux_sym_substitute_repeat1,
  [13875] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(830), 1,
      anon_sym_RBRACK,
    STATE(636), 1,
      sym_end_comment,
    STATE(640), 1,
      aux_sym_substitute_repeat1,
  [13894] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(832), 1,
      anon_sym_RBRACK,
    STATE(637), 1,
      sym_end_comment,
    STATE(640), 1,
      aux_sym_substitute_repeat1,
  [13913] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(797), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(624), 1,
      aux_sym_multichar_symbols_repeat1,
    STATE(638), 1,
      sym_end_comment,
    STATE(642), 1,
      sym_alphabet_symbol,
  [13932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(639), 1,
      sym_end_comment,
    ACTIONS(834), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13947] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(836), 1,
      anon_sym_RBRACK,
    ACTIONS(838), 1,
      sym_symbol,
    STATE(640), 2,
      sym_end_comment,
      aux_sym_substitute_repeat1,
  [13964] = 6,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(814), 1,
      sym_symbol,
    ACTIONS(841), 1,
      anon_sym_RBRACK,
    STATE(636), 1,
      aux_sym_substitute_repeat1,
    STATE(641), 1,
      sym_end_comment,
  [13983] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    STATE(642), 1,
      sym_end_comment,
    ACTIONS(843), 3,
      aux_sym_alphabet_symbol_token1,
      anon_sym_LEXICON,
      sym_lexicon_start_wrong_case,
  [13998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(824), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(643), 1,
      sym_end_comment,
    STATE(645), 1,
      sym_lexicon_name,
  [14014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(845), 1,
      sym_semicolon,
    ACTIONS(847), 1,
      sym_gloss,
    STATE(644), 1,
      sym_end_comment,
  [14030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(849), 1,
      sym_semicolon,
    ACTIONS(851), 1,
      sym_gloss,
    STATE(645), 1,
      sym_end_comment,
  [14046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    STATE(646), 1,
      sym_end_comment,
    ACTIONS(806), 2,
      sym_semicolon,
      sym_gloss,
  [14060] = 5,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(853), 1,
      anon_sym_RBRACK,
    ACTIONS(855), 1,
      sym_symbol,
    STATE(647), 1,
      sym_end_comment,
  [14076] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(824), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(648), 1,
      sym_end_comment,
    STATE(650), 1,
      sym_lexicon_name,
  [14092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(857), 1,
      sym_semicolon,
    ACTIONS(859), 1,
      sym_gloss,
    STATE(649), 1,
      sym_end_comment,
  [14108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(861), 1,
      sym_semicolon,
    ACTIONS(863), 1,
      sym_gloss,
    STATE(650), 1,
      sym_end_comment,
  [14124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(865), 1,
      sym_semicolon,
    ACTIONS(867), 1,
      sym_gloss,
    STATE(651), 1,
      sym_end_comment,
  [14140] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(869), 1,
      sym_semicolon,
    ACTIONS(871), 1,
      sym_gloss,
    STATE(652), 1,
      sym_end_comment,
  [14156] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(824), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(651), 1,
      sym_lexicon_name,
    STATE(653), 1,
      sym_end_comment,
  [14172] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(873), 1,
      aux_sym_end_comment_token1,
    STATE(654), 1,
      sym_end_comment,
  [14185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(875), 1,
      sym_semicolon,
    STATE(655), 1,
      sym_end_comment,
  [14198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(877), 1,
      anon_sym_COMMA,
    STATE(656), 1,
      sym_end_comment,
  [14211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(879), 1,
      anon_sym_LBRACK,
    STATE(657), 1,
      sym_end_comment,
  [14224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(881), 1,
      anon_sym_COMMA,
    STATE(658), 1,
      sym_end_comment,
  [14237] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(883), 1,
      aux_sym_lexicon_token1,
    STATE(659), 1,
      sym_end_comment,
  [14250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(885), 1,
      anon_sym_COMMA,
    STATE(660), 1,
      sym_end_comment,
  [14263] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(887), 1,
      sym_symbol,
    STATE(661), 1,
      sym_end_comment,
  [14276] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(889), 1,
      sym_symbol,
    STATE(662), 1,
      sym_end_comment,
  [14289] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(891), 1,
      sym_symbol,
    STATE(663), 1,
      sym_end_comment,
  [14302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(893), 1,
      ts_builtin_sym_end,
    STATE(664), 1,
      sym_end_comment,
  [14315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(895), 1,
      sym_semicolon,
    STATE(665), 1,
      sym_end_comment,
  [14328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(897), 1,
      sym_semicolon,
    STATE(666), 1,
      sym_end_comment,
  [14341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(899), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(667), 1,
      sym_end_comment,
  [14354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(901), 1,
      sym_semicolon,
    STATE(668), 1,
      sym_end_comment,
  [14367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(903), 1,
      sym_semicolon,
    STATE(669), 1,
      sym_end_comment,
  [14380] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(905), 1,
      sym_symbol,
    STATE(670), 1,
      sym_end_comment,
  [14393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(907), 1,
      sym_semicolon,
    STATE(671), 1,
      sym_end_comment,
  [14406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(909), 1,
      aux_sym_alphabet_symbol_token1,
    STATE(672), 1,
      sym_end_comment,
  [14419] = 4,
    ACTIONS(19), 1,
      sym_comment,
    ACTIONS(21), 1,
      anon_sym_END,
    ACTIONS(911), 1,
      aux_sym_lexicon_token1,
    STATE(673), 1,
      sym_end_comment,
  [14432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(913), 1,
      anon_sym_LBRACK,
    STATE(674), 1,
      sym_end_comment,
  [14445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(915), 1,
      anon_sym_COMMA,
    STATE(675), 1,
      sym_end_comment,
  [14458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(917), 1,
      anon_sym_LBRACK,
    STATE(676), 1,
      sym_end_comment,
  [14471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_END,
    ACTIONS(919), 1,
      anon_sym_LBRACK,
    STATE(677), 1,
      sym_end_comment,
  [14484] = 1,
    ACTIONS(921), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(375)] = 0,
  [SMALL_STATE(376)] = 57,
  [SMALL_STATE(377)] = 116,
  [SMALL_STATE(378)] = 173,
  [SMALL_STATE(379)] = 230,
  [SMALL_STATE(380)] = 291,
  [SMALL_STATE(381)] = 350,
  [SMALL_STATE(382)] = 409,
  [SMALL_STATE(383)] = 466,
  [SMALL_STATE(384)] = 523,
  [SMALL_STATE(385)] = 584,
  [SMALL_STATE(386)] = 641,
  [SMALL_STATE(387)] = 698,
  [SMALL_STATE(388)] = 755,
  [SMALL_STATE(389)] = 812,
  [SMALL_STATE(390)] = 869,
  [SMALL_STATE(391)] = 930,
  [SMALL_STATE(392)] = 991,
  [SMALL_STATE(393)] = 1048,
  [SMALL_STATE(394)] = 1109,
  [SMALL_STATE(395)] = 1168,
  [SMALL_STATE(396)] = 1228,
  [SMALL_STATE(397)] = 1288,
  [SMALL_STATE(398)] = 1348,
  [SMALL_STATE(399)] = 1408,
  [SMALL_STATE(400)] = 1467,
  [SMALL_STATE(401)] = 1524,
  [SMALL_STATE(402)] = 1581,
  [SMALL_STATE(403)] = 1640,
  [SMALL_STATE(404)] = 1697,
  [SMALL_STATE(405)] = 1756,
  [SMALL_STATE(406)] = 1813,
  [SMALL_STATE(407)] = 1872,
  [SMALL_STATE(408)] = 1931,
  [SMALL_STATE(409)] = 1988,
  [SMALL_STATE(410)] = 2045,
  [SMALL_STATE(411)] = 2101,
  [SMALL_STATE(412)] = 2157,
  [SMALL_STATE(413)] = 2215,
  [SMALL_STATE(414)] = 2269,
  [SMALL_STATE(415)] = 2323,
  [SMALL_STATE(416)] = 2381,
  [SMALL_STATE(417)] = 2435,
  [SMALL_STATE(418)] = 2489,
  [SMALL_STATE(419)] = 2545,
  [SMALL_STATE(420)] = 2599,
  [SMALL_STATE(421)] = 2653,
  [SMALL_STATE(422)] = 2707,
  [SMALL_STATE(423)] = 2761,
  [SMALL_STATE(424)] = 2815,
  [SMALL_STATE(425)] = 2873,
  [SMALL_STATE(426)] = 2929,
  [SMALL_STATE(427)] = 2983,
  [SMALL_STATE(428)] = 3037,
  [SMALL_STATE(429)] = 3095,
  [SMALL_STATE(430)] = 3161,
  [SMALL_STATE(431)] = 3227,
  [SMALL_STATE(432)] = 3293,
  [SMALL_STATE(433)] = 3359,
  [SMALL_STATE(434)] = 3421,
  [SMALL_STATE(435)] = 3487,
  [SMALL_STATE(436)] = 3553,
  [SMALL_STATE(437)] = 3619,
  [SMALL_STATE(438)] = 3685,
  [SMALL_STATE(439)] = 3751,
  [SMALL_STATE(440)] = 3817,
  [SMALL_STATE(441)] = 3883,
  [SMALL_STATE(442)] = 3949,
  [SMALL_STATE(443)] = 4015,
  [SMALL_STATE(444)] = 4081,
  [SMALL_STATE(445)] = 4147,
  [SMALL_STATE(446)] = 4213,
  [SMALL_STATE(447)] = 4279,
  [SMALL_STATE(448)] = 4345,
  [SMALL_STATE(449)] = 4411,
  [SMALL_STATE(450)] = 4477,
  [SMALL_STATE(451)] = 4543,
  [SMALL_STATE(452)] = 4609,
  [SMALL_STATE(453)] = 4672,
  [SMALL_STATE(454)] = 4735,
  [SMALL_STATE(455)] = 4798,
  [SMALL_STATE(456)] = 4861,
  [SMALL_STATE(457)] = 4924,
  [SMALL_STATE(458)] = 4987,
  [SMALL_STATE(459)] = 5050,
  [SMALL_STATE(460)] = 5113,
  [SMALL_STATE(461)] = 5176,
  [SMALL_STATE(462)] = 5239,
  [SMALL_STATE(463)] = 5302,
  [SMALL_STATE(464)] = 5365,
  [SMALL_STATE(465)] = 5428,
  [SMALL_STATE(466)] = 5491,
  [SMALL_STATE(467)] = 5554,
  [SMALL_STATE(468)] = 5617,
  [SMALL_STATE(469)] = 5680,
  [SMALL_STATE(470)] = 5743,
  [SMALL_STATE(471)] = 5806,
  [SMALL_STATE(472)] = 5869,
  [SMALL_STATE(473)] = 5932,
  [SMALL_STATE(474)] = 5992,
  [SMALL_STATE(475)] = 6052,
  [SMALL_STATE(476)] = 6112,
  [SMALL_STATE(477)] = 6172,
  [SMALL_STATE(478)] = 6232,
  [SMALL_STATE(479)] = 6292,
  [SMALL_STATE(480)] = 6352,
  [SMALL_STATE(481)] = 6412,
  [SMALL_STATE(482)] = 6472,
  [SMALL_STATE(483)] = 6532,
  [SMALL_STATE(484)] = 6592,
  [SMALL_STATE(485)] = 6652,
  [SMALL_STATE(486)] = 6712,
  [SMALL_STATE(487)] = 6772,
  [SMALL_STATE(488)] = 6832,
  [SMALL_STATE(489)] = 6892,
  [SMALL_STATE(490)] = 6952,
  [SMALL_STATE(491)] = 7012,
  [SMALL_STATE(492)] = 7072,
  [SMALL_STATE(493)] = 7132,
  [SMALL_STATE(494)] = 7192,
  [SMALL_STATE(495)] = 7252,
  [SMALL_STATE(496)] = 7312,
  [SMALL_STATE(497)] = 7372,
  [SMALL_STATE(498)] = 7432,
  [SMALL_STATE(499)] = 7492,
  [SMALL_STATE(500)] = 7549,
  [SMALL_STATE(501)] = 7606,
  [SMALL_STATE(502)] = 7663,
  [SMALL_STATE(503)] = 7720,
  [SMALL_STATE(504)] = 7777,
  [SMALL_STATE(505)] = 7834,
  [SMALL_STATE(506)] = 7891,
  [SMALL_STATE(507)] = 7948,
  [SMALL_STATE(508)] = 8005,
  [SMALL_STATE(509)] = 8062,
  [SMALL_STATE(510)] = 8119,
  [SMALL_STATE(511)] = 8176,
  [SMALL_STATE(512)] = 8233,
  [SMALL_STATE(513)] = 8290,
  [SMALL_STATE(514)] = 8347,
  [SMALL_STATE(515)] = 8404,
  [SMALL_STATE(516)] = 8461,
  [SMALL_STATE(517)] = 8518,
  [SMALL_STATE(518)] = 8575,
  [SMALL_STATE(519)] = 8632,
  [SMALL_STATE(520)] = 8689,
  [SMALL_STATE(521)] = 8746,
  [SMALL_STATE(522)] = 8803,
  [SMALL_STATE(523)] = 8860,
  [SMALL_STATE(524)] = 8917,
  [SMALL_STATE(525)] = 8974,
  [SMALL_STATE(526)] = 9031,
  [SMALL_STATE(527)] = 9088,
  [SMALL_STATE(528)] = 9145,
  [SMALL_STATE(529)] = 9202,
  [SMALL_STATE(530)] = 9259,
  [SMALL_STATE(531)] = 9316,
  [SMALL_STATE(532)] = 9373,
  [SMALL_STATE(533)] = 9430,
  [SMALL_STATE(534)] = 9487,
  [SMALL_STATE(535)] = 9544,
  [SMALL_STATE(536)] = 9601,
  [SMALL_STATE(537)] = 9658,
  [SMALL_STATE(538)] = 9715,
  [SMALL_STATE(539)] = 9772,
  [SMALL_STATE(540)] = 9829,
  [SMALL_STATE(541)] = 9886,
  [SMALL_STATE(542)] = 9943,
  [SMALL_STATE(543)] = 10000,
  [SMALL_STATE(544)] = 10057,
  [SMALL_STATE(545)] = 10114,
  [SMALL_STATE(546)] = 10171,
  [SMALL_STATE(547)] = 10228,
  [SMALL_STATE(548)] = 10285,
  [SMALL_STATE(549)] = 10342,
  [SMALL_STATE(550)] = 10399,
  [SMALL_STATE(551)] = 10456,
  [SMALL_STATE(552)] = 10513,
  [SMALL_STATE(553)] = 10570,
  [SMALL_STATE(554)] = 10627,
  [SMALL_STATE(555)] = 10684,
  [SMALL_STATE(556)] = 10741,
  [SMALL_STATE(557)] = 10798,
  [SMALL_STATE(558)] = 10855,
  [SMALL_STATE(559)] = 10912,
  [SMALL_STATE(560)] = 10969,
  [SMALL_STATE(561)] = 11026,
  [SMALL_STATE(562)] = 11083,
  [SMALL_STATE(563)] = 11140,
  [SMALL_STATE(564)] = 11197,
  [SMALL_STATE(565)] = 11254,
  [SMALL_STATE(566)] = 11311,
  [SMALL_STATE(567)] = 11368,
  [SMALL_STATE(568)] = 11425,
  [SMALL_STATE(569)] = 11482,
  [SMALL_STATE(570)] = 11539,
  [SMALL_STATE(571)] = 11596,
  [SMALL_STATE(572)] = 11653,
  [SMALL_STATE(573)] = 11710,
  [SMALL_STATE(574)] = 11767,
  [SMALL_STATE(575)] = 11824,
  [SMALL_STATE(576)] = 11881,
  [SMALL_STATE(577)] = 11938,
  [SMALL_STATE(578)] = 11995,
  [SMALL_STATE(579)] = 12052,
  [SMALL_STATE(580)] = 12109,
  [SMALL_STATE(581)] = 12166,
  [SMALL_STATE(582)] = 12223,
  [SMALL_STATE(583)] = 12280,
  [SMALL_STATE(584)] = 12337,
  [SMALL_STATE(585)] = 12394,
  [SMALL_STATE(586)] = 12451,
  [SMALL_STATE(587)] = 12508,
  [SMALL_STATE(588)] = 12565,
  [SMALL_STATE(589)] = 12622,
  [SMALL_STATE(590)] = 12679,
  [SMALL_STATE(591)] = 12736,
  [SMALL_STATE(592)] = 12793,
  [SMALL_STATE(593)] = 12850,
  [SMALL_STATE(594)] = 12907,
  [SMALL_STATE(595)] = 12935,
  [SMALL_STATE(596)] = 12963,
  [SMALL_STATE(597)] = 13004,
  [SMALL_STATE(598)] = 13043,
  [SMALL_STATE(599)] = 13068,
  [SMALL_STATE(600)] = 13093,
  [SMALL_STATE(601)] = 13118,
  [SMALL_STATE(602)] = 13143,
  [SMALL_STATE(603)] = 13168,
  [SMALL_STATE(604)] = 13193,
  [SMALL_STATE(605)] = 13218,
  [SMALL_STATE(606)] = 13243,
  [SMALL_STATE(607)] = 13277,
  [SMALL_STATE(608)] = 13297,
  [SMALL_STATE(609)] = 13317,
  [SMALL_STATE(610)] = 13337,
  [SMALL_STATE(611)] = 13357,
  [SMALL_STATE(612)] = 13377,
  [SMALL_STATE(613)] = 13397,
  [SMALL_STATE(614)] = 13417,
  [SMALL_STATE(615)] = 13443,
  [SMALL_STATE(616)] = 13463,
  [SMALL_STATE(617)] = 13483,
  [SMALL_STATE(618)] = 13503,
  [SMALL_STATE(619)] = 13523,
  [SMALL_STATE(620)] = 13551,
  [SMALL_STATE(621)] = 13571,
  [SMALL_STATE(622)] = 13599,
  [SMALL_STATE(623)] = 13619,
  [SMALL_STATE(624)] = 13644,
  [SMALL_STATE(625)] = 13667,
  [SMALL_STATE(626)] = 13688,
  [SMALL_STATE(627)] = 13708,
  [SMALL_STATE(628)] = 13727,
  [SMALL_STATE(629)] = 13746,
  [SMALL_STATE(630)] = 13765,
  [SMALL_STATE(631)] = 13784,
  [SMALL_STATE(632)] = 13799,
  [SMALL_STATE(633)] = 13818,
  [SMALL_STATE(634)] = 13837,
  [SMALL_STATE(635)] = 13856,
  [SMALL_STATE(636)] = 13875,
  [SMALL_STATE(637)] = 13894,
  [SMALL_STATE(638)] = 13913,
  [SMALL_STATE(639)] = 13932,
  [SMALL_STATE(640)] = 13947,
  [SMALL_STATE(641)] = 13964,
  [SMALL_STATE(642)] = 13983,
  [SMALL_STATE(643)] = 13998,
  [SMALL_STATE(644)] = 14014,
  [SMALL_STATE(645)] = 14030,
  [SMALL_STATE(646)] = 14046,
  [SMALL_STATE(647)] = 14060,
  [SMALL_STATE(648)] = 14076,
  [SMALL_STATE(649)] = 14092,
  [SMALL_STATE(650)] = 14108,
  [SMALL_STATE(651)] = 14124,
  [SMALL_STATE(652)] = 14140,
  [SMALL_STATE(653)] = 14156,
  [SMALL_STATE(654)] = 14172,
  [SMALL_STATE(655)] = 14185,
  [SMALL_STATE(656)] = 14198,
  [SMALL_STATE(657)] = 14211,
  [SMALL_STATE(658)] = 14224,
  [SMALL_STATE(659)] = 14237,
  [SMALL_STATE(660)] = 14250,
  [SMALL_STATE(661)] = 14263,
  [SMALL_STATE(662)] = 14276,
  [SMALL_STATE(663)] = 14289,
  [SMALL_STATE(664)] = 14302,
  [SMALL_STATE(665)] = 14315,
  [SMALL_STATE(666)] = 14328,
  [SMALL_STATE(667)] = 14341,
  [SMALL_STATE(668)] = 14354,
  [SMALL_STATE(669)] = 14367,
  [SMALL_STATE(670)] = 14380,
  [SMALL_STATE(671)] = 14393,
  [SMALL_STATE(672)] = 14406,
  [SMALL_STATE(673)] = 14419,
  [SMALL_STATE(674)] = 14432,
  [SMALL_STATE(675)] = 14445,
  [SMALL_STATE(676)] = 14458,
  [SMALL_STATE(677)] = 14471,
  [SMALL_STATE(678)] = 14484,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [13] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 2, 0, 0),
  [15] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 2, 0, 0),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [29] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 3, 0, 0),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 3, 0, 0),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_replace, 3, 0, 0),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_simple_replace, 3, 0, 0),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 2, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 2, 0, 0),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mark, 4, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mark, 4, 0, 0),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 3, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 3, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mark, 5, 0, 0),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mark, 5, 0, 0),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_replace, 5, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_replace, 5, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 1, 0, 0),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 1, 0, 0),
  [111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mark, 3, 0, 0),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mark, 3, 0, 0),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(552),
  [197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 1, 0, 0),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_optional_repeat1, 1, 0, 0),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0),
  [369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0),
  [371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(467),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context_list, 1, 0, 0),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context_list, 1, 0, 0),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parallel_conditional_replace, 2, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parallel_conditional_replace, 2, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context_list, 2, 0, 0),
  [394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context_list, 2, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(565),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(560),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parallel_replace, 2, 0, 0),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parallel_replace, 2, 0, 0),
  [444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(519),
  [467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(466),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitute, 7, 0, 0),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitute, 7, 0, 0),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_substitute, 8, 0, 0),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_substitute, 8, 0, 0),
  [478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(461),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 3, 0, 0),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 3, 0, 0),
  [485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_restrict, 3, 0, 0),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_restrict, 3, 0, 0),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional, 2, 0, 0),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional, 2, 0, 0),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_replace, 3, 0, 0),
  [495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_replace, 3, 0, 0),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(575),
  [502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(516),
  [505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(458),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(502),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(515),
  [520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [522] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(454),
  [528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(576),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(469),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(463),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(538),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(568),
  [547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(517),
  [550] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(534),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(459),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(464),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(504),
  [568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(462),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(539),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(471),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_context_list_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parallel_conditional_replace_repeat1, 2, 0, 0), SHIFT_REPEAT(536),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(497),
  [604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(387),
  [607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(387),
  [610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(465),
  [613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(657),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(551),
  [621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_optional_repeat1, 2, 0, 0), SHIFT_REPEAT(557),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow, 1, 0, 0),
  [704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow, 1, 0, 0),
  [706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_condition_operators, 1, 0, 0),
  [708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_condition_operators, 1, 0, 0),
  [710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon, 4, 0, 1),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(626),
  [716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon, 4, 0, 1),
  [718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lexicon_repeat1, 2, 0, 0),
  [722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lexicon_repeat1, 2, 0, 0), SHIFT_REPEAT(628),
  [725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_lexicon_repeat1, 2, 0, 0), SHIFT_REPEAT(626),
  [728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lexicon_repeat1, 2, 0, 0),
  [730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_lexicon_repeat1, 2, 0, 0), SHIFT_REPEAT(474),
  [733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 4, 10, 7),
  [735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 4, 10, 7),
  [737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 4, 10, 9),
  [739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 4, 10, 9),
  [741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 3, 10, 3),
  [743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 3, 10, 3),
  [745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 3, 0, 4),
  [747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 3, 0, 4),
  [749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 6, 10, 13),
  [751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 6, 10, 13),
  [753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 5, 10, 10),
  [755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 5, 10, 10),
  [757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 4, 10, 6),
  [759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 4, 10, 6),
  [761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(673),
  [766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(659),
  [769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_lexicon_repeat1, 1, 0, 0),
  [771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_lexicon_repeat1, 1, 0, 0),
  [773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 3, 10, 5),
  [775] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 3, 10, 5),
  [777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 5, 10, 12),
  [779] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 5, 10, 12),
  [781] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 5, 10, 11),
  [783] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 5, 10, 11),
  [785] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 2, 0, 0),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 2, 0, 2),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 2, 0, 2),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_line, 4, 10, 8),
  [795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_line, 4, 10, 8),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(639),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_multichar_symbols, 2, 0, 0),
  [801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_multichar_symbols_repeat1, 2, 0, 0), SHIFT_REPEAT(639),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multichar_symbols_repeat1, 2, 0, 0),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_name, 1, 0, 0),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_string, 1, 0, 0),
  [810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexicon_string, 1, 0, 0),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alphabet_symbol, 1, 0, 0),
  [836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_substitute_repeat1, 2, 0, 0),
  [838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_substitute_repeat1, 2, 0, 0), SHIFT_REPEAT(647),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_multichar_symbols_repeat1, 1, 0, 0),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_substitute_repeat1, 1, 0, 0),
  [855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_substitute_repeat1, 1, 0, 0),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(656),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(658),
  [893] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(660),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, 10, 0),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexicon_start, 1, 0, 0),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_end_comment, 2, 0, 0),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_lexc(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
